#ifndef _LIB_GD_25LQ64_INST_SET_TABLE_H
#define _LIB_GD_25LQ64_INST_SET_TABLE_H
#include "hx_drv_spi.h"

#define GD_25LQ64_CMD_NOP 0x00
#define GD_25LQ64_CMD_JEDEC_ID_READ 0x9F
#define GD_25LQ64_JEDEC_ID_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define GD_25LQ64_CMD_SINGLE_READ 0x03
#define GD_25LQ64_SINGLE_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define GD_25LQ64_CMD_FAST_SINGLE_READ 0x0B
#define GD_25LQ64_FAST_SINGLE_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT
#define GD_25LQ64_FAST_SINGLE_READ_INST_LEN SPI_INST_L8
#define GD_25LQ64_FAST_SINGLE_READ_ADDR_LEN SPI_ADDR_L24
#define GD_25LQ64_FAST_SINGLE_READ_TRANS_TYPE SPI_TRANSFER_TT0
#define GD_25LQ64_FAST_SINGLE_READ_WAIT_CYCLE 0x8

#define GD_25LQ64_CMD_SINGLE_WRITE 0x02
#define GD_25LQ64_SINGLE_WRITE_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define GD_25LQ64_CMD_ERASE_SECTOR_4K 0x20
#define GD_25LQ64_CMD_ERASE_SECTOR_32K 0x52
#define GD_25LQ64_CMD_ERASE_SECTOR_64K 0xD8
#define GD_25LQ64_ERASE_SECTOR_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define GD_25LQ64_CMD_ERASE_ALL 0x60
#define GD_25LQ64_ERASE_ALL_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define GD_25LQ64_CMD_STATUS1_READ 0x05
#define GD_25LQ64_CMD_STATUS2_READ 0x35
#define GD_25LQ64_CMD_STATUS_READ_COUNTS 1
#define GD_25LQ64_STATUS_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define GD_25LQ64_CMD_STATUS1_WRITE 0x01
#define GD_25LQ64_STATUS_WRITE_SPI_FRF SPI_FRF_SINGLE_FORMAT
#define GD_25LQ64_STATUS1_WRITE_COUNTS 2

#define GD_25LQ64_CMD_WRITE_ENABLE 0x06
#define GD_25LQ64_WRITE_ENABLE_SPI_FRF SPI_FRF_SINGLE_FORMAT
#define GD_25LQ64_CMD_WRITE_DISABLE 0x04

#define GD_25LQ64_WIP_POS 0
#define GD_25LQ64_WIP_MASK 0x1

#define GD_25LQ64_QUAD_ENABLE_POS 1
#define GD_25LQ64_QUAD_ENABLE_MASK 0x2
#define GD_25LQ64_CMD_QUAD_ENABLE_WRITE GD_25LQ64_CMD_STATUS1_WRITE
#define GD_25LQ64_QUAD_ENABLE_WRITE_COUNTS 2

#define GD_25LQ64_PROTECT_MASK 0xFC
#define GD_25LQ64_PROTECT2_MASK 0x79
#define GD_25LQ64_PERTECT_EN_MASK 0x03

#define GD_25LQ64_CMD_DUAL_RDAD_FAST 0xBB
#define GD_25LQ64_DUAL_RDAD_FAST_SPI_FRF SPI_FRF_DUAL_FORMAT
#define GD_25LQ64_DUAL_RDAD_FAST_INST_LEN SPI_INST_L8
#define GD_25LQ64_DUAL_RDAD_FAST_ADDR_LEN SPI_ADDR_L24
#define GD_25LQ64_DUAL_RDAD_FAST_TRANS_TYPE SPI_TRANSFER_TT1
#define GD_25LQ64_DUAL_RDAD_FAST_WAIT_CYCLE 0x4

#define GD_25LQ64_CMD_DUAL_RDAD_SINGLE_ADDR 0x3B
#define GD_25LQ64_DUAL_RDAD_SINGLE_ADDR_SPI_FRF SPI_FRF_DUAL_FORMAT
#define GD_25LQ64_DUAL_RDAD_SINGLE_ADDR_INST_LEN SPI_INST_L8
#define GD_25LQ64_DUAL_RDAD_SINGLE_ADDR_ADDR_LEN SPI_ADDR_L24
#define GD_25LQ64_DUAL_RDAD_SINGLE_ADDR_TRANS_TYPE SPI_TRANSFER_TT0
#define GD_25LQ64_DUAL_RDAD_SINGLE_ADDR_WAIT_CYCLE 0x8

#define GD_25LQ64_CMD_QUAD_RDAD 0x6B
#define GD_25LQ64_QUAD_RDAD_SPI_FRF SPI_FRF_QUAD_FORMAT
#define GD_25LQ64_QUAD_RDAD_INST_LEN SPI_INST_L8
#define GD_25LQ64_QUAD_RDAD_ADDR_LEN SPI_ADDR_L24
#define GD_25LQ64_QUAD_RDAD_TRANS_TYPE SPI_TRANSFER_TT0
#define GD_25LQ64_QUAD_RDAD_WAIT_CYCLE 0x8

#define GD_25LQ64_CMD_QUAD_WRITE 0x32
#define GD_25LQ64_QUAD_WRITE_SPI_FRF SPI_FRF_QUAD_FORMAT
#define GD_25LQ64_QUAD_WRITE_INST_LEN SPI_INST_L8
#define GD_25LQ64_QUAD_WRITE_ADDR_LEN SPI_ADDR_L24
#define GD_25LQ64_QUAD_WRITE_TRANS_TYPE SPI_TRANSFER_TT0
#define GD_25LQ64_QUAD_WRITE_WAIT_CYCLE 0x4

#define GD_25LQ64_CMD_QUAD_RDAD_IO 0xEB
#define GD_25LQ64_QUAD_RDAD_IO_SPI_FRF SPI_FRF_QUAD_FORMAT
#define GD_25LQ64_QUAD_RDAD_IO_INST_LEN SPI_INST_L8
#define GD_25LQ64_QUAD_RDAD_IO_ADDR_LEN SPI_ADDR_L24
#define GD_25LQ64_QUAD_RDAD_IO_TRANS_TYPE SPI_TRANSFER_TT1
#define GD_25LQ64_QUAD_RDAD_IO_WAIT_CYCLE 0x6
#endif
