#ifndef _LIB_MX_25U1632_INST_SET_TABLE_H
#define _LIB_MX_25U1632_INST_SET_TABLE_H
#include "hx_drv_spi.h"

#define MX_25U1632_CMD_NOP 0x00
#define MX_25U1632_CMD_JEDEC_ID_READ 0x9F
#define MX_25U1632_JEDEC_ID_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define MX_25U1632_CMD_SINGLE_READ 0x03
#define MX_25U1632_SINGLE_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define MX_25U1632_CMD_FAST_SINGLE_READ 0x0B
#define MX_25U1632_FAST_SINGLE_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT
#define MX_25U1632_FAST_SINGLE_READ_INST_LEN SPI_INST_L8
#define MX_25U1632_FAST_SINGLE_READ_ADDR_LEN SPI_ADDR_L24
#define MX_25U1632_FAST_SINGLE_READ_TRANS_TYPE SPI_TRANSFER_TT0
#define MX_25U1632_FAST_SINGLE_READ_WAIT_CYCLE 0x8

#define MX_25U1632_CMD_SINGLE_WRITE 0x02
#define MX_25U1632_SINGLE_WRITE_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define MX_25U1632_CMD_ERASE_SECTOR_4K 0x20
#define MX_25U1632_CMD_ERASE_SECTOR_32K 0x52
#define MX_25U1632_CMD_ERASE_SECTOR_64K 0xD8
#define MX_25U1632_ERASE_SECTOR_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define MX_25U1632_CMD_ERASE_ALL 0x60
#define MX_25U1632_ERASE_ALL_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define MX_25U1632_CMD_STATUS1_READ 0x05
#define MX_25U1632_CMD_STATUS2_READ 0x35
//Read configuration register
#define MX_25U1632_CMD_CONFIG_READ 0x15
#define MX_25U1632_CMD_STATUS_READ_COUNTS 1
#define MX_25U1632_STATUS_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define MX_25U1632_CMD_STATUS1_WRITE 0x01
// #define MX_25U1632_CMD_STATUS2_WRITE 0x31
// #define MX_25U1632_CMD_STATUS3_WRITE 0x11
#define MX_25U1632_STATUS_WRITE_SPI_FRF SPI_FRF_SINGLE_FORMAT
#define MX_25U1632_STATUS1_WRITE_COUNTS 2

#define MX_25U1632_CMD_WRITE_ENABLE 0x06
#define MX_25U1632_WRITE_ENABLE_SPI_FRF SPI_FRF_SINGLE_FORMAT

#define MX_25U1632_WIP_POS 0
#define MX_25U1632_WIP_MASK 0x1
#define MX_25U1632_QUAD_ENABLE_POS 6
#define MX_25U1632_QUAD_ENABLE_MASK 0x40
#define MX_25U1632_CMD_QUAD_ENABLE_WRITE MX_25U1632_CMD_STATUS1_WRITE
#define MX_25U1632_QUAD_ENABLE_WRITE_COUNTS 1

#define MX_25U1632_PROTECT_MASK 0xBC
#define MX_25U1632_PROTECT2_MASK 0x00 
#define MX_25U1632_PERTECT_EN_MASK 0x01

////when DC == 0(default setting), support max freq = 84MHZ 
#define MX_25U1632_CMD_DUAL_RDAD_FAST 0xBB
#define MX_25U1632_DUAL_RDAD_FAST_SPI_FRF SPI_FRF_DUAL_FORMAT
#define MX_25U1632_DUAL_RDAD_FAST_INST_LEN SPI_INST_L8
#define MX_25U1632_DUAL_RDAD_FAST_ADDR_LEN SPI_ADDR_L24
#define MX_25U1632_DUAL_RDAD_FAST_TRANS_TYPE SPI_TRANSFER_TT1
#define MX_25U1632_DUAL_RDAD_FAST_WAIT_CYCLE 0x4

#define MX_25U1632_CMD_DUAL_RDAD_SINGLE_ADDR 0x3B
#define MX_25U1632_DUAL_RDAD_SINGLE_ADDR_SPI_FRF SPI_FRF_DUAL_FORMAT
#define MX_25U1632_DUAL_RDAD_SINGLE_ADDR_INST_LEN SPI_INST_L8
#define MX_25U1632_DUAL_RDAD_SINGLE_ADDR_ADDR_LEN SPI_ADDR_L24
#define MX_25U1632_DUAL_RDAD_SINGLE_ADDR_TRANS_TYPE SPI_TRANSFER_TT0
#define MX_25U1632_DUAL_RDAD_SINGLE_ADDR_WAIT_CYCLE 0x8

#define MX_25U1632_CMD_QUAD_RDAD 0x6B
#define MX_25U1632_QUAD_RDAD_SPI_FRF SPI_FRF_QUAD_FORMAT
#define MX_25U1632_QUAD_RDAD_INST_LEN SPI_INST_L8
#define MX_25U1632_QUAD_RDAD_ADDR_LEN SPI_ADDR_L24
#define MX_25U1632_QUAD_RDAD_TRANS_TYPE SPI_TRANSFER_TT0
#define MX_25U1632_QUAD_RDAD_WAIT_CYCLE 0x8

#define MX_25U1632_CMD_QUAD_WRITE_QUAD_ADDR 0x38
#define MX_25U1632_QUAD_WRITE_QUAD_ADDR_SPI_FRF SPI_FRF_QUAD_FORMAT
#define MX_25U1632_QUAD_WRITE_QUAD_ADDR_INST_LEN SPI_INST_L8
#define MX_25U1632_QUAD_WRITE_QUAD_ADDR_ADDR_LEN SPI_ADDR_L24
#define MX_25U1632_QUAD_WRITE_QUAD_ADDR_TRANS_TYPE SPI_TRANSFER_TT1
#define MX_25U1632_QUAD_WRITE_QUAD_ADDR_WAIT_CYCLE 0x0

//when DC == 0(default setting), support max freq = 84MHZ
#define MX_25U1632_CMD_QUAD_RDAD_IO 0xEB
#define MX_25U1632_QUAD_RDAD_IO_SPI_FRF SPI_FRF_QUAD_FORMAT
#define MX_25U1632_QUAD_RDAD_IO_INST_LEN SPI_INST_L8
#define MX_25U1632_QUAD_RDAD_IO_ADDR_LEN SPI_ADDR_L24
#define MX_25U1632_QUAD_RDAD_IO_TRANS_TYPE SPI_TRANSFER_TT1
#define MX_25U1632_QUAD_RDAD_IO_WAIT_CYCLE 0x6

#define MX_25U1632_CMD_QUAD_READ_4DUMMY 0xE7
#define MX_25U1632_QUAD_READ_4DUMMY_SPI_FRF SPI_FRF_QUAD_FORMAT
#define MX_25U1632_QUAD_READ_4DUMMY_INST_LEN SPI_INST_L8
#define MX_25U1632_QUAD_READ_4DUMMY_ADDR_LEN SPI_ADDR_L24
#define MX_25U1632_QUAD_READ_4DUMMY_TRANS_TYPE SPI_TRANSFER_TT1
#define MX_25U1632_QUAD_READ_4DUMMY_WAIT_CYCLE 0x4
#endif
