#ifndef _LIB_WB_25Q64JW_INST_SET_TABLE_H
#define _LIB_WB_25Q64JW_INST_SET_TABLE_H
#include "hx_drv_spi.h"

#define WB_25Q64JW_CMD_JEDEC_ID_READ 0x9F

#define WB_25Q64JW_CMD_SINGLE_READ 0x03

#define WB_25Q64JW_CMD_FAST_SINGLE_READ 0x0B
#define WB_25Q64JW_FAST_SINGLE_READ_SPI_FRF SPI_FRF_SINGLE_FORMAT
#define WB_25Q64JW_FAST_SINGLE_READ_INST_LEN SPI_INST_L8
#define WB_25Q64JW_FAST_SINGLE_READ_ADDR_LEN SPI_ADDR_L24
#define WB_25Q64JW_FAST_SINGLE_READ_TRANS_TYPE SPI_TRANSFER_TT0
#define WB_25Q64JW_FAST_SINGLE_READ_WAIT_CYCLE 0x8

#define WB_25Q64JW_CMD_SINGLE_WRITE 0x02

#define WB_25Q64JW_CMD_ERASE_SECTOR_4K 0x20
#define WB_25Q64JW_CMD_ERASE_SECTOR_32K 0x52
#define WB_25Q64JW_CMD_ERASE_SECTOR_64K 0xD8

#define WB_25Q64JW_CMD_ERASE_ALL 0x60

#define WB_25Q64JW_CMD_STATUS1_READ 0x05
#define WB_25Q64JW_CMD_STATUS2_READ 0x35
#define WB_25Q64JW_CMD_STATUS3_READ 0x15
#define WB_25Q64JW_CMD_STATUS_READ_COUNTS 1

#define WB_25Q64JW_CMD_STATUS1_WRITE 0x01
#define WB_25Q64JW_CMD_STATUS2_WRITE 0x31
#define WB_25Q64JW_CMD_STATUS3_WRITE 0x11
#define WB_25Q64JW_STATUS1_WRITE_COUNTS 1

#define WB_25Q64JW_CMD_WRITE_ENABLE 0x06
#define WB_25Q64JW_CMD_WRITE_DISABLE 0x04

#define WB_25Q64JW_WIP_POS 0
#define WB_25Q64JW_WIP_MASK 0x1

#define WB_25Q64JW_QUAD_ENABLE_POS 1
#define WB_25Q64JW_QUAD_ENABLE_MASK 0x2
#define WB_25Q64JW_CMD_QUAD_ENABLE_WRITE WB_25Q64JW_CMD_STATUS2_WRITE
#define WB_25Q64JW_QUAD_ENABLE_WRITE_COUNTS 1

#define WB_25Q64JW_PROTECT_MASK 0xFC
#define WB_25Q64JW_PROTECT2_MASK 0x79
#define WB_25Q64JW_PERTECT_EN_MASK 0x03

#define WB_25Q64JW_CMD_DUAL_RDAD_FAST 0xBB
#define WB_25Q64JW_DUAL_RDAD_FAST_SPI_FRF SPI_FRF_DUAL_FORMAT
#define WB_25Q64JW_DUAL_RDAD_FAST_INST_LEN SPI_INST_L8
#define WB_25Q64JW_DUAL_RDAD_FAST_ADDR_LEN SPI_ADDR_L24
#define WB_25Q64JW_DUAL_RDAD_FAST_TRANS_TYPE SPI_TRANSFER_TT1
#define WB_25Q64JW_DUAL_RDAD_FAST_WAIT_CYCLE 0x4

#define WB_25Q64JW_CMD_DUAL_RDAD_SINGLE_ADDR 0x3B
#define WB_25Q64JW_DUAL_RDAD_SINGLE_ADDR_SPI_FRF SPI_FRF_DUAL_FORMAT
#define WB_25Q64JW_DUAL_RDAD_SINGLE_ADDR_INST_LEN SPI_INST_L8
#define WB_25Q64JW_DUAL_RDAD_SINGLE_ADDR_ADDR_LEN SPI_ADDR_L24
#define WB_25Q64JW_DUAL_RDAD_SINGLE_ADDR_TRANS_TYPE SPI_TRANSFER_TT0
#define WB_25Q64JW_DUAL_RDAD_SINGLE_ADDR_WAIT_CYCLE 0x8

#define WB_25Q64JW_CMD_QUAD_RDAD 0x6B
#define WB_25Q64JW_QUAD_RDAD_SPI_FRF SPI_FRF_QUAD_FORMAT
#define WB_25Q64JW_QUAD_RDAD_INST_LEN SPI_INST_L8
#define WB_25Q64JW_QUAD_RDAD_ADDR_LEN SPI_ADDR_L24
#define WB_25Q64JW_QUAD_RDAD_TRANS_TYPE SPI_TRANSFER_TT0
#define WB_25Q64JW_QUAD_RDAD_WAIT_CYCLE 0x8

#define WB_25Q64JW_CMD_QUAD_WRITE 0x32
#define WB_25Q64JW_QUAD_WRITE_SPI_FRF SPI_FRF_QUAD_FORMAT
#define WB_25Q64JW_QUAD_WRITE_INST_LEN SPI_INST_L8
#define WB_25Q64JW_QUAD_WRITE_ADDR_LEN SPI_ADDR_L24
#define WB_25Q64JW_QUAD_WRITE_TRANS_TYPE SPI_TRANSFER_TT0
#define WB_25Q64JW_QUAD_WRITE_WAIT_CYCLE 0x4

#define WB_25Q64JW_CMD_QUAD_RDAD_IO 0xEB
#define WB_25Q64JW_QUAD_RDAD_IO_SPI_FRF SPI_FRF_QUAD_FORMAT
#define WB_25Q64JW_QUAD_RDAD_IO_INST_LEN SPI_INST_L8
#define WB_25Q64JW_QUAD_RDAD_IO_ADDR_LEN SPI_ADDR_L24
#define WB_25Q64JW_QUAD_RDAD_IO_TRANS_TYPE SPI_TRANSFER_TT1
#define WB_25Q64JW_QUAD_RDAD_IO_WAIT_CYCLE 0x6
#endif
