CMSIS_DRIVERS_ROOT = $(EPII_ROOT)/cmsis_drivers
CMSIS_DRIVERS_INC_DIR = $(EPII_ROOT)/CMSIS/Driver/Include

CMSIS_DRIVERS_OBJS =

CMSIS_DRIVERS_COBJS =
CMSIS_DRIVERS_ASMOBJS =
CMSIS_DRIVERS_CXXOBJS =
CMSIS_DRIVERS_CCOBJS =

CMSIS_DRIVERS_CSRCS =
CMSIS_DRIVERS_ASMSRCS =
CMSIS_DRIVERS_CXXSRCS =
CMSIS_DRIVERS_CCSRCS =

-include $(CMSIS_DRIVERS_ROOT)/$(CMSIS_DRIVERS_USECASE_SEL).mk

ifdef CMSIS_DRIVERS_LIST
override CMSIS_DRIVERS_LIST := $(sort $(strip $(CMSIS_DRIVERS_LIST)))
FOREACH_CMSIS_DRIVERS_LIST = $(foreach CMSIS_DRIVERS_, $(CMSIS_DRIVERS_LIST), $(addprefix $(CMSIS_DRIVERS_ROOT)/, $(CMSIS_DRIVERS_)))
CMSIS_DRIVERS_CSRC_DIR = $(FOREACH_CMSIS_DRIVERS_LIST)
CMSIS_DRIVERS_ASMSRC_DIR = $(FOREACH_CMSIS_DRIVERS_LIST)
CMSIS_DRIVERS_CXXSRC_DIR = $(FOREACH_CMSIS_DRIVERS_LIST)
CMSIS_DRIVERS_CCSRC_DIR = $(FOREACH_CMSIS_DRIVERS_LIST)
CMSIS_DRIVERS_INC_DIR += $(FOREACH_CMSIS_DRIVERS_LIST)

CMSIS_DRIVERS_CSRCS += $(call get_csrcs, $(CMSIS_DRIVERS_CSRC_DIR))
CMSIS_DRIVERS_ASMSRCS += $(call get_asmsrcs, $(CMSIS_DRIVERS_ASMSRC_DIR))
CMSIS_DRIVERS_CXXSRCS += $(call get_cxxsrcs, $(CMSIS_DRIVERS_CXXSRC_DIR))
CMSIS_DRIVERS_CCSRCS += $(call get_ccsrcs, $(CMSIS_DRIVERS_CCSRC_DIR))

CMSIS_DRIVERS_COBJS += $(call get_relobjs, $(CMSIS_DRIVERS_CSRCS))
CMSIS_DRIVERS_ASMOBJS += $(call get_relobjs, $(CMSIS_DRIVERS_ASMSRCS))
CMSIS_DRIVERS_CXXOBJS += $(call get_relobjs, $(CMSIS_DRIVERS_CXXSRCS))
CMSIS_DRIVERS_CCOBJS += $(call get_relobjs, $(CMSIS_DRIVERS_CCSRCS))
CMSIS_DRIVERS_OBJS = $(CMSIS_DRIVERS_COBJS) $(CMSIS_DRIVERS_ASMOBJS) $(CMSIS_DRIVERS_CXXOBJS) $(CMSIS_DRIVERS_CCOBJS)

# get dependency files
CMSIS_DRIVERS_DEPS = $(call get_deps, $(CMSIS_DRIVERS_OBJS))

# extra macros to be defined
CMSIS_DRIVERS_DEFINES = 

# generate library
CMSIS_DRIVERS_LIB = $(OUT_DIR)/libcmsis_drivers.a

# library generation rule
$(CMSIS_DRIVERS_LIB): $(CMSIS_DRIVERS_OBJS)
	$(TRACE_ARCHIVE)
	$(Q)$(AR) $(AR_OPT) $@ $(CMSIS_DRIVERS_OBJS)

# include dependency files
ifneq ($(MAKECMDGOALS),clean)
-include $(CMSIS_DRIVERS_DEPS)
endif

endif #ifdef CMSIS_DRIVERS_LIST
