override SCENARIO_APP_SUPPORT_LIST := $(APP_TYPE)
#override NONTRUSTZONE_SRC_DIR := ${EPII_ROOT}\EPII_CM55M_APP_NS
#override EPII_NSC_SEL :=
override SEMIHOST := n

##
# library support feature
# Add new library here
# The source code should be loacted in ~\library\{lib_name}\
##
LIB_SEL = tfm170

##
# middleware support feature
# Add new middleware here
# The source code should be loacted in ~\middleware\{mid_name}\
##
MID_SEL =

# TrustZone
# TrustZone support y or n
# TRUSTZONE_TYPE security or non-security
# TRUSTZONE_FW_TYPE 0(S and NS) or 1(S only)
override TRUSTZONE := y
override TRUSTZONE_TYPE := non-security
override TRUSTZONE_FW_TYPE := 0
override EPII_USECASE_SEL := drv_onecore_cm55m_tfm_ns

##
# Add new external device here
# The source code should be located in ~\external\{device_name}\
##
#EXT_DEV_LIST += 

##
# TFM Setting
##
# _TFM_PROFILE support profile_large or profile_medium
_TFM_PROFILE=profile_large

# _TFM_CONFIG support Debug or Release
_TFM_CONFIG=Debug

# _TFM_ISOLATION_LEVEL support 1 or 2 or 3
_TFM_ISOLATION_LEVEL=3

# _TFM_ENABLE_MVE_FP support ON or OFF
_TFM_ENABLE_MVE_FP=ON

# _CRYPTO_HW_ACCELERATOR support ON or OFF
_CRYPTO_HW_ACCELERATOR=ON

# _TFM_EXCEPTION_INFO_DUMP support ON or OFF
_TFM_EXCEPTION_INFO_DUMP=ON

# _TFM_LOG_LEVEL support DEBUG or INFO or ERROR or SILENCE
_TFM_LOG_LEVEL=DEBUG

# _EMULATED_MPC_LAYOUT support ON or OFF
# ON: MPC LAYOUT by Secure FW; OFF: MPC LAYOUT by BootROM
_EMULATED_MPC_LAYOUT=OFF

# _TFM_NS_RTOS2_WRAPPER support BARE_METAL or RTOS2_RTX or RTOS2_FREERTOS
_TFM_NS_RTOS2_WRAPPER=BARE_METAL

# _TEST_S support ON or OFF
# ON: Run Test in Secure Side; OFF: Normal
_TEST_S=OFF

# _TEST_NS support ON or OFF
# ON: Run Test in Non Secure Side; OFF: Normal
_TEST_NS=OFF

####################################################################
TFM_ROOT = $(EPII_ROOT)/library/tfm170
include $(EPII_ROOT)/library/tfm170/tools/setup.mk
include $(EPII_ROOT)/library/tfm170/tools/check_setup.mk

# himax add
$(eval $(call set_tfm_cache_vars,BUILD_TFM_NS,ON))
$(eval $(call set_tfm_cache_vars,HX_TFM,ON))
$(eval $(call set_tfm_cache_vars,IMPLEMENT_FLASH_DRV,ON))
$(eval $(call set_tfm_cache_vars,EMULATED_MPC_LAYOUT,$(strip ${_EMULATED_MPC_LAYOUT})))
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_HX,ON))
$(eval $(call set_tfm_cache_vars,TFM_NS_RTOS2_WRAPPER,$(strip ${_TFM_NS_RTOS2_WRAPPER})))

# default
$(eval $(call set_tfm_cache_vars,TFM_SYSTEM_DSP,OFF))
$(eval $(call set_tfm_cache_vars,NS,ON))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_SPM_BACKEND,IPC))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_FLIH_API,ON))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_SLIH_API,OFF))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_MMIO_REGION_ENABLE,ON))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_BUILDING_SPE,1))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_LAZY_STACKING,ON))
$(eval $(call set_tfm_cache_vars,TFM_MULTI_CORE_NS_OS,OFF))
$(eval $(call set_tfm_cache_vars,TFM_MULTI_CORE_NS_OS_MAILBOX_THREAD,OFF))
$(eval $(call set_tfm_cache_vars,TFM_MULTI_CORE_TEST,OFF))
$(eval $(call set_tfm_cache_vars,BL2,OFF))
$(eval $(call set_tfm_cache_vars,BL2_HEADER_SIZE,0x000))
$(eval $(call set_tfm_cache_vars,BL2_TRAILER_SIZE,0x000))
$(eval $(call set_tfm_cache_vars,TFM_NS_MANAGE_NSID,OFF))
$(eval $(call set_tfm_cache_vars,TFM_PLATFORM,arm/an552_hx))
$(eval $(call set_tfm_cache_vars,TFM_LIB_MODEL,OFF))
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_CRYPTO,ON))
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_INTERNAL_TRUSTED_STORAGE,ON))
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_INITIAL_ATTESTATION,ON))
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_PLATFORM,ON))
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_PROTECTED_STORAGE,ON))
$(eval $(call set_tfm_cache_vars,TEST_NS_FLIH_HX,OFF))

##
# setting
##
$(eval $(call set_tfm_cache_vars,TFM_PROFILE,$(strip ${_TFM_PROFILE})))
$(eval $(call set_tfm_cache_vars,CRYPTO_HW_ACCELERATOR,$(strip ${_CRYPTO_HW_ACCELERATOR})))
$(eval $(call set_tfm_cache_vars,TFM_CONFIG,$(strip ${_TFM_CONFIG}))) #CMAKE_BUILD_TYPE
$(eval $(call set_tfm_cache_vars,TEST_S,$(strip ${_TEST_S})))
$(eval $(call set_tfm_cache_vars,TEST_NS,$(strip ${_TEST_NS})))
$(eval $(call set_tfm_cache_vars,TFM_ISOLATION_LEVEL,$(strip ${_TFM_ISOLATION_LEVEL})))
$(eval $(call set_tfm_cache_vars,TFM_SPM_LOG_LEVEL,TFM_SPM_LOG_LEVEL_$(strip ${_TFM_LOG_LEVEL})))
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_LOG_LEVEL,TFM_PARTITION_LOG_LEVEL_$(strip ${_TFM_LOG_LEVEL})))
$(eval $(call set_tfm_cache_vars,TFM_EXCEPTION_INFO_DUMP,$(strip ${_TFM_EXCEPTION_INFO_DUMP})))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_ENABLE_MVE_FP,$(strip ${_TFM_ENABLE_MVE_FP})))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_ENABLE_MVE,$(strip ${_TFM_ENABLE_MVE_FP})))
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_ENABLE_FP,$(strip ${_TFM_ENABLE_MVE_FP})))

############## ADD FPU/SLIH/FLIH TEST ON. TFM Defaut OFF ##################
#$(eval $(call set_tfm_cache_vars,TEST_S_FPU,ON))
#$(eval $(call set_tfm_cache_vars,TEST_NS_FPU,ON))
#$(eval $(call set_tfm_cache_vars,TEST_NS_SLIH_IRQ,OFF))
#$(eval $(call set_tfm_cache_vars,TEST_NS_FLIH_IRQ,ON))
############################################################################

ifeq ($(findstring ON,$(strip ${CONFIG_TFM_ENABLE_FP}) $(strip ${CONFIG_TFM_ENABLE_MVE}) $(strip ${CONFIG_TFM_ENABLE_MVE_FP})),) # OR logic
$(eval $(call set_tfm_cache_vars_force,TEST_S_FPU,OFF))
$(eval $(call set_tfm_cache_vars_force,TEST_NS_FPU,OFF))
$(eval $(call set_tfm_cache_vars_force,CONFIG_TFM_LAZY_STACKING,OFF))
$(eval $(call set_tfm_cache_vars_force,CONFIG_TFM_ENABLE_CP10CP11,OFF))
endif
#ifeq ($(strip ${TFM_PARTITION_HX}),ON)
#$(eval $(call set_tfm_cache_vars_force,TEST_NS_SLIH_IRQ,OFF))
#$(eval $(call set_tfm_cache_vars_force,TEST_NS_FLIH_IRQ,OFF))
#endif
ifeq ($(strip ${TEST_NS_SLIH_IRQ}),ON)
$(eval $(call set_tfm_cache_vars_force,CONFIG_TFM_SLIH_API,ON))
endif
ifeq ($(strip ${TFM_PARTITION_HX}),ON)
$(eval $(call set_tfm_cache_vars_force,CONFIG_TFM_FLIH_API,ON))
endif
ifeq ($(strip ${TEST_NS_FLIH_IRQ}),ON)
$(eval $(call set_tfm_cache_vars_force,CONFIG_TFM_FLIH_API,ON))
endif

include $(EPII_ROOT)/library/tfm170/CMakeLists.mk
include $(EPII_ROOT)/library/tfm170/tools/compile_definitions.mk

#APPL_DEFINES += -DHX_LIB_SPIM_DMA_POLL_STATUS_NO_IRQ
#APPL_DEFINES += -DHX_LIB_SPI_EEPROM_BUFFER_POOL
APPL_DEFINES += -DTFM_PARTITION_HX_IRQS_DMA1_QSPI

override MPU := n
override SUPPORT_SEC_LIB := n

ifeq ($(strip ${TFM_NS_RTOS2_WRAPPER}),RTOS2_RTX)
override OS_SEL := TFM_NS_RTX
else ifeq ($(strip ${TFM_NS_RTOS2_WRAPPER}),RTOS2_FREERTOS)
override OS_SEL := freertos
else
override OS_SEL :=
endif

ifeq ($(strip ${CONFIG_TFM_FLOAT_ABI}),hard)
override FLOAT_ABI := hard
else
override FLOAT_ABI := soft
endif

ifeq ($(strip $(TOOLCHAIN)),arm)
override LINKER_SCRIPT_FILE := $(SCENARIO_APP_ROOT)/$(APP_TYPE)/arm/tfm_common_ns_170.sct
else
override LINKER_SCRIPT_FILE := $(SCENARIO_APP_ROOT)/$(APP_TYPE)/gnu/tfm_common_ns_170.ld
endif

ifeq ($(strip ${TFM_CONFIG}),Debug)
OLEVEL := O1
else ifeq ($(strip ${TFM_CONFIG}),Release)
OLEVEL := O2
else
OLEVEL := O2
endif
