#-------------------------------------------------------------------------------
# Copyright (c) 2022, Arm Limited. All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
#
#-------------------------------------------------------------------------------

#set(TFM_PROFILE                profile_medium_arotless CACHE STRING    "Profile to use")
$(eval $(call set_tfm_cache_vars,TFM_PROFILE,profile_medium_arotless))
#set(PROJECT_CONFIG_HEADER_FILE "${CMAKE_SOURCE_DIR}/config/profile/config_profile_medium_arotless.h" CACHE FILEPATH "User defined header file for TF-M config")
$(eval $(call set_tfm_cache_vars,PROJECT_CONFIG_HEADER_FILE,\"config_profile_medium_arotless.h\"))

############################ SPM CONFIGURATION  ################################

#set(CONFIG_TFM_SPM_BACKEND              "SFN"       CACHE STRING    "The SPM backend [IPC, SFN]")
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_SPM_BACKEND,SFN))
#set(TFM_ISOLATION_LEVEL                 1           CACHE STRING    "Isolation level")
$(eval $(call set_tfm_cache_vars,TFM_ISOLATION_LEVEL,1))

############################ Partitions ########################################

#set(TFM_PARTITION_INTERNAL_TRUSTED_STORAGE ON       CACHE BOOL      "Enable Internal Trusted Storage partition")
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_INTERNAL_TRUSTED_STORAGE,ON))
#set(TFM_PARTITION_CRYPTO                ON          CACHE BOOL      "Enable Crypto partition")
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_CRYPTO,ON))
#set(TFM_PARTITION_PLATFORM              ON          CACHE BOOL      "Enable the TF-M Platform partition")
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_PLATFORM,ON))
#set(TFM_PARTITION_INITIAL_ATTESTATION   ON          CACHE BOOL      "Enable Initial Attestation partition")
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_INITIAL_ATTESTATION,ON))
#set(TFM_PARTITION_FIRMWARE_UPDATE       ON          CACHE BOOL      "Enable firmware update partition")
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_FIRMWARE_UPDATE,ON))
#set(TFM_PARTITION_PROTECTED_STORAGE     OFF         CACHE BOOL      "Enable Protected Storage partition")
$(eval $(call set_tfm_cache_vars,TFM_PARTITION_PROTECTED_STORAGE,OFF))

################################## Dependencies ################################

#set(TFM_MBEDCRYPTO_CONFIG_PATH              "${CMAKE_SOURCE_DIR}/lib/ext/mbedcrypto/mbedcrypto_config/tfm_mbedcrypto_config_profile_medium.h" CACHE PATH "Config to use for Mbed Crypto")
$(eval $(call set_tfm_cache_vars,TFM_MBEDCRYPTO_CONFIG_PATH,\"tfm_mbedcrypto_config_profile_medium.h\"))
#set(TFM_MBEDCRYPTO_PSA_CRYPTO_CONFIG_PATH   "${CMAKE_SOURCE_DIR}/lib/ext/mbedcrypto/mbedcrypto_config/crypto_config_profile_medium.h" CACHE PATH "Config to use psa crypto setting for Mbed Crypto.")
$(eval $(call set_tfm_cache_vars,TFM_MBEDCRYPTO_PSA_CRYPTO_CONFIG_PATH,\"crypto_config_profile_medium.h\"))

## If the platform doesn't support FWU, stop the configuration right now to give users a more
## specific error message, rather than letting check_config step to throw out a general error
## description.
#if(NOT PLATFORM_HAS_FIRMWARE_UPDATE_SUPPORT)
#    message(FATAL_ERROR "${TFM_PLATFORM} doesn't support FWU. Fail to select Profile Medium-ARoT-less")
#endif()
ifeq ($(strip ${PLATFORM_HAS_FIRMWARE_UPDATE_SUPPORT}),ON)
$(error ${TFM_PLATFORM} doesn't support FWU. Fail to select Profile Medium-ARoT-less)
endif