/*
 * Copyright (c) 2021-2022, Arm Limited. All rights reserved.
 * Copyright (c) 2021-2022 Cypress Semiconductor Corporation (an Infineon
 * company) or an affiliate of Cypress Semiconductor Corporation. All rights
 * reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 *
 */

/***********  WARNING: This is an auto-generated file. Do not edit!  ***********/

#include <stdint.h>
#include <stddef.h>
#include "config_tfm.h"
#include "region.h"
#include "region_defs.h"
#include "spm_ipc.h"
#include "load/interrupt_defs.h"
#include "load/partition_defs.h"
#include "load/service_defs.h"
#include "load/asset_defs.h"
#include "tfm_peripherals_def.h"
#include "psa_manifest/pid.h"
#include "psa_manifest/sid.h"
#include "psa_manifest/client_partition_psa.h"

#define CLIENT_PARTITION_NDEPS                                  (9)
#define CLIENT_PARTITION_NSERVS                                 (1)
#if TFM_LVL == 3
#define CLIENT_PARTITION_NASSETS                                (0 + 1)
#else
#define CLIENT_PARTITION_NASSETS                                (0)
#endif
#define CLIENT_PARTITION_NIRQS                                  (0)

/* Memory region declaration */
#if TFM_LVL == 3
REGION_DECLARE(Image$$, PT_CLIENT_PARTITION_PRIVATE, _DATA_START$$Base);
REGION_DECLARE(Image$$, PT_CLIENT_PARTITION_PRIVATE, _DATA_END$$Base);
#endif

extern uint8_t client_partition_stack[];

/* Entrypoint function declaration */
extern void client_main(void);

/* Interrupt init functions */

/* partition load info type definition */
struct partition_client_partition_load_info_t {
    /* common length load data */
    struct partition_load_info_t    load_info;
    /* per-partition variable length load data */
    uintptr_t                       stack_addr;
    uintptr_t                       heap_addr;
    uint32_t                        deps[CLIENT_PARTITION_NDEPS];
    struct service_load_info_t      services[CLIENT_PARTITION_NSERVS];
#if TFM_LVL == 3
    struct asset_desc_t             assets[CLIENT_PARTITION_NASSETS];
#else
#endif
} __attribute__((aligned(4)));

/* Partition load, deps, service load data. Put to a dedicated section. */
#if defined(__ICCARM__)
#pragma location = ".part_load_priority_normal"
__root
#endif /* __ICCARM__ */
const struct partition_client_partition_load_info_t client_partition_load
    __attribute__((used, section(".part_load_priority_normal"))) = {
    .load_info = {
        .psa_ff_ver                 = 0x0100 | PARTITION_INFO_MAGIC,
        .pid                        = CLIENT_PARTITION,
        .flags                      = 0
                                    | PARTITION_MODEL_IPC
                                    | PARTITION_PRI_NORMAL,
        .entry                      = ENTRY_TO_POSITION(client_main),
        .stack_size                 = 0x400,
        .heap_size                  = 0,
        .ndeps                      = CLIENT_PARTITION_NDEPS,
        .nservices                  = CLIENT_PARTITION_NSERVS,
        .nassets                    = CLIENT_PARTITION_NASSETS,
        .nirqs                      = CLIENT_PARTITION_NIRQS,
    },
    .stack_addr                     = (uintptr_t)client_partition_stack,
    .heap_addr                      = 0,
    .deps = {
        DRIVER_UART_SID,
        DRIVER_NVMEM_SID,
        DRIVER_TEST_SID,
        SERVER_TEST_DISPATCHER_SID,
        SERVER_UNSPECIFED_VERSION_SID,
        SERVER_STRICT_VERSION_SID,
        SERVER_RELAX_VERSION_SID,
        SERVER_SECURE_CONNECT_ONLY_SID,
        SERVER_CONNECTION_DROP_SID,
    },
    .services = {
        {
            .name_strid             = STRING_PTR_TO_STRID("CLIENT_TEST_DISPATCHER"),
            .sfn                    = 0,
            .signal                 = CLIENT_TEST_DISPATCHER_SIGNAL,

            .sid                    = 0x0000FA01,
            .flags                  = 0
                                    | SERVICE_FLAG_NS_ACCESSIBLE
                                    | SERVICE_VERSION_POLICY_RELAXED,
            .version                = 1,
        },
    },
#if TFM_LVL == 3
    .assets                         = {
        {
            .mem.start              = PART_REGION_ADDR(PT_CLIENT_PARTITION_PRIVATE, _DATA_START$$Base),
            .mem.limit              = PART_REGION_ADDR(PT_CLIENT_PARTITION_PRIVATE, _DATA_END$$Base),
            .attr                   = ASSET_ATTR_READ_WRITE,
        },
    },
#else
#endif
};

/* Placeholder for partition and service runtime space. Do not reference it. */
#if defined(__ICCARM__)
#pragma location=".bss.part_runtime_priority_normal"
__root
#endif /* __ICCARM__ */
static struct partition_t client_partition_partition_runtime_item
    __attribute__((used, section(".bss.part_runtime_priority_normal")));
#if defined(__ICCARM__)
#pragma location = ".bss.serv_runtime_priority_normal"
__root
#endif /* __ICCARM__ */
static struct service_t client_partition_service_runtime_item[CLIENT_PARTITION_NSERVS]
    __attribute__((used, section(".bss.serv_runtime_priority_normal")));
