/*
 * Copyright (c) 2021-2022, Arm Limited. All rights reserved.
 * Copyright (c) 2021-2022 Cypress Semiconductor Corporation (an Infineon
 * company) or an affiliate of Cypress Semiconductor Corporation. All rights
 * reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 *
 */

/***********  WARNING: This is an auto-generated file. Do not edit!  ***********/

#include <stdint.h>
#include <stddef.h>
#include "config_tfm.h"
#include "region.h"
#include "region_defs.h"
#include "spm_ipc.h"
#include "load/interrupt_defs.h"
#include "load/partition_defs.h"
#include "load/service_defs.h"
#include "load/asset_defs.h"
#include "tfm_peripherals_def.h"
#include "psa_manifest/pid.h"
#include "psa_manifest/sid.h"
#include "psa_manifest/driver_partition_psa.h"

#define DRIVER_PARTITION_NDEPS                                  (0)
#define DRIVER_PARTITION_NSERVS                                 (4)
#if TFM_LVL == 3
#define DRIVER_PARTITION_NASSETS                                (4 + 1)
#else
#define DRIVER_PARTITION_NASSETS                                (4)
#endif
#define DRIVER_PARTITION_NIRQS                                  (1)

/* Memory region declaration */
#if TFM_LVL == 3
REGION_DECLARE(Image$$, PT_DRIVER_PARTITION_PRIVATE, _DATA_START$$Base);
REGION_DECLARE(Image$$, PT_DRIVER_PARTITION_PRIVATE, _DATA_END$$Base);
#endif

extern uint8_t driver_partition_stack[];

/* Entrypoint function declaration */
extern void driver_main(void);

/* Interrupt init functions */
extern enum tfm_hal_status_t ff_test_uart_irq_init(void *p_pt,
                                                            const struct irq_load_info_t *p_ildi);

/* partition load info type definition */
struct partition_driver_partition_load_info_t {
    /* common length load data */
    struct partition_load_info_t    load_info;
    /* per-partition variable length load data */
    uintptr_t                       stack_addr;
    uintptr_t                       heap_addr;
    struct service_load_info_t      services[DRIVER_PARTITION_NSERVS];
#if TFM_LVL == 3
    struct asset_desc_t             assets[DRIVER_PARTITION_NASSETS];
#else
    struct asset_desc_t             assets[DRIVER_PARTITION_NASSETS];
#endif
    struct irq_load_info_t          irqs[DRIVER_PARTITION_NIRQS];
} __attribute__((aligned(4)));

/* Partition load, deps, service load data. Put to a dedicated section. */
#if defined(__ICCARM__)
#pragma location = ".part_load_priority_normal"
__root
#endif /* __ICCARM__ */
const struct partition_driver_partition_load_info_t driver_partition_load
    __attribute__((used, section(".part_load_priority_normal"))) = {
    .load_info = {
        .psa_ff_ver                 = 0x0100 | PARTITION_INFO_MAGIC,
        .pid                        = DRIVER_PARTITION,
        .flags                      = 0
                                    | PARTITION_MODEL_IPC
                                    | PARTITION_MODEL_PSA_ROT
                                    | PARTITION_PRI_NORMAL,
        .entry                      = ENTRY_TO_POSITION(driver_main),
        .stack_size                 = 0x400,
        .heap_size                  = 0,
        .ndeps                      = DRIVER_PARTITION_NDEPS,
        .nservices                  = DRIVER_PARTITION_NSERVS,
        .nassets                    = DRIVER_PARTITION_NASSETS,
        .nirqs                      = DRIVER_PARTITION_NIRQS,
    },
    .stack_addr                     = (uintptr_t)driver_partition_stack,
    .heap_addr                      = 0,
    .services = {
        {
            .name_strid             = STRING_PTR_TO_STRID("DRIVER_UART"),
            .sfn                    = 0,
            .signal                 = DRIVER_UART_SIGNAL,

            .sid                    = 0x0000FC01,
            .flags                  = 0
                                    | SERVICE_FLAG_NS_ACCESSIBLE
                                    | SERVICE_VERSION_POLICY_RELAXED,
            .version                = 1,
        },
        {
            .name_strid             = STRING_PTR_TO_STRID("DRIVER_WATCHDOG"),
            .sfn                    = 0,
            .signal                 = DRIVER_WATCHDOG_SIGNAL,

            .sid                    = 0x0000FC02,
            .flags                  = 0
                                    | SERVICE_FLAG_NS_ACCESSIBLE
                                    | SERVICE_VERSION_POLICY_RELAXED,
            .version                = 1,
        },
        {
            .name_strid             = STRING_PTR_TO_STRID("DRIVER_NVMEM"),
            .sfn                    = 0,
            .signal                 = DRIVER_NVMEM_SIGNAL,

            .sid                    = 0x0000FC03,
            .flags                  = 0
                                    | SERVICE_FLAG_NS_ACCESSIBLE
                                    | SERVICE_VERSION_POLICY_RELAXED,
            .version                = 1,
        },
        {
            .name_strid             = STRING_PTR_TO_STRID("DRIVER_TEST"),
            .sfn                    = 0,
            .signal                 = DRIVER_TEST_SIGNAL,

            .sid                    = 0x0000FC04,
            .flags                  = 0
                                    | SERVICE_FLAG_NS_ACCESSIBLE
                                    | SERVICE_VERSION_POLICY_RELAXED,
            .version                = 1,
        },
    },
#if TFM_LVL == 3
    .assets                         = {
        {
            .mem.start              = PART_REGION_ADDR(PT_DRIVER_PARTITION_PRIVATE, _DATA_START$$Base),
            .mem.limit              = PART_REGION_ADDR(PT_DRIVER_PARTITION_PRIVATE, _DATA_END$$Base),
            .attr                   = ASSET_ATTR_READ_WRITE,
        },
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(FF_TEST_UART_REGION),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(FF_TEST_WATCHDOG_REGION),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(FF_TEST_NVMEM_REGION),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(FF_TEST_DRIVER_PARTITION_MMIO),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
    },
#else
    .assets                         = {
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(FF_TEST_UART_REGION),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(FF_TEST_WATCHDOG_REGION),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(FF_TEST_NVMEM_REGION),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(FF_TEST_DRIVER_PARTITION_MMIO),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
    },
#endif
    .irqs = {
        {
            .init = ff_test_uart_irq_init,
            .flih_func = 0,
            .pid = DRIVER_PARTITION,
            .source = FF_TEST_UART_IRQ,
            .signal = DRIVER_UART_INTR_SIG,
        },
    },
};

/* Placeholder for partition and service runtime space. Do not reference it. */
#if defined(__ICCARM__)
#pragma location=".bss.part_runtime_priority_normal"
__root
#endif /* __ICCARM__ */
static struct partition_t driver_partition_partition_runtime_item
    __attribute__((used, section(".bss.part_runtime_priority_normal")));
#if defined(__ICCARM__)
#pragma location = ".bss.serv_runtime_priority_normal"
__root
#endif /* __ICCARM__ */
static struct service_t driver_partition_service_runtime_item[DRIVER_PARTITION_NSERVS]
    __attribute__((used, section(".bss.serv_runtime_priority_normal")));
