/*
 * Copyright (c) 2021-2022, Arm Limited. All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 *
 */
/***********  WARNING: This is an auto-generated file. Do not edit!  ***********/

#ifndef __CONFIG_IMPL_H__
#define __CONFIG_IMPL_H__

#include "config_tfm.h"

#if 0  //YX 20230117 removed
#if (defined(CONFIG_TFM_SPM_BACKEND) && CONFIG_TFM_SPM_BACKEND == IPC)
/* Backends */
#define CONFIG_TFM_SPM_BACKEND_IPC                               1
#define CONFIG_TFM_SPM_BACKEND_SFN                               0
#if TFM_LVL > 1
/* API calls */
#define CONFIG_TFM_PSA_API_SFN_CALL                              0
#define CONFIG_TFM_PSA_API_CROSS_CALL                            0
#define CONFIG_TFM_PSA_API_SUPERVISOR_CALL                       1
#else
/* API calls */
#define CONFIG_TFM_PSA_API_SFN_CALL                              0
#define CONFIG_TFM_PSA_API_CROSS_CALL                            1
#define CONFIG_TFM_PSA_API_SUPERVISOR_CALL                       0
#endif
#elif (defined(CONFIG_TFM_SPM_BACKEND) && CONFIG_TFM_SPM_BACKEND == SFN)
/* Backends */
#define CONFIG_TFM_SPM_BACKEND_IPC                               0
#define CONFIG_TFM_SPM_BACKEND_SFN                               1
/* API calls */
#define CONFIG_TFM_PSA_API_SFN_CALL                              1
#define CONFIG_TFM_PSA_API_CROSS_CALL                            0
#define CONFIG_TFM_PSA_API_SUPERVISOR_CALL                       0
#if TFM_LVL > 1
#error "SFN backend does not support high isolation levels."
#endif
#else
#error "CONFIG_TFM_SPM_BACKEND != IPC and CONFIG_TFM_SPM_BACKEND != SFN"
#endif

#define CONFIG_TFM_CONNECTION_BASED_SERVICE_API                  1
#define CONFIG_TFM_MMIO_REGION_ENABLE                            1
#define CONFIG_TFM_FLIH_API                                      0
#define CONFIG_TFM_SLIH_API                                      0
#endif  //YX 20230117 removed

#if CONFIG_TFM_SPM_BACKEND_IPC == 1
/* Trustzone NS agent working stack size. */
#if defined(TFM_FIH_PROFILE_ON) && TFM_LVL == 1
#define CONFIG_TFM_NS_AGENT_TZ_STACK_SIZE                        1256
#else
//#define CONFIG_TFM_NS_AGENT_TZ_STACK_SIZE                        1024
#define CONFIG_TFM_NS_AGENT_TZ_STACK_SIZE                        (1024 + (4*1024)) //YX 20230307
#endif

/* SPM re-uses Trustzone NS agent stack. */
#define CONFIG_TFM_SPM_THREAD_STACK_SIZE                             \
            CONFIG_TFM_NS_AGENT_TZ_STACK_SIZE                       

#elif CONFIG_TFM_SPM_BACKEND_SFN == 1
/*
 * In isolation level 1 SFN model, all subsequent components work on NS agent
 * stack. It is observed that half of the sum of all partition stack sizes is
 * enough for working. Define a divisor factor
 * CONFIG_TFM_NS_AGENT_TZ_STK_SIZE_SHIFT_FACTOR for reference, and allow
 * modification of the factor based on application situation. The stack size
 * value is aligned to 8 bytes.
 * The minimum value is 0x400 to satisfy the SPM functional requirement.
 * Manifest tool will assure this.
 */

#if defined(TEST_S_FWU) || defined(TEST_NS_FWU)
#define __FWU_STACK_SIZE  FWU_STACK_SIZE
#else
#define __FWU_STACK_SIZE  0
#endif
#if defined(TEST_NS_SLIH_IRQ) || defined(TEST_NS_FLIH_IRQ)
#define __NS_SLIH_FLIH_IRQU_STACK_SIZE  0x400
#else
#define __NS_SLIH_FLIH_IRQU_STACK_SIZE  0
#endif

#define __CONFIG_TFM_TOTAL_STACK_SIZE  (0 + PS_STACK_SIZE + ITS_STACK_SIZE + CRYPTO_STACK_SIZE + PLATFORM_SP_STACK_SIZE + ATTEST_STACK_SIZE + 0x0D00 + 0x0220 + 0x0300 + 0x500 + 0x300 + 0x400)
#define CONFIG_TFM_TOTAL_STACK_SIZE    (__CONFIG_TFM_TOTAL_STACK_SIZE + __FWU_STACK_SIZE + __NS_SLIH_FLIH_IRQU_STACK_SIZE)

#if (CONFIG_TFM_TOTAL_STACK_SIZE < 2048)
#undef CONFIG_TFM_TOTAL_STACK_SIZE                             
#define CONFIG_TFM_TOTAL_STACK_SIZE                              2048
#endif

#define CONFIG_TFM_NS_AGENT_TZ_STK_SIZE_SHIFT_FACTOR             1
#define CONFIG_TFM_NS_AGENT_TZ_STACK_SIZE                         \
    (((CONFIG_TFM_TOTAL_STACK_SIZE >> CONFIG_TFM_NS_AGENT_TZ_STK_SIZE_SHIFT_FACTOR) + 0x7) & (~0x7))

#endif /* CONFIG_TFM_SPM_BACKEND_IPC == 1 */

#endif /* __CONFIG_IMPL_H__ */
