/*
 * Copyright (c) 2021-2022, Arm Limited. All rights reserved.
 * Copyright (c) 2021-2022 Cypress Semiconductor Corporation (an Infineon
 * company) or an affiliate of Cypress Semiconductor Corporation. All rights
 * reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 *
 */

/***********  WARNING: This is an auto-generated file. Do not edit!  ***********/

#include <stdint.h>
#include <stddef.h>
#include "config_tfm.h"
#include "region.h"
#include "region_defs.h"
#include "spm_ipc.h"
#include "load/interrupt_defs.h"
#include "load/partition_defs.h"
#include "load/service_defs.h"
#include "load/asset_defs.h"
#include "tfm_peripherals_def.h"
#include "psa_manifest/pid.h"
#include "psa_manifest/sid.h"
#include "psa_manifest/tfm_hx_service.h"

#define TFM_SP_HX_NDEPS                                         (1)
#define TFM_SP_HX_NSERVS                                        (1)
#if TFM_LVL == 3
#define TFM_SP_HX_NASSETS                                       (1 + 1)
#else
#define TFM_SP_HX_NASSETS                                       (1)
#endif
#if defined(TFM_PARTITION_HX_IRQS_DMA1_QSPI)
#if !defined(TEST_NS_SLIH_IRQ) && !defined(TEST_NS_FLIH_IRQ)
#define TFM_SP_HX_NIRQS                                         (2 + 2)
#else
#define TFM_SP_HX_NIRQS                                         (1 + 2)
#endif
#else
#if !defined(TEST_NS_SLIH_IRQ) && !defined(TEST_NS_FLIH_IRQ)
#define TFM_SP_HX_NIRQS                                         (2)
#else
#define TFM_SP_HX_NIRQS                                         (1)
#endif
#endif


/* Memory region declaration */
#if TFM_LVL == 3
REGION_DECLARE(Image$$, PT_TFM_SP_HX_PRIVATE, _DATA_START$$Base);
REGION_DECLARE(Image$$, PT_TFM_SP_HX_PRIVATE, _DATA_END$$Base);
#endif

extern uint8_t tfm_sp_hx_stack[];

/* Entrypoint function declaration */
extern void hx_service_entry(void);

/* Interrupt init functions */
extern enum tfm_hal_status_t timer2int_irqn_init(void *p_pt,
                                                            const struct irq_load_info_t *p_ildi);
extern enum tfm_hal_status_t timer3int_irqn_init(void *p_pt,
                                                            const struct irq_load_info_t *p_ildi);
extern enum tfm_hal_status_t dmac1_dmacintr_irqn_init(void *p_pt,
                                                            const struct irq_load_info_t *p_ildi);
extern enum tfm_hal_status_t qspi_ssi_intp_irqn_init(void *p_pt,
                                                            const struct irq_load_info_t *p_ildi);

/* partition load info type definition */
struct partition_tfm_sp_hx_load_info_t {
    /* common length load data */
    struct partition_load_info_t    load_info;
    /* per-partition variable length load data */
    uintptr_t                       stack_addr;
    uintptr_t                       heap_addr;
    uint32_t                        deps[TFM_SP_HX_NDEPS];
    struct service_load_info_t      services[TFM_SP_HX_NSERVS];
#if TFM_LVL == 3
    struct asset_desc_t             assets[TFM_SP_HX_NASSETS];
#else
    struct asset_desc_t             assets[TFM_SP_HX_NASSETS];
#endif
    struct irq_load_info_t          irqs[TFM_SP_HX_NIRQS];
} __attribute__((aligned(4)));

/* Partition load, deps, service load data. Put to a dedicated section. */
#if defined(__ICCARM__)
#pragma location = ".part_load_priority_normal"
__root
#endif /* __ICCARM__ */
const struct partition_tfm_sp_hx_load_info_t tfm_sp_hx_load
    //__attribute__((used, section(".part_load_priority_normal"))) = {
    __attribute__((used, section(".part_load_priority_hx"))) = {
    .load_info = {
        .psa_ff_ver                 = 0x0101 | PARTITION_INFO_MAGIC,
        .pid                        = TFM_SP_HX,
        .flags                      = 0
                                    | PARTITION_MODEL_IPC
                                    | PARTITION_MODEL_PSA_ROT
                                    | PARTITION_PRI_NORMAL,
        .entry                      = ENTRY_TO_POSITION(hx_service_entry),
        .stack_size                 = HX_STACK_SIZE,
        .heap_size                  = 0,
        .ndeps                      = TFM_SP_HX_NDEPS,
        .nservices                  = TFM_SP_HX_NSERVS,
        .nassets                    = TFM_SP_HX_NASSETS,
        .nirqs                      = TFM_SP_HX_NIRQS,
    },
    .stack_addr                     = (uintptr_t)tfm_sp_hx_stack,
    .heap_addr                      = 0,
    .deps = {
        TFM_PLATFORM_SERVICE_SID,
    },
    .services = {
        {
            .name_strid             = STRING_PTR_TO_STRID("TFM_HX_SERVICE"),
            .sfn                    = 0,
            .signal                 = TFM_HX_SERVICE_SIGNAL,

//            .sid                    = 0x0000F1B0,
            .sid                    = TFM_HX_SERVICE_SID,
            .flags                  = 0
                                    | SERVICE_FLAG_NS_ACCESSIBLE
                                    | SERVICE_FLAG_STATELESS | 0x8
//                                    | SERVICE_FLAG_STATELESS | 0x7
                                    | SERVICE_VERSION_POLICY_STRICT,
            .version                = 1,
        },
    },
#if TFM_LVL == 3
    .assets                         = {
        {
            .mem.start              = PART_REGION_ADDR(PT_TFM_SP_HX_PRIVATE, _DATA_START$$Base),
            .mem.limit              = PART_REGION_ADDR(PT_TFM_SP_HX_PRIVATE, _DATA_END$$Base),
            .attr                   = ASSET_ATTR_READ_WRITE,
        },
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(TFM_PERIPHERAL_TIMER),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
    },
#else
    .assets                         = {
        {
            .dev.dev_ref            = PTR_TO_REFERENCE(TFM_PERIPHERAL_TIMER),
            .attr                   = ASSET_ATTR_NAMED_MMIO
                                    | ASSET_ATTR_READ_WRITE,
        },
    },
#endif
    .irqs = {
#if !defined(TEST_NS_SLIH_IRQ) && !defined(TEST_NS_FLIH_IRQ)
        {
            .init = timer2int_irqn_init,
            .flih_func = timer2int_irqn_flih,
            .pid = TFM_SP_HX,
            .source = TIMER2INT_IRQn,
            .signal = TIMER2INT_IRQn_SIGNAL,
        },
#endif
        {
            .init = timer3int_irqn_init,
            .flih_func = timer3int_irqn_flih,
            .pid = TFM_SP_HX,
            .source = TIMER3INT_IRQn,
            .signal = TIMER3INT_IRQn_SIGNAL,
        },
#if defined(TFM_PARTITION_HX_IRQS_DMA1_QSPI)
        {
            .init = dmac1_dmacintr_irqn_init,
            .flih_func = dmac1_dmacintr_irqn_flih,
            .pid = TFM_SP_HX,
            .source = DMAC1_DMACINTR_IRQn,
            .signal = DMAC1_DMACINTR_IRQn_SIGNAL,
        },
        {
            .init = qspi_ssi_intp_irqn_init,
            .flih_func = qspi_ssi_intp_irqn_flih,
            .pid = TFM_SP_HX,
            .source = QSPI_ssi_intp_IRQn,
            .signal = QSPI_ssi_intp_IRQn_SIGNAL,
        },
#endif
    },
};

/* Placeholder for partition and service runtime space. Do not reference it. */
#if defined(__ICCARM__)
#pragma location=".bss.part_runtime_priority_normal"
__root
#endif /* __ICCARM__ */
static struct partition_t tfm_sp_hx_partition_runtime_item
    __attribute__((used, section(".bss.part_runtime_priority_normal")));
#if defined(__ICCARM__)
#pragma location = ".bss.serv_runtime_priority_normal"
__root
#endif /* __ICCARM__ */
static struct service_t tfm_sp_hx_service_runtime_item[TFM_SP_HX_NSERVS]
    __attribute__((used, section(".bss.serv_runtime_priority_normal")));
