#-------------------------------------------------------------------------------
# Copyright (c) 2021-2022, Arm Limited. All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
#
#-------------------------------------------------------------------------------

########################## Check Flags Input ###################################

#tfm_invalid_config((NOT TFM_PARTITION_PROTECTED_STORAGE) AND (TEST_NS_PS OR TEST_S_PS))
ifeq ($(strip ${TFM_PARTITION_PROTECTED_STORAGE}),OFF)
ifneq ($(findstring ON,$(strip ${TEST_NS_PS}) $(strip ${TEST_S_PS})),) # OR logic
$(error tfm_invalid_config. TFM_PARTITION_PROTECTED_STORAGE = ${TFM_PARTITION_PROTECTED_STORAGE}, TEST_NS_PS = ${TEST_NS_PS}, TEST_S_PS = ${TEST_S_PS})
endif
endif

#tfm_invalid_config((NOT TFM_PARTITION_INTERNAL_TRUSTED_STORAGE) AND (TEST_NS_ITS OR TEST_S_ITS OR TEST_NS_PS))
ifeq ($(strip ${TFM_PARTITION_INTERNAL_TRUSTED_STORAGE}),OFF)
ifneq ($(findstring ON,$(strip ${TEST_NS_ITS}) $(strip ${TEST_S_ITS}) $(strip ${TEST_NS_PS})),) # OR logic
$(error tfm_invalid_config. TFM_PARTITION_INTERNAL_TRUSTED_STORAGE = ${TFM_PARTITION_INTERNAL_TRUSTED_STORAGE}, TEST_NS_ITS = ${TEST_NS_ITS}, TEST_S_ITS = ${TEST_S_ITS}, TEST_NS_PS = ${TEST_NS_PS})
endif
endif

#tfm_invalid_config((NOT TFM_PARTITION_CRYPTO) AND (TEST_NS_CRYPTO OR TEST_S_CRYPTO))
ifeq ($(strip ${TFM_PARTITION_CRYPTO}),OFF)
ifneq ($(findstring ON,$(strip ${TEST_NS_CRYPTO}) $(strip ${TEST_S_CRYPTO})),) # OR logic
$(error tfm_invalid_config. TFM_PARTITION_CRYPTO = ${TFM_PARTITION_CRYPTO}, TEST_NS_CRYPTO = ${TEST_NS_CRYPTO}, TEST_S_CRYPTO = ${TEST_S_CRYPTO})
endif
endif
#tfm_invalid_config((NOT TFM_PARTITION_INITIAL_ATTESTATION) AND (TEST_NS_ATTESTATION OR TEST_S_ATTESTATION OR TEST_NS_QCBOR OR TEST_NS_T_COSE))
ifeq ($(strip ${TFM_PARTITION_INITIAL_ATTESTATION}),OFF)
ifneq ($(findstring ON,$(strip ${TEST_NS_ATTESTATION}) $(strip ${TEST_S_ATTESTATION}) $(strip ${TEST_NS_QCBOR}) $(strip ${TEST_NS_T_COSE})),) # OR logic
$(error tfm_invalid_config. TFM_PARTITION_INITIAL_ATTESTATION = ${TFM_PARTITION_INITIAL_ATTESTATION}, \
TEST_NS_ATTESTATION = ${TEST_NS_ATTESTATION}, \
TEST_S_ATTESTATION = ${TEST_S_ATTESTATION}, \
TEST_NS_QCBOR = ${TEST_NS_QCBOR}, \
TEST_NS_T_COSE = ${TEST_NS_T_COSE})
endif
endif
#tfm_invalid_config((NOT TFM_PARTITION_PLATFORM) AND (TEST_NS_PLATFORM OR TEST_S_PLATFORM))
ifeq ($(strip ${TFM_PARTITION_PLATFORM}),OFF)
ifneq ($(findstring ON,$(strip ${TEST_NS_PLATFORM}) $(strip ${TEST_S_PLATFORM})),) # OR logic
$(error tfm_invalid_config. TFM_PARTITION_PLATFORM = ${TFM_PARTITION_PLATFORM}, \
TEST_NS_PLATFORM = ${TEST_NS_PLATFORM}, \
TEST_S_PLATFORM = ${TEST_S_PLATFORM})
endif
endif
#tfm_invalid_config(NOT TFM_PARTITION_FIRMWARE_UPDATE AND (TEST_NS_FWU OR TEST_S_FWU))
ifeq ($(strip ${TFM_PARTITION_FIRMWARE_UPDATE}),OFF)
ifneq ($(findstring ON,$(strip ${TEST_NS_FWU}) $(strip ${TEST_S_FWU})),) # OR logic
$(error tfm_invalid_config. TFM_PARTITION_FIRMWARE_UPDATE = ${TFM_PARTITION_FIRMWARE_UPDATE}, \
TEST_NS_FWU = ${TEST_NS_FWU}, \
TEST_S_FWU = ${TEST_S_FWU})
endif
endif

#tfm_invalid_config((TEST_NS_IPC OR TEST_S_IPC) AND CONFIG_TFM_SPM_BACKEND_SFN)
ifneq ($(findstring ON,$(strip ${TEST_NS_IPC}) $(strip ${TEST_S_IPC})),) # OR logic
ifeq ($(strip ${CONFIG_TFM_SPM_BACKEND_SFN}),ON)
$(error tfm_invalid_config. CONFIG_TFM_SPM_BACKEND_SFN = ${CONFIG_TFM_SPM_BACKEND_SFN}, \
TEST_NS_IPC = ${TEST_NS_IPC}, \
TEST_S_IPC = ${TEST_S_IPC})
endif
endif

#tfm_invalid_config(TEST_S_SFN_BACKEND AND CONFIG_TFM_SPM_BACKEND_IPC)
ifeq ($(strip ${TEST_S_SFN_BACKEND}),ON)
ifeq ($(strip ${CONFIG_TFM_SPM_BACKEND_IPC}),ON)
$(error tfm_invalid_config. TEST_S_SFN_BACKEND = ${TEST_S_SFN_BACKEND}, CONFIG_TFM_SPM_BACKEND_IPC = ${CONFIG_TFM_SPM_BACKEND_IPC})
endif
endif

#tfm_invalid_config(CONFIG_TFM_FLOAT_ABI STREQUAL "soft" AND (TEST_S_FPU OR TEST_NS_FPU))
ifeq ($(strip ${CONFIG_TFM_FLOAT_ABI}),soft)
ifneq ($(findstring ON,$(strip ${TEST_S_FPU}) $(strip ${TEST_NS_FPU})),) # OR logic
$(error tfm_invalid_config. CONFIG_TFM_FLOAT_ABI = ${CONFIG_TFM_FLOAT_ABI}, \
TEST_S_FPU = ${TEST_S_FPU}, \
TEST_NS_FPU = ${TEST_NS_FPU})
endif
endif

#tfm_invalid_config((NOT TFM_MULTI_CORE_TOPOLOGY) AND TEST_NS_MULTI_CORE)
ifeq ($(strip ${TFM_MULTI_CORE_TOPOLOGY}),OFF)
ifeq ($(strip ${TEST_NS_MULTI_CORE}),ON)
$(error tfm_invalid_config. TFM_MULTI_CORE_TOPOLOGY = ${TFM_MULTI_CORE_TOPOLOGY}, TEST_NS_MULTI_CORE = ${TEST_NS_MULTI_CORE})
endif
endif

#tfm_invalid_config(TEST_NS_T_COSE AND SYMMETRIC_INITIAL_ATTESTATION)
ifeq ($(strip ${TEST_NS_T_COSE}),ON)
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),ON)
$(error tfm_invalid_config. TEST_NS_T_COSE = ${TEST_NS_T_COSE}, SYMMETRIC_INITIAL_ATTESTATION = ${SYMMETRIC_INITIAL_ATTESTATION})
endif
endif

#tfm_invalid_config((NOT TFM_NS_MANAGE_NSID) AND TEST_NS_MANAGE_NSID)
ifeq ($(strip ${TFM_NS_MANAGE_NSID}),OFF)
ifeq ($(strip ${TEST_NS_MANAGE_NSID}),ON)
$(error tfm_invalid_config. TFM_NS_MANAGE_NSID = ${TFM_NS_MANAGE_NSID}, TEST_NS_MANAGE_NSID = ${TEST_NS_MANAGE_NSID})
endif
endif

# So far all NS regression tests are triggered from NS app
#tfm_invalid_config(NOT NS AND TEST_FRAMEWORK_NS)
ifeq ($(strip ${NS}),OFF)
ifeq ($(strip ${TEST_FRAMEWORK_NS}),ON)
$(error tfm_invalid_config. NS = ${NS}, TEST_FRAMEWORK_NS = ${TEST_FRAMEWORK_NS})
endif
endif

########################## Check suites dependence #############################

#tfm_invalid_config(TEST_NS_PS AND NOT TEST_NS_ITS)
ifeq ($(strip ${TEST_NS_PS}),ON)
ifeq ($(strip ${TEST_NS_ITS}),OFF)
$(error tfm_invalid_config. TEST_NS_PS = ${TEST_NS_PS}, TEST_NS_ITS = ${TEST_NS_ITS})
endif
endif

############################ FLIH/SLIH dependence ##############################

# FLIH and SLIH testing can not be enabled at the same time
#tfm_invalid_config(TEST_NS_SLIH_IRQ AND TEST_NS_FLIH_IRQ)
ifeq ($(strip ${TEST_NS_SLIH_IRQ}),ON)
ifeq ($(strip ${TEST_NS_FLIH_IRQ}),ON)
$(error tfm_invalid_config. TEST_NS_SLIH_IRQ = ${TEST_NS_SLIH_IRQ}, TEST_NS_FLIH_IRQ = ${TEST_NS_FLIH_IRQ})
endif
endif

#tfm_invalid_config(NOT PLATFORM_SLIH_IRQ_TEST_SUPPORT AND TEST_NS_SLIH_IRQ)
ifeq ($(strip ${PLATFORM_SLIH_IRQ_TEST_SUPPORT}),OFF)
ifeq ($(strip ${TEST_NS_SLIH_IRQ}),ON)
$(error tfm_invalid_config. PLATFORM_SLIH_IRQ_TEST_SUPPORT = ${PLATFORM_SLIH_IRQ_TEST_SUPPORT}, TEST_NS_SLIH_IRQ = ${TEST_NS_SLIH_IRQ})
endif
endif

#tfm_invalid_config(NOT PLATFORM_FLIH_IRQ_TEST_SUPPORT AND TEST_NS_FLIH_IRQ)
ifeq ($(strip ${PLATFORM_FLIH_IRQ_TEST_SUPPORT}),OFF)
ifeq ($(strip ${TEST_NS_FLIH_IRQ}),ON)
$(error tfm_invalid_config. PLATFORM_FLIH_IRQ_TEST_SUPPORT = ${PLATFORM_FLIH_IRQ_TEST_SUPPORT}, TEST_NS_FLIH_IRQ = ${TEST_NS_FLIH_IRQ})
endif
endif
