#-------------------------------------------------------------------------------
# Copyright (c) 2021-2022, Arm Limited. All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
#
#-------------------------------------------------------------------------------

########################## NS test framework ###################################

#set(TEST_FRAMEWORK_NS       OFF        CACHE BOOL      "Whether to build NS regression tests framework")
$(eval $(call set_tfm_cache_vars,TEST_FRAMEWORK_NS,OFF))

########################## NS test suites ######################################

#set(TEST_NS_ATTESTATION     OFF        CACHE BOOL      "Whether to build NS regression Attestation tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_ATTESTATION,OFF))
#set(TEST_NS_T_COSE          OFF        CACHE BOOL      "Whether to build NS regression t_cose tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_T_COSE,OFF))
#set(TEST_NS_QCBOR           OFF        CACHE BOOL      "Whether to build NS regression QCBOR tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_QCBOR,OFF))
#set(TEST_NS_CRYPTO          OFF        CACHE BOOL      "Whether to build NS regression Crypto tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_CRYPTO,OFF))
#set(TEST_NS_ITS             OFF        CACHE BOOL      "Whether to build NS regression ITS tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_ITS,OFF))
#set(TEST_NS_PS              OFF        CACHE BOOL      "Whether to build NS regression PS tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_PS,OFF))
#set(TEST_NS_PLATFORM        OFF        CACHE BOOL      "Whether to build NS regression Platform tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_PLATFORM,OFF))
#set(TEST_NS_FWU             OFF        CACHE BOOL      "Whether to build NS regression FWU tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_FWU,OFF))
#set(TEST_NS_IPC             OFF        CACHE BOOL      "Whether to build NS regression IPC tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_IPC,OFF))
#set(TEST_NS_SLIH_IRQ        OFF        CACHE BOOL      "Whether to build NS regression Second-Level Interrupt Handling tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_SLIH_IRQ,OFF))
#set(TEST_NS_FLIH_IRQ        OFF        CACHE BOOL      "Whether to build NS regression First-Level Interrupt Handling tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_FLIH_IRQ,OFF))
#set(TEST_NS_MULTI_CORE      OFF        CACHE BOOL      "Whether to build NS regression multi-core tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_MULTI_CORE,OFF))
#set(TEST_NS_MANAGE_NSID     OFF        CACHE BOOL      "Whether to build NS regression NSID management tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_MANAGE_NSID,OFF))
#set(TEST_NS_SFN_BACKEND     OFF        CACHE BOOL      "Whether to build NS regression SFN backend tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_SFN_BACKEND,OFF))
#set(TEST_NS_FPU             OFF        CACHE BOOL      "Whether to build NS regression FPU tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_FPU,OFF))

########################## S test framework ####################################

#set(TEST_FRAMEWORK_S        OFF        CACHE BOOL      "Whether to build S regression tests framework")
$(eval $(call set_tfm_cache_vars,TEST_FRAMEWORK_S,OFF))

########################## S test suites #######################################

#set(TEST_S_ATTESTATION      OFF        CACHE BOOL      "Whether to build S regression Attestation tests")
$(eval $(call set_tfm_cache_vars,TEST_S_ATTESTATION,OFF))
#set(TEST_S_CRYPTO           OFF        CACHE BOOL      "Whether to build S regression Crypto tests")
$(eval $(call set_tfm_cache_vars,TEST_S_CRYPTO,OFF))
#set(TEST_S_ITS              OFF        CACHE BOOL      "Whether to build S regression ITS tests")
$(eval $(call set_tfm_cache_vars,TEST_S_ITS,OFF))
#set(TEST_S_PS               OFF        CACHE BOOL      "Whether to build S regression PS tests")
$(eval $(call set_tfm_cache_vars,TEST_S_PS,OFF))
#set(TEST_S_PLATFORM         OFF        CACHE BOOL      "Whether to build S regression Platform tests")
$(eval $(call set_tfm_cache_vars,TEST_S_PLATFORM,OFF))
#set(TEST_S_FWU              OFF        CACHE BOOL      "Whether to build S regression FWU tests")
$(eval $(call set_tfm_cache_vars,TEST_S_FWU,OFF))
#set(TEST_S_IPC              OFF        CACHE BOOL      "Whether to build S regression IPC tests")
$(eval $(call set_tfm_cache_vars,TEST_S_IPC,OFF))
#set(TEST_S_SFN_BACKEND      OFF        CACHE BOOL      "Whether to build S regression SFN tests")
$(eval $(call set_tfm_cache_vars,TEST_S_SFN_BACKEND,OFF))

################################## PS Tests ####################################

#set(PS_TEST_NV_COUNTERS                 ON          CACHE BOOL      "Use the test NV counters to test Protected Storage rollback scenarios")
$(eval $(call set_tfm_cache_vars,PS_TEST_NV_COUNTERS,ON))

################################## Default CRYPTO Tests ########################

#set(TFM_CRYPTO_TEST_ALG_CBC                     ON       CACHE BOOL      "Test CBC cryptography mode")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_CBC,ON))
#set(TFM_CRYPTO_TEST_ALG_CCM                     ON       CACHE BOOL      "Test CCM cryptography mode")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_CCM,ON))
#set(TFM_CRYPTO_TEST_ALG_CFB                     ON       CACHE BOOL      "Test CFB cryptography mode")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_CFB,ON))
#set(TFM_CRYPTO_TEST_ALG_ECB                     ON       CACHE BOOL      "Test ECB cryptography mode")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_ECB,ON))
#set(TFM_CRYPTO_TEST_ALG_CTR                     ON       CACHE BOOL      "Test CTR cryptography mode")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_CTR,ON))
#set(TFM_CRYPTO_TEST_ALG_OFB                     ON       CACHE BOOL      "Test OFB cryptography mode")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_OFB,ON))
#set(TFM_CRYPTO_TEST_ALG_GCM                     ON       CACHE BOOL      "Test GCM cryptography mode")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_GCM,ON))
#set(TFM_CRYPTO_TEST_ALG_SHA_384                 ON       CACHE BOOL      "Test SHA-384 cryptography algorithm")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_SHA_384,ON))
#set(TFM_CRYPTO_TEST_ALG_SHA_512                 ON       CACHE BOOL      "Test SHA-512 cryptography algorithm")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_SHA_512,ON))
#set(TFM_CRYPTO_TEST_HKDF                        ON       CACHE BOOL      "Test the HKDF key derivation algorithm")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_HKDF,ON))
#set(TFM_CRYPTO_TEST_ECDH                        ON       CACHE BOOL      "Test the ECDH key agreement algorithm")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ECDH,ON))
#set(TFM_CRYPTO_TEST_CHACHA20                    OFF      CACHE BOOL      "Test the ChaCha20 stream cipher")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_CHACHA20,OFF))
#set(TFM_CRYPTO_TEST_ALG_CHACHA20_POLY1305       OFF      CACHE BOOL      "Test ChaCha20-Poly1305 AEAD algorithm")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_CHACHA20_POLY1305,OFF))
#set(TFM_CRYPTO_TEST_ALG_RSASSA_PSS_VERIFICATION ON       CACHE BOOL      "Test RSASSA-PSS signature verification algorithm")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_ALG_RSASSA_PSS_VERIFICATION,ON))
#set(TFM_CRYPTO_TEST_SINGLE_PART_FUNCS           ON       CACHE BOOL      "Test single-part operations in hash, MAC, AEAD and symmetric ciphers")
$(eval $(call set_tfm_cache_vars,TFM_CRYPTO_TEST_SINGLE_PART_FUNCS,ON))

################################## FWU Tests ###################################

#set(TFM_FWU_TEST_REQUEST_REBOOT         OFF         CACHE BOOL      "Test psa_fwu_request_reboot")
$(eval $(call set_tfm_cache_vars,TFM_FWU_TEST_REQUEST_REBOOT,OFF))
#set(TFM_FWU_TEST_WRITE_WITH_NULL        OFF         CACHE BOOL      "Test psa_fwu_write with data block NULL")
$(eval $(call set_tfm_cache_vars,TFM_FWU_TEST_WRITE_WITH_NULL,OFF))
#set(TFM_FWU_TEST_QUERY_WITH_NULL        OFF         CACHE BOOL      "Test psa_fwu_query with info NULL")
$(eval $(call set_tfm_cache_vars,TFM_FWU_TEST_QUERY_WITH_NULL,OFF))

############################################ FPU Tests #########################

#set(TEST_S_FPU                          OFF         CACHE BOOL      "Whether to build S regression FPU tests")
$(eval $(call set_tfm_cache_vars,TEST_S_FPU,OFF))

################################## Extra test suites ###########################

#set(EXTRA_NS_TEST_SUITE_PATH            ""          CACHE PATH      "List of extra non-secure test suites directories. An extra test suite folder contains source code, CMakeLists.txt and cmake configuration file")
$(eval $(call set_tfm_cache_vars,EXTRA_NS_TEST_SUITE_PATH,))
#set(EXTRA_S_TEST_SUITE_PATH             ""          CACHE PATH      "List of extra secure test suites directories. An extra test suite folder contains source code, CMakeLists.txt and cmake configuration file")
$(eval $(call set_tfm_cache_vars,EXTRA_S_TEST_SUITE_PATH,))

######################### Platform specific setting ############################

#set(PLATFORM_SLIH_IRQ_TEST_SUPPORT      OFF         CACHE BOOL    "Platform supports SLIH IRQ tests")
$(eval $(call set_tfm_cache_vars,PLATFORM_SLIH_IRQ_TEST_SUPPORT,OFF))
#set(PLATFORM_FLIH_IRQ_TEST_SUPPORT      OFF         CACHE BOOL    "Platform supports FLIH IRQ tests")
$(eval $(call set_tfm_cache_vars,PLATFORM_FLIH_IRQ_TEST_SUPPORT,OFF))

