#-------------------------------------------------------------------------------
# Copyright (c) 2021-2022, Arm Limited. All rights reserved.
# Copyright (c) 2022 Cypress Semiconductor Corporation (an Infineon company)
# or an affiliate of Cypress Semiconductor Corporation. All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
#
#-------------------------------------------------------------------------------

#set(CONFIG_TFM_USE_TRUSTZONE          ON    CACHE BOOL    "Enable use of TrustZone to transition between NSPE and SPE")
$(eval $(call set_tfm_cache_vars,CONFIG_TFM_USE_TRUSTZONE,ON))
#set(TFM_MULTI_CORE_TOPOLOGY           OFF   CACHE BOOL    "Whether to build for a dual-cpu architecture")
$(eval $(call set_tfm_cache_vars,TFM_MULTI_CORE_TOPOLOGY,OFF))

#set(PLATFORM_SLIH_IRQ_TEST_SUPPORT    ON    CACHE BOOL    "Platform supports SLIH IRQ tests")
$(eval $(call set_tfm_cache_vars,PLATFORM_SLIH_IRQ_TEST_SUPPORT,ON))
#set(PLATFORM_FLIH_IRQ_TEST_SUPPORT    ON    CACHE BOOL    "Platform supports FLIH IRQ tests")
$(eval $(call set_tfm_cache_vars,PLATFORM_FLIH_IRQ_TEST_SUPPORT,ON))

## Make FLIH IRQ test as the default IRQ test on Corstone-310
#set(TEST_NS_SLIH_IRQ                  OFF   CACHE BOOL    "Whether to build NS regression Second-Level Interrupt Handling tests")
$(eval $(call set_tfm_cache_vars,TEST_NS_SLIH_IRQ,OFF))

#if(BL2)
#    set(BL2_TRAILER_SIZE 0x800 CACHE STRING "Trailer size")
#else()
#    #No header if no bootloader, but keep IMAGE_CODE_SIZE the same
#    set(BL2_TRAILER_SIZE 0xC00 CACHE STRING "Trailer size")
#endif()
ifeq ($(strip ${BL2}),ON)
$(eval $(call set_tfm_cache_vars,BL2_TRAILER_SIZE,0x800))
else
$(eval $(call set_tfm_cache_vars,BL2_TRAILER_SIZE,0xC00))
endif

#set(PLATFORM_HAS_ISOLATION_L3_SUPPORT   ON          CACHE BOOL      "Platform supports Isolation level 3")
$(eval $(call set_tfm_cache_vars,PLATFORM_HAS_ISOLATION_L3_SUPPORT,ON))
#set(TFM_EXTRA_GENERATED_FILE_LIST_PATH  ${CMAKE_CURRENT_SOURCE_DIR}/platform/ext/target/arm/mps3/an552/generated_file_list.yaml  CACHE PATH "Path to extra generated file list. Appended to stardard TFM generated file list." FORCE)
#$(eval $(call set_tfm_cache_vars_force,TFM_EXTRA_GENERATED_FILE_LIST_PATH,${TFM_ROOT}/platform/ext/target/arm/an552_hx/generated_file_list.yaml))
