/*
 * Copyright (c) 2019-2022, Arm Limited. All rights reserved.
 * Copyright (c) 2020, Cypress Semiconductor Corporation. All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 *
 */

#ifndef __TFM_PERIPHERALS_DEF_H__
#define __TFM_PERIPHERALS_DEF_H__

#include "platform_irq.h"
#include "target_cfg.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Quantized default IRQ priority, the value is:
 * (Number of configurable priority) / 4: (1UL << __NVIC_PRIO_BITS) / 4
 */
#define DEFAULT_IRQ_PRIORITY    (1UL << (__NVIC_PRIO_BITS - 2))

//#define TFM_TIMER0_IRQ           (TIMER0_IRQn)
//#define TFM_TIMER1_IRQ           (TIMER1_IRQn)
//#define TFM_TIMER0_IRQ           (TIMER0INT_IRQn) //YX 20230202 porting
#define TFM_TIMER2_IRQ           (TIMER2INT_IRQn) //YX 20230503 porting

//#define TFM_FPU_S_TEST_IRQ       (GPIO0_0_IRQn)
//#define TFM_FPU_NS_TEST_IRQ      (GPIO0_1_IRQn)
#define TFM_FPU_S_TEST_IRQ       (FPIXC_IRQn) //YX 20230202 porting
#define TFM_FPU_NS_TEST_IRQ      (FPIDC_IRQn)
//FPIXC_IRQn = 8,
//FPIDC_IRQn = 9,

extern struct platform_data_t tfm_peripheral_timer;
extern struct platform_data_t tfm_peripheral_std_uart;

#define TFM_PERIPHERAL_TIMER           (&tfm_peripheral_timer)
#define TFM_PERIPHERAL_STD_UART         (&tfm_peripheral_std_uart)

#ifdef __cplusplus
}
#endif

#endif /* __TFM_PERIPHERALS_DEF_H__ */
