# Collect header
TFM_INC_DIR = 

# Collect c/asm/cpp source
TFM_CSRCS =
TFM_ASMSRCS =
TFM_CXXSRCS =
TFM_CCSRCS =

# Collect objs from c/asm/cpp source
TFM_COBJS =
TFM_ASMOBJS =
TFM_CXXOBJS =
TFM_CCOBJS =

# Linker
TFM_LIBS =
TFM_OBJS =

# ----------------------------- S ---------------------------------------
ifeq ($(strip ${BUILD_TFM_NS}),OFF)
ifeq ($(strip ${TFM_PARTITION_CRYPTO}),ON)
include ${TFM_ROOT}/tools/platform_crypto_keys.mk
endif
include ${TFM_ROOT}/tools/${TFM_PLATFORM}/platform_s.mk
include ${TFM_ROOT}/tools/${TFM_PLATFORM}/tfm_s.mk
include ${TFM_ROOT}/tools/tfm_t_cose_s.mk
include ${TFM_ROOT}/tools/tfm_qcbor_s.mk
include ${TFM_ROOT}/tools/tfm_partitions.mk
ifeq ($(strip ${TEST_S}),ON)
include ${TFM_ROOT}/tools/tfm_s_tests.mk
endif
#include ${TFM_ROOT}/tools/tfm_secure_api.mk
include ${TFM_ROOT}/tools/${TFM_PLATFORM}/tfm_sprt.mk
include ${TFM_ROOT}/tools/tfm_spm.mk
include ${TFM_ROOT}/tools/tfm_fih.mk
ifeq ($(strip ${TFM_PARTITION_CRYPTO}),ON)
ifeq ($(strip ${CRYPTO_HW_ACCELERATOR}),ON)
include ${TFM_ROOT}/tools/crypto_service_cc312.mk
ifeq ($(strip ${CC312_LEGACY_DRIVER_API_ENABLED}),ON)
include ${TFM_ROOT}/tools/crypto_service_cc312_mbedtls_api.mk
else
include ${TFM_ROOT}/tools/crypto_service_cc312_psa_driver_api.mk
endif
include ${TFM_ROOT}/tools/crypto_service_cc312_pal.mk
include ${TFM_ROOT}/tools/crypto_service_crypto_hw.mk
endif #ifeq ($(strip ${CRYPTO_HW_ACCELERATOR}),ON)
#mbedcrypto_static_target
#include ${TFM_ROOT}/tools/mbedtls.mk
#mbedx509_static_target
#include ${TFM_ROOT}/tools/mbedx509.mk
#mbedtls_static_target
include ${TFM_ROOT}/tools/mbedcrypto.mk
endif #ifeq ($(strip ${TFM_PARTITION_CRYPTO}),ON)

ifeq ($(strip ${TFM_PARTITION_SFN_BACKEND_TEST}),ON)
include ${TFM_ROOT}/tools/tfm_app_rot_partition_sfn_backend_test.mk
endif
ifeq ($(strip ${TFM_PARTITION_PLATFORM}),ON)
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_platform.mk
endif
ifeq ($(strip ${TFM_PARTITION_PROTECTED_STORAGE}),ON)
include ${TFM_ROOT}/tools/tfm_app_rot_partition_ps.mk
endif
ifeq ($(strip ${TFM_PARTITION_INTERNAL_TRUSTED_STORAGE}),ON)
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_its.mk
endif
ifeq ($(strip ${TFM_PARTITION_INITIAL_ATTESTATION}),ON)
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_attestation.mk
endif
ifeq ($(strip ${TFM_PARTITION_CRYPTO}),ON)
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_crypto.mk
endif
#ifeq ($(strip ${TFM_PARTITION_PSA_PROXY}),ON) #1.7.0 has no
#include ${TFM_ROOT}/tools/tfm_psa_rot_partition_psa_proxy.mk
#endif
ifeq ($(strip ${TFM_PARTITION_FIRMWARE_UPDATE}),ON)
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_fwu.mk
endif

ifeq ($(strip ${TEST_NS_SLIH_IRQ}),ON)
include ${TFM_ROOT}/tools/tfm_app_rot_partition_slih_test.mk
endif
ifeq ($(strip ${TEST_NS_FLIH_IRQ}),ON)
include ${TFM_ROOT}/tools/tfm_app_rot_partition_flih_test.mk
endif

ifeq ($(strip ${TFM_PARTITION_HX}),ON)
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_hx.mk
endif

#ifeq ($(strip ${TEST_NS_CORE}),ON) 1.7.0 has no
#include ${TFM_ROOT}/tools/tfm_psa_rot_partition_core_test.mk
#include ${TFM_ROOT}/tools/tfm_app_rot_partition_core_test_2.mk
#endif
ifeq ($(strip ${TEST_S_FPU}),ON)
include ${TFM_ROOT}/tools/tfm_app_rot_partition_fpu_service.mk
#YX 20230112 Modfiy TFM_SP_FPU_SERVICE_TEST type to PSA-ROT for fpu_interrupt_trigger trigger TFM_FPU_NS_TEST_IRQ
#include ${TFM_ROOT}/tools/tfm_psa_rot_partition_fpu_service.mk
endif
#ifeq ($(strip ${TFM_PARTITION_AUDIT_LOG}),ON)
#include ${TFM_ROOT}/tools/tfm_psa_rot_partition_audit.mk #1.7.0 has no
#endif
#lib\ext\tfm_test_repo-src\test\secure_tests.cmake
#if (TEST_S_CRYPTO)
#    add_library(tfm_test_suite_crypto_s STATIC EXCLUDE_FROM_ALL)
#endif()
ifeq ($(strip ${TEST_S_CRYPTO}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_crypto_s.mk
endif
#if (TEST_S_ATTESTATION)
#    add_library(tfm_test_suite_attestation_s STATIC EXCLUDE_FROM_ALL)
#endif()
ifeq ($(strip ${TEST_S_ATTESTATION}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_attestation_s.mk
endif
#if (TEST_S_ITS)
#    add_library(tfm_test_suite_its_s STATIC EXCLUDE_FROM_ALL)
#endif()
ifeq ($(strip ${TEST_S_ITS}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_its_s.mk
endif
#if (TEST_S_PS)
#    add_library(tfm_test_suite_ps_s STATIC EXCLUDE_FROM_ALL)
#endif()
ifeq ($(strip ${TEST_S_PS}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_ps_s.mk
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_ps_test.mk
endif
#if (TEST_S_PLATFORM)
#    add_library(tfm_test_suite_platform_s STATIC EXCLUDE_FROM_ALL)
#endif()
ifeq ($(strip ${TEST_S_PLATFORM}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_platform_s.mk
endif
#if (TEST_S_IPC)
#    add_library(tfm_test_suite_ipc_s STATIC EXCLUDE_FROM_ALL)
#endif()
ifeq ($(strip ${TEST_S_IPC}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_ipc_s.mk
endif
#if (TEST_S_FWU)
#    add_library(tfm_test_suite_fwu_s STATIC EXCLUDE_FROM_ALL)
#endif()
ifeq ($(strip ${TEST_S_FWU}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_fwu_s.mk
endif
#if (TEST_S_FPU)
#    add_library(tfm_test_suite_fpu_s STATIC EXCLUDE_FROM_ALL)
#endif()
ifeq ($(strip ${TEST_S_FPU}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_fpu_s.mk
endif
#ifeq ($(strip ${TEST_S_AUDIT}),ON)
#include ${TFM_ROOT}/tools/tfm_test_suite_audit_s.mk #1.7.0 has no
#endif
ifeq ($(strip ${TFM_PARTITION_IPC_TEST}),ON)
include ${TFM_ROOT}/tools/tfm_app_rot_partition_ipc_client.mk
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_ipc_service.mk
endif
ifeq ($(strip ${TEST_FRAMEWORK_S}),ON)
include ${TFM_ROOT}/tools/tfm_app_rot_partition_secure_client_2.mk
include ${TFM_ROOT}/tools/tfm_psa_rot_partition_secure_client_service.mk
endif
ifeq ($(strip ${TEST_S_SFN_BACKEND}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_sfn_s.mk
endif
else

# ----------------------------- NS ---------------------------------------
include ${TFM_ROOT}/tools/CMSIS_5_tfm_ns.mk
ifeq ($(strip ${TEST_NS}),ON)
include ${TFM_ROOT}/tools/tfm_ns_tests.mk
endif
include ${TFM_ROOT}/tools/tfm_log.mk
include ${TFM_ROOT}/tools/tfm_api_ns.mk
ifeq ($(strip ${TEST_NS_MANAGE_NSID}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_nsid.mk
endif
ifeq ($(strip ${TFM_MULTI_CORE_TOPOLOGY}),OFF)
include ${TFM_ROOT}/tools/${TFM_PLATFORM}/platform_ns.mk
endif
ifeq ($(strip ${TEST_NS_SFN_BACKEND}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_sfn_ns.mk
endif
ifeq ($(strip ${TEST_NS}),ON)
include ${TFM_ROOT}/tools/tfm_t_cose_ns.mk
include ${TFM_ROOT}/tools/tfm_qcbor_ns.mk
ifeq ($(strip ${TEST_NS_IPC}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_ipc_ns.mk
endif
ifeq ($(strip ${TEST_NS_ATTESTATION}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_attestation_ns.mk
endif
ifeq ($(strip ${TEST_NS_CRYPTO}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_crypto_ns.mk
endif
ifeq ($(strip ${TEST_NS_ITS}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_its_ns.mk
endif
ifeq ($(strip ${TEST_NS_PS}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_ps_ns.mk
endif
#ifeq ($(strip ${TEST_NS_AUDIT}),ON)
#include ${TFM_ROOT}/tools/tfm_test_suite_audit_ns.mk 1.7.0 has no
#endif
ifeq ($(strip ${TEST_NS_PLATFORM}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_platform_ns.mk
endif
ifeq ($(strip ${TEST_NS_T_COSE}),ON)
include ${TFM_ROOT}/tools/tfm_t_cose_test.mk
include ${TFM_ROOT}/tools/tfm_test_suite_t_cose_ns.mk
endif
ifeq ($(strip ${TEST_NS_QCBOR}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_qcbor_ns.mk
include ${TFM_ROOT}/tools/tfm_qcbor_test.mk
endif
#ifeq ($(strip ${TEST_NS_CORE}),ON) 1.7.0 has no
#include ${TFM_ROOT}/tools/tfm_test_suite_core_ns.mk
#endif
endif
ifeq ($(strip ${TEST_NS_FPU}),ON)
include ${TFM_ROOT}/tools/tfm_test_suite_fpu_ns.mk
endif
ifneq ($(findstring ON,$(strip ${TEST_NS_SLIH_IRQ}) $(strip ${TEST_NS_FLIH_IRQ})),) # OR logic
include ${TFM_ROOT}/tools/tfm_test_suite_irq.mk
endif
#include ${TFM_ROOT}/tools/tfm_ns_integration_test.mk #1.7.0 has no
include ${TFM_ROOT}/tools/${TFM_PLATFORM}/tfm_ns.mk
include ${TFM_ROOT}/tools/tfm_test_app.mk
#lib\ext\tfm_test_repo-src\app\CMakeLists.txt
## Include NS local interface headers
#target_include_directories(tfm_ns_interface
#    INTERFACE
#        ${NS_INTERFACE_DIR}
#        ${NSID_MGR_DIR}
#)
TFM_INC_DIR += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/ns_interface
TFM_INC_DIR += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/ns_interface/ns_client_ext
endif

# ----------------------------- S/NS ---------------------------------------
ifneq ($(findstring ON,$(strip ${TEST_S}) $(strip ${TEST_NS})),) # OR logic
include ${TFM_ROOT}/tools/tfm_test_framework_common.mk
endif
#ifeq ($(strip ${TFM_SP_LOG_RAW_ENABLED}),ON)
#include ${TFM_ROOT}/tools/tfm_sp_log_raw.mk #1.7.0 has no
#endif

#For TFM_MBEDCRYPTO_CONFIG_PATH
TFM_INC_DIR += ${TFM_ROOT}/lib/ext/mbedcrypto/mbedcrypto_config
#For PROJECT_CONFIG_HEADER_FILE
TFM_INC_DIR += ${TFM_ROOT}/config/profile
TFM_INC_DIR += ${TFM_ROOT}/config

#fih\CMakeLists.txt
#target_include_directories(tfm_fih_headers
#    INTERFACE
#        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc>
#)
TFM_INC_DIR += ${TFM_ROOT}/lib/fih/inc

#target_include_directories(tfm_qcbor_s
#    PUBLIC
#        $<BUILD_INTERFACE:${QCBOR_PATH}/inc>
#    INTERFACE
#        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
#        $<BUILD_INTERFACE:${QCBOR_PATH}/inc/qcbor>
#)
#TFM_INC_DIR += ${TFM_ROOT}/lib/ext/qcbor-src/inc
#TFM_INC_DIR += ${TFM_ROOT}/lib/ext/qcbor
#TFM_INC_DIR += ${TFM_ROOT}/lib/ext/qcbor-src/inc/qcbor

#secure_fw\spm\CMakeLists.txt
#target_include_directories(tfm_spm_defs
#    INTERFACE
#        ${CMAKE_CURRENT_SOURCE_DIR}/cmsis_psa
#        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
#        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/boot>
#        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/interface>
#        ${CMAKE_CURRENT_SOURCE_DIR}/cmsis_psa/arch
#)
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/cmsis_psa
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/include
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/include/boot
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/include/interface
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/cmsis_psa/arch

#secure_fw\spm\CMakeLists.txt
#target_include_directories(tfm_spm
#    PUBLIC
#        ${CMAKE_CURRENT_SOURCE_DIR}
#        ${CMAKE_CURRENT_SOURCE_DIR}/include
#        ${CMAKE_CURRENT_SOURCE_DIR}/cmsis_psa
#        ${CMAKE_CURRENT_SOURCE_DIR}/cmsis_psa/include
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/include
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/cmsis_psa
#TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/cmsis_psa/include

#secure_fw\partitions\lib\runtime\CMakeLists.txt
#target_include_directories(tfm_sprt
#    PUBLIC
#        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
#        ${CMAKE_SOURCE_DIR}/secure_fw/include
#)
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/lib/runtime/include
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/include

#secure_fw\CMakeLists.txt
#target_include_directories(tfm_config
#    INTERFACE
#        ${CMAKE_CURRENT_SOURCE_DIR}/include
#        ${CMAKE_CURRENT_SOURCE_DIR}/partitions/crypto
#        ${CMAKE_CURRENT_SOURCE_DIR}/partitions/firmware_update
#        ${CMAKE_CURRENT_SOURCE_DIR}/partitions/initial_attestation
#        ${CMAKE_CURRENT_SOURCE_DIR}/partitions/internal_trusted_storage
#        ${CMAKE_CURRENT_SOURCE_DIR}/partitions/platform
#        ${CMAKE_CURRENT_SOURCE_DIR}/partitions/protected_storage
#        ${CMAKE_CURRENT_SOURCE_DIR}/spm/include
#        ${CMAKE_BINARY_DIR}/generated/interface/include
#)
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/include
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/crypto
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/firmware_update
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/initial_attestation
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/internal_trusted_storage
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/platform
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/protected_storage
#TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/audit_logging
#TFM_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/psa_proxy
TFM_INC_DIR += ${TFM_ROOT}/secure_fw/spm/include
TFM_INC_DIR += ${TFM_ROOT}/generated/interface/include


TFM_INC_DIR += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/spm/common
TFM_INC_DIR += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/spm/common/suites
TFM_INC_DIR += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/spm/common/service
ifeq ($(strip ${BUILD_TFM_NS}),ON)
ifeq ($(strip ${TEST_NS_FLIH_IRQ}),ON)
TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/spm/irq/service/tfm_flih_test_service
endif
ifeq ($(strip ${TEST_NS_SLIH_IRQ}),ON)
TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/spm/irq/service/tfm_slih_test_service
endif
ifeq ($(strip ${TEST_PARTITION_FPU_TEST}),ON)
TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/fpu
endif
ifeq ($(strip ${TFM_PARTITION_IPC_TEST}),ON)
TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/spm/ipc/service/tfm_ipc_client
TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/spm/ipc/service/tfm_ipc_service
endif
ifeq ($(strip ${TEST_S_PS}),ON)
TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/ps/service
endif
ifeq ($(strip ${TEST_FRAMEWORK_S}),ON)
TFM_INC_DIR += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/common_test_services/tfm_secure_client_2
TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/common_test_services/tfm_secure_client_service
endif
#ifeq ($(strip ${TEST_NS_CORE}),ON) 1.7.0 has no
#TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/core/service/tfm_core_test_2
#TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/core/service/tfm_core_test
#endif
ifeq ($(strip ${TFM_PARTITION_SFN_BACKEND_TEST}),ON)
#TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/test_services/tfm_test_sfn_partitions
TFM_INC_DIR +=${TFM_ROOT}/lib/ext/tfm_test_repo-src/test/secure_fw/suites/spm/sfn/service/sfn_backend_test_partition
endif
endif

#platform\CMakeLists.txt
#target_include_directories(platform_common_interface
#    INTERFACE
#        ./ext
#        ./ext/cmsis
#        ./ext/common
#        ./ext/driver
#        ./include
#)
TFM_INC_DIR += ${TFM_ROOT}/platform/ext
####TFM_INC_DIR += ${TFM_ROOT}/platform/ext/cmsis
TFM_INC_DIR += ${TFM_ROOT}/platform/ext/common
TFM_INC_DIR += ${TFM_ROOT}/platform/ext/common/template
TFM_INC_DIR += ${TFM_ROOT}/platform/ext/driver
TFM_INC_DIR += ${TFM_ROOT}/platform/include

#lib\ext\tfm_test_repo-src\app\CMakeLists.txt
## Include interface headers exported by TF-M
#target_include_directories(tfm_ns_interface
#    INTERFACE
#        ${INTERFACE_INC_DIR}
#        ${CMAKE_BINARY_DIR}/generated/interface/include
#        $<$<BOOL:${TFM_PARTITION_NS_AGENT_MAILBOX}>:${INTERFACE_INC_DIR}/multi_core>
#)
TFM_INC_DIR += ${TFM_ROOT}/interface/include
TFM_INC_DIR += ${TFM_ROOT}/generated/interface/include
ifeq ($(strip ${TFM_MULTI_CORE_TOPOLOGY}),ON)
TFM_INC_DIR += ${TFM_ROOT}/interface/include/multi_core
endif

ifeq ($(strip ${BUILD_TFM_NS}),ON)

ifneq ($(strip ${TFM_NS_RTOS2_WRAPPER}),BARE_METAL)
ifeq ($(findstring $(strip ${OS_SEL}),TFM_NS_RTX freertos),) 
$(error OS_SEL = ${OS_SEL})
endif
endif
ifeq ($(findstring $(strip ${TOOLCHAIN}),arm gnu),) # OR logic
$(error TOOLCHAIN = ${TOOLCHAIN})
endif
ifeq ($(strip ${TFM_NS_RTOS2_WRAPPER}),RTOS2_RTX)
ifeq ($(strip ${TOOLCHAIN}),arm)
ifeq ($(strip ${CONFIG_TFM_FLOAT_ABI}),hard)
TFM_LIBS += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/CMSIS/RTOS2/RTX/Library/ARM/RTX_V8MMFN.lib
else ifeq ($(strip ${CONFIG_TFM_FLOAT_ABI}),soft)
TFM_LIBS += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/CMSIS/RTOS2/RTX/Library/ARM/RTX_V8MMN.lib
endif
else ifeq ($(strip ${TOOLCHAIN}),gnu)
ifeq ($(strip ${CONFIG_TFM_FLOAT_ABI}),hard)
TFM_LIBS += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/CMSIS/RTOS2/RTX/Library/GCC/libRTX_V8MMFN.a
else ifeq ($(strip ${CONFIG_TFM_FLOAT_ABI}),soft)
TFM_LIBS += ${TFM_ROOT}/lib/ext/tfm_test_repo-src/CMSIS/RTOS2/RTX/Library/GCC/libRTX_V8MMN.a
endif
endif
endif #ifeq ($(strip ${TFM_NS_RTOS2_WRAPPER}),RTOS2_RTX)

else

ifneq ($(strip $(OS_SEL)),TFM_SPM)
$(error OS_SEL = ${OS_SEL})
endif

endif #ifeq ($(strip ${BUILD_TFM_NS}),ON)

#target_link_libraries(CMSIS_5_tfm_ns
#    INTERFACE
#        $<$<C_COMPILER_ID:ARMClang>:CMSIS_5_RTX_V8MMN>
#        $<$<AND:$<C_COMPILER_ID:GNU>,$<STREQUAL:${CONFIG_TFM_FLOAT_ABI},hard>>:CMSIS_5_RTX_V8MMFN>
#        $<$<AND:$<C_COMPILER_ID:GNU>,$<STREQUAL:${CONFIG_TFM_FLOAT_ABI},soft>>:CMSIS_5_RTX_V8MMN>
#        $<$<C_COMPILER_ID:IAR>:CMSIS_5_RTX_V81MMN>
#)
#target_link_libraries(CMSIS_5_tfm_ns
#    INTERFACE
#        $<$<C_COMPILER_ID:ARMClang>:CMSIS_5_RTX_V8MMN>
#        $<$<AND:$<C_COMPILER_ID:GNU>,$<OR:$<BOOL:${CONFIG_TFM_ENABLE_FP}>,$<BOOL:${CONFIG_TFM_ENABLE_MVE_FP}>>>:CMSIS_5_RTX_V8MMFN>
#        $<$<AND:$<C_COMPILER_ID:GNU>,$<NOT:$<OR:$<BOOL:${CONFIG_TFM_ENABLE_FP}>,$<BOOL:${CONFIG_TFM_ENABLE_MVE_FP}>>>>:CMSIS_5_RTX_V8MMN>
#        $<$<C_COMPILER_ID:IAR>:CMSIS_5_RTX_V81MMN>
#)

# nsc func need pwrmgmt/spi_eeprom/spi_psram header
TFM_INC_DIR += $(EPII_ROOT)/library/pwrmgmt
TFM_INC_DIR += $(EPII_ROOT)/library/spi_eeprom
TFM_INC_DIR += $(EPII_ROOT)/library/spi_psram

# Sort header
TFM_INC_DIR := $(sort ${TFM_INC_DIR})
TFM_OBJS := $(sort ${TFM_OBJS})

# Collect all c/asm/cpp directories
TFM_CSRC_DIR = $(sort $(dir ${TFM_CSRCS}))
TFM_ASMSRC_DIR = $(sort $(dir ${TFM_ASMSRCS}))
TFM_CCSRC_DIR = $(sort $(dir ${TFM_CXXSRCS}))
TFM_CXXSRCS_DIR = $(sort $(dir ${TFM_CCSRCS}))
