# directory declaration
TFM_S_INC_DIR = ${TFM_ROOT}
TFM_S_CSRCS =
TFM_S_ASMSRCS =
TFM_S_CXXSRCS =
TFM_S_CCSRCS =

#platform\CMakeLists.txt
## If this is not added to the tfm_s it will not correctly override the weak
## default handlers declared in assemebly, and will instead be discarded as they
## are not in use.
#target_sources(tfm_s
#    PRIVATE
#        ext/common/faults.c
#        $<$<OR:$<BOOL:${TEST_S_FPU}>,$<BOOL:${TEST_NS_FPU}>>:${CMAKE_SOURCE_DIR}/platform/ext/common/test_interrupt.c>
#)
TFM_S_CSRCS += ${TFM_ROOT}/platform/ext/common/faults.c
ifneq ($(findstring ON,$(strip ${TEST_S_FPU}) $(strip ${TEST_NS_FPU})),) # OR logic
TFM_S_CSRCS += ${TFM_ROOT}/platform/ext/common/test_interrupt.c
endif

#platform\ext\target\arm\an552_hx\CMakeLists.txt
## Specify the location of platform specific build dependencies.
#target_sources(tfm_s
#    PRIVATE
#    ${CMAKE_CURRENT_SOURCE_DIR}/device/source/startup_an552.c
#)
#TFM_S_CSRCS += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/device/source/startup_an552_cfile.c
TFM_S_CCSRCS += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/device/source/startup_an552.cc #YX 20230315

#secure_fw\partitions\ns_agent_tz\CMakeLists.txt
## If this is added to the spm, it is discarded as it is not used. Since the
## spm is a static library it can't generate veneers under all compilers so
## instead this single file is added to the 'tfm_s' target.
#target_sources(tfm_s
#    PRIVATE
#        "$<$<IN_LIST:${TFM_SYSTEM_ARCHITECTURE},${ARM_V80M_ARCH}>:${CMAKE_CURRENT_SOURCE_DIR}/psa_api_veneers_v80m.c>"
#        "$<$<NOT:$<IN_LIST:${TFM_SYSTEM_ARCHITECTURE},${ARM_V80M_ARCH}>>:${CMAKE_CURRENT_SOURCE_DIR}/psa_api_veneers.c>"
#)
#set(ARM_V80M_ARCH armv8-m.base armv8-m.main)
ifneq ($(findstring $(strip ${TFM_SYSTEM_ARCHITECTURE}),$(strip ${ARM_V80M_ARCH})),) # OR logic
TFM_S_CSRCS += ${TFM_ROOT}/secure_fw/partitions/ns_agent_tz/psa_api_veneers_v80m.c
else
TFM_S_CSRCS += ${TFM_ROOT}/secure_fw/partitions/ns_agent_tz/psa_api_veneers.c
endif

#if(CONFIG_TFM_USE_TRUSTZONE)
#    # If this is added to the spm, it is discarded as it is not used. Since the
#    # spm is a static library it can't generate veneers under all compilers so
#    # instead this single file is added to the tfm_s target.
#    target_sources(tfm_s
#        PRIVATE
#            $<$<BOOL:${TFM_NS_MANAGE_NSID}>:${CMAKE_CURRENT_SOURCE_DIR}/ns_client_ext/tfm_ns_client_ext.c>
#    )
#endif()
ifeq ($(strip ${CONFIG_TFM_USE_TRUSTZONE}),ON)
ifeq ($(strip ${TFM_NS_MANAGE_NSID}),ON)
#secure_fw\spm\CMakeLists.txt
TFM_S_CSRCS += ${TFM_ROOT}/secure_fw/spm/ns_client_ext/tfm_ns_client_ext.c
endif
endif

#target_include_directories(platform_common_interface
#    INTERFACE
#        ./ext
#        ./ext/cmsis
#        ./ext/common
#        ./ext/driver
#        ./include
#)

#platform\ext\target\CMakeLists.txt
#target_include_directories(platform_s
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/cmsis_drivers
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/cmsis_drivers/config
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/device
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/device/config
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/device/include
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/native_drivers
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/partition
TFM_S_INC_DIR += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/services/src

#YX 20230119 use tfm_sp_log_raw.o to override c library printf
TFM_S_CSRCS += ${TFM_ROOT}/secure_fw/partitions/lib/runtime/tfm_sp_log_raw.c

#YX 20230711 use tfm_interrupts to override hx_drv_timer TIMER2_IRQ_Handler,TIMER3_IRQ_Handler
TFM_S_CSRCS += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/tfm_interrupts.c #move to tfm_s.mk

## Adding new defined handler function to the library where the weak handler
## funtion symbol are, to override weak handler funtion.
## Otherwise the weak handler funtion cannot be replaced by the new defined
## hanlder function which symbol is in another library.
#ifeq ($(strip ${TEST_NS_FPU}),ON)
#TFM_S_CSRCS += ${TFM_ROOT}/platform/ext/target/arm/an552_hx/tfm_interrupts.c
#endif

## secure_fw\partitions\ns_agent_tz\CMakeLists.txt
## target_sources(tfm_s
#ifeq ($(strip ${TFM_PSA_API}),ON)
#ifeq ($(strip ${TFM_MULTI_CORE_TOPOLOGY}),OFF)
#TFM_S_CSRCS += ${TFM_ROOT}/secure_fw/partitions/ns_agent_tz/tfm_psa_api_veneers.c
#endif
#endif

## secure_fw\spm\CMakeLists.txt
## target_sources(tfm_s
#ifeq ($(strip ${TFM_PSA_API}),OFF)
#TFM_S_CSRCS += ${TFM_ROOT}/generated/secure_fw/spm/cmsis_func/tfm_veneers.c
#endif

# get object files
TFM_S_COBJS = $(call get_relobjs, $(TFM_S_CSRCS))
TFM_S_ASMOBJS = $(call get_relobjs, $(TFM_S_ASMSRCS))
TFM_S_CXXOBJS = $(call get_relobjs, $(TFM_S_CXXSRCS))
TFM_S_CCOBJS = $(call get_relobjs, $(TFM_S_CCSRCS))
TFM_S_OBJS = $(TFM_S_COBJS) $(TFM_S_ASMOBJS) $(TFM_S_CXXOBJS) $(TFM_S_CCOBJS)

# get dependency files
TFM_S_DEPS = $(call get_deps, $(TFM_S_OBJS))

## genearte library
#TFM_S_LIB = $(OUT_DIR)/libtfm_s.a
#
## library generation rule
#$(TFM_S_LIB): $(TFM_S_OBJS)
#	$(TRACE_ARCHIVE)
##	$(Q)-$(IFEXISTFILE) $(subst /,$(PS),$(TFM_S_LIB)) $(ENDIFEXISTFILE) $(RM) $(subst /,$(PS),$(TFM_S_LIB))	
#	$(Q)$(AR) $(AR_OPT) $@ $(TFM_S_OBJS)

TFM_INC_DIR += $(TFM_S_INC_DIR)
TFM_CSRCS += $(TFM_S_CSRCS)
TFM_ASMSRCS += $(TFM_S_CXXSRCS)
TFM_CXXSRCS += $(TFM_S_ASMSRCS)
TFM_CCSRCS += $(TFM_S_CCSRCS)

TFM_COBJS += $(TFM_S_COBJS)
TFM_ASMOBJS += $(TFM_S_ASMOBJS)
TFM_CXXOBJS += $(TFM_S_CXXOBJS)
TFM_CCOBJS += $(TFM_S_CCOBJS)

#TFM_LIBS += $(TFM_S_LIB)
TFM_OBJS += $(TFM_S_OBJS)

ifneq ($(MAKECMDGOALS),clean)
-include $(TFM_S_DEPS)
endif