ifeq ($(strip ${HX_TFM}),ON)
APPL_DEFINES += -DHX_TFM
endif

ifeq ($(strip ${IMPLEMENT_FLASH_DRV}),ON)
APPL_DEFINES += -DIMPLEMENT_FLASH_DRV
endif

ifeq ($(strip ${EMULATED_MPC_LAYOUT}),ON)
APPL_DEFINES += -DEMULATED_MPC_LAYOUT
endif

APPL_DEFINES += -DTFM_NS_RTOS2_WRAPPER_$(strip ${TFM_NS_RTOS2_WRAPPER})

# For GNU Arm Embedded Toolchain doesn't emit __ARM_ARCH_8_1M_MAIN__, adding this macro manually.
# add_compile_definitions($<$<STREQUAL:${TFM_SYSTEM_ARCHITECTURE},armv8.1-m.main>:__ARM_ARCH_8_1M_MAIN__>)
ifeq ($(strip ${TOOLCHAIN}),gnu)
ifeq ($(strip ${TFM_SYSTEM_ARCHITECTURE}),armv8.1-m.main)
APPL_DEFINES += -D__ARM_ARCH_8_1M_MAIN__
APPL_DEFINES += -D__ARM_FEATURE_MVE=3
endif
endif

APPL_DEFINES += -DBL2_HEADER_SIZE=$(strip ${BL2_HEADER_SIZE})
APPL_DEFINES += -DBL2_TRAILER_SIZE=$(strip ${BL2_TRAILER_SIZE})
APPL_DEFINES += -DBL1_HEADER_SIZE=$(strip ${BL1_HEADER_SIZE}) #1.6.1
APPL_DEFINES += -DBL1_TRAILER_SIZE=$(strip ${BL1_TRAILER_SIZE}) #1.6.1
ifeq ($(strip ${PLATFORM_DEFAULT_BL1}),ON) #1.6.1
APPL_DEFINES += -DPLATFORM_DEFAULT_BL1
endif
ifeq ($(strip ${TEST_BL1_1}),ON) #1.6.1
APPL_DEFINES += -DTEST_BL1_1
APPL_DEFINES += MCUBOOT_FIH_PROFILE_HIGH
endif
ifeq ($(strip ${TEST_BL1_2}),ON) #1.6.1
APPL_DEFINES += -DTEST_BL1_2
endif
ifeq ($(strip ${TFM_BL1_MEMORY_MAPPED_FLASH}),ON) #1.6.1
APPL_DEFINES += -DTFM_BL1_MEMORY_MAPPED_FLASH
endif

ifeq ($(strip ${BUILD_TFM_NS}),ON)
APPL_DEFINES += -DDOMAIN_NS=1
APPL_DEFINES += -DBUILD_TFM_NS=1
endif

#target_compile_definitions(tfm_test_framework_s
#    INTERFACE
#        USE_SP_LOG
#)
ifeq ($(strip ${BUILD_TFM_NS}),OFF)
APPL_DEFINES += -DUSE_SP_LOG #1.6.1
endif

#ifeq ($(strip ${TFM_LIB_MODEL}),ON) #1.7.0 has no
#APPL_DEFINES += -DTFM_LIB_MODEL
#endif

#substituted for generated\interface\include\config_impl.h
APPL_DEFINES += -DCONFIG_TFM_SPM_BACKEND=$(strip ${CONFIG_TFM_SPM_BACKEND})
ifeq ($(strip ${CONFIG_TFM_SPM_BACKEND_IPC}),ON)
APPL_DEFINES += -DCONFIG_TFM_SPM_BACKEND_IPC=1
else
APPL_DEFINES += -DCONFIG_TFM_SPM_BACKEND_ICP=0
endif
ifeq ($(strip ${CONFIG_TFM_SPM_BACKEND_SFN}),ON)
APPL_DEFINES += -DCONFIG_TFM_SPM_BACKEND_SFN=1
else
APPL_DEFINES += -DCONFIG_TFM_SPM_BACKEND_SFN=0
endif
ifeq ($(strip ${CONFIG_TFM_PSA_API_SUPERVISOR_CALL}),ON)
APPL_DEFINES += -DCONFIG_TFM_PSA_API_SUPERVISOR_CALL=1
else
APPL_DEFINES += -DCONFIG_TFM_PSA_API_SUPERVISOR_CALL=0
endif
ifeq ($(strip ${CONFIG_TFM_PSA_API_CROSS_CALL}),ON)
APPL_DEFINES += -DCONFIG_TFM_PSA_API_CROSS_CALL=1
else
APPL_DEFINES += -DCONFIG_TFM_PSA_API_CROSS_CALL=0
endif
ifeq ($(strip ${CONFIG_TFM_PSA_API_SFN_CALL}),ON)
APPL_DEFINES += -DCONFIG_TFM_PSA_API_SFN_CALL=1
else
APPL_DEFINES += -DCONFIG_TFM_PSA_API_SFN_CALL=0
endif
ifeq ($(strip ${CONFIG_TFM_CONNECTION_BASED_SERVICE_API}),ON)
APPL_DEFINES += -DCONFIG_TFM_CONNECTION_BASED_SERVICE_API=1
else
APPL_DEFINES += -DCONFIG_TFM_CONNECTION_BASED_SERVICE_API=0
endif
ifeq ($(strip ${CONFIG_TFM_FLIH_API}),ON)
APPL_DEFINES += -DCONFIG_TFM_FLIH_API=1
else
APPL_DEFINES += -DCONFIG_TFM_FLIH_API=0
endif
ifeq ($(strip ${CONFIG_TFM_SLIH_API}),ON)
APPL_DEFINES += -DCONFIG_TFM_SLIH_API=1
else
APPL_DEFINES += -DCONFIG_TFM_SLIH_API=0
endif
ifeq ($(strip ${CONFIG_TFM_MMIO_REGION_ENABLE}),ON)
APPL_DEFINES += -DCONFIG_TFM_MMIO_REGION_ENABLE=1
else
APPL_DEFINES += -DCONFIG_TFM_MMIO_REGION_ENABLE=0
endif

#substituted for generated\interface\include\psa\framework_feature.h
APPL_DEFINES += -DPSA_FRAMEWORK_ISOLATION_LEVEL=$(strip ${TFM_ISOLATION_LEVEL})
ifeq ($(strip ${PSA_FRAMEWORK_HAS_MM_IOVEC}),ON)
APPL_DEFINES += -DPSA_FRAMEWORK_HAS_MM_IOVEC=1
else
APPL_DEFINES += -DPSA_FRAMEWORK_HAS_MM_IOVEC=0
endif

#TFM_FIH_PROFILE_${TFM_FIH_PROFILE}
#$<$<NOT:$<STREQUAL:${TFM_FIH_PROFILE},OFF>>:TFM_FIH_PROFILE_ON>
APPL_DEFINES += -DTFM_FIH_PROFILE_$(strip ${TFM_FIH_PROFILE})
ifneq ($(strip ${TFM_FIH_PROFILE}),OFF)
APPL_DEFINES += -DTFM_FIH_PROFILE_ON
endif

APPL_DEFINES += -DTFM_LVL=$(strip ${TFM_ISOLATION_LEVEL})
ifeq ($(strip ${CONFIG_TFM_USE_TRUSTZONE}),ON) #1.7.0
APPL_DEFINES += -DCONFIG_TFM_USE_TRUSTZONE
endif

ifeq ($(strip ${CONFIG_TFM_HALT_ON_CORE_PANIC}),ON)
APPL_DEFINES += -DCONFIG_TFM_HALT_ON_CORE_PANIC
endif

#ifeq ($(strip ${TFM_PSA_API}),ON)
#APPL_DEFINES += DCONFIG_TFM_CONN_HANDLE_MAX_NUM=$(strip ${CONFIG_TFM_CONN_HANDLE_MAX_NUM}) #1.7.0 has no
#endif

APPL_DEFINES += -DCONFIG_TFM_BUILDING_SPE=$(strip ${CONFIG_TFM_BUILDING_SPE})

#ifeq ($(strip ${CONFIG_TFM_DOORBELL_API}),ON) #1.7.0 has no
#APPL_DEFINES += -DCONFIG_TFM_DOORBELL_API=1 #1.6.1
#endif

#ifeq ($(strip ${TFM_FWU_BUF_SIZE}),) #1.7.0 has no
#APPL_DEFINES += -DTFM_FWU_BUF_SIZE=$(strip ${TFM_FWU_BUF_SIZE}) #1.6.1
#endif

#APPL_DEFINES += -DTFM_CRYPTO_ENGINE_BUF_SIZE=$(strip ${CRYPTO_ENGINE_BUF_SIZE}) #1.7.0 has no

#1.7.0 target_compile_definitions has no TFM_IPC_ISOLATION_3_RETRIEVE_APP_MEM
#$<$<AND:$<BOOL:${TEST_S_IPC}>,$<VERSION_EQUAL:${TFM_ISOLATION_LEVEL},3>>:TFM_IPC_ISOLATION_3_RETRIEVE_APP_MEM>
ifeq ($(strip ${TEST_S_IPC}),ON) 
ifeq ($(strip ${TFM_ISOLATION_LEVEL}),3)
APPL_DEFINES += -DTFM_IPC_ISOLATION_3_RETRIEVE_APP_MEM
endif
endif

#$<$<BOOL:${TFM_ISOLATION_TEST_APP_2_PSA}>:TFM_IPC_ISOLATION_2_APP_ACCESS_PSA_MEM>
#$<$<AND:$<VERSION_GREATER:${TFM_ISOLATION_LEVEL},1>,$<BOOL:${TFM_ISOLATION_TEST_APP_2_PSA}>>:TFM_IPC_ISOLATION_2_APP_ACCESS_PSA_MEM>
ifneq ($(findstring $(strip ${TFM_ISOLATION_LEVEL}),2 3),) # OR logic
ifeq ($(strip ${TFM_ISOLATION_TEST_APP_2_PSA}),ON)
APPL_DEFINES += -DTFM_IPC_ISOLATION_2_APP_ACCESS_PSA_MEM
endif
endif
ifeq ($(strip ${TFM_ISOLATION_TEST_APP_2_PSA}),ON)
APPL_DEFINES += -DTFM_IPC_ISOLATION_2_APP_ACCESS_PSA_MEM
endif

#$<$<BOOL:${TFM_ISOLATION_TEST_MEM_CHECK}>:TFM_IPC_ISOLATION_2_MEM_CHECK>
#$<$<AND:$<VERSION_GREATER:${TFM_ISOLATION_LEVEL},1>,$<BOOL:${TFM_ISOLATION_TEST_MEM_CHECK}>>:TFM_IPC_ISOLATION_2_MEM_CHECK>
ifneq ($(findstring $(strip ${TFM_ISOLATION_LEVEL}),2 3),) # OR logic
ifeq ($(strip ${TFM_ISOLATION_TEST_MEM_CHECK}),ON)
APPL_DEFINES += -DTFM_IPC_ISOLATION_2_MEM_CHECK
endif
endif
ifeq ($(strip ${TFM_ISOLATION_TEST_MEM_CHECK}),ON)
APPL_DEFINES += -DTFM_IPC_ISOLATION_2_MEM_CHECK
endif

#1.7.0 target_compile_definitions has no TFM_IPC_ISOLATION_2_TEST_READ_ONLY_MEM
#$<$<VERSION_GREATER:${TFM_ISOLATION_LEVEL},1>:TFM_IPC_ISOLATION_2_TEST_READ_ONLY_MEM> #1.6.1
#ifneq ($(findstring $(strip ${TFM_ISOLATION_LEVEL}),2 3),) # OR logic
#APPL_DEFINES += -DTFM_IPC_ISOLATION_2_TEST_READ_ONLY_MEM
#endif

#$<$<STREQUAL:${MCUBOOT_SIGNATURE_TYPE},RSA>:MCUBOOT_SIGN_RSA>
#$<$<STREQUAL:${MCUBOOT_SIGNATURE_TYPE},RSA>:MCUBOOT_SIGN_RSA_LEN=${MCUBOOT_SIGNATURE_KEY_LEN}>
ifeq ($(strip ${MCUBOOT_SIGNATURE_TYPE}),RSA)
APPL_DEFINES += -DMCUBOOT_SIGN_RSA
APPL_DEFINES += -DMCUBOOT_SIGN_RSA_LEN=$(strip ${MCUBOOT_SIGNATURE_KEY_LEN})
endif
APPL_DEFINES += -DMBEDTLS_CONFIG_FILE=$(strip ${TFM_MBEDCRYPTO_CONFIG_PATH})
APPL_DEFINES += -DPROJECT_CONFIG_HEADER_FILE=$(strip ${PROJECT_CONFIG_HEADER_FILE}) #1.7.0
APPL_DEFINES += -DMBEDTLS_PSA_CRYPTO_CONFIG_FILE=$(strip ${TFM_MBEDCRYPTO_PSA_CRYPTO_CONFIG_PATH})

#target_compile_definitions(crypto_service_mbedcrypto_config
ifneq ($(strip ${TFM_MBEDCRYPTO_PLATFORM_EXTRA_CONFIG_PATH}),)
APPL_DEFINES += -DMBEDTLS_USER_CONFIG_FILE=$(strip ${TFM_MBEDCRYPTO_PLATFORM_EXTRA_CONFIG_PATH})
endif

ifeq ($(strip ${MCUBOOT_EXECUTION_SLOT}),2)
APPL_DEFINES += -DLINK_TO_SECONDARY_PARTITION
endif
ifeq ($(strip ${BL2}),ON)
APPL_DEFINES += -DBL2
endif
ifeq ($(strip ${TFM_CODE_SHARING}),ON)
APPL_DEFINES += -DCODE_SHARING
endif
ifneq ($(strip ${MCUBOOT_IMAGE_NUMBER}),)
APPL_DEFINES += -DMCUBOOT_IMAGE_NUMBER=$(strip ${MCUBOOT_IMAGE_NUMBER})
endif
ifeq ($(strip ${SECURE_UART1}),ON)
APPL_DEFINES += -DSECURE_UART1
endif
#target_compile_definitions(tfm_config
#    INTERFACE
#        $<$<STREQUAL:${TEST_PSA_API},CRYPTO>:TEST_PSA_API_CRYPTO>
#        $<$<STREQUAL:${TEST_PSA_API},IPC>:TEST_PSA_API_IPC>
#)
#$<$<BOOL:${TEST_PSA_API}>:PSA_API_TEST_${TEST_PSA_API}>
APPL_DEFINES += -DPSA_API_TEST_$(strip ${TEST_PSA_API})
#APPL_DEFINES += -DPSA_API_TEST_$(strip ${TEST_PSA_API})
ifeq ($(strip ${BUILD_TFM_NS}),ON)
ifneq ($(strip ${PSA_API_TEST}),)
APPL_DEFINES += -DPSA_API_TEST_NS
endif
endif

#$<$<AND:$<BOOL:${BL2}>,$<BOOL:${CONFIG_TFM_BOOT_STORE_MEASUREMENTS}>>:BOOT_DATA_AVAILABLE>
ifeq ($(strip ${BL2}),ON)
APPL_DEFINES += -DMCUBOOT_MEASURED_BOOT
ifeq ($(strip ${CONFIG_TFM_BOOT_STORE_MEASUREMENTS}),ON)
APPL_DEFINES += -DBOOT_DATA_AVAILABLE
endif
endif
#$<$<NOT:$<BOOL:${PLATFORM_DEFAULT_ATTEST_HAL}>>:CLAIM_VALUE_CHECK>
ifeq ($(strip ${PLATFORM_DEFAULT_ATTEST_HAL}),OFF)
APPL_DEFINES += -DCLAIM_VALUE_CHECK
endif

ifeq ($(strip ${CRYPTO_HW_ACCELERATOR}),ON) 
APPL_DEFINES += -DCRYPTO_HW_ACCELERATOR
ifeq ($(strip ${CRYPTO_HW_ACCELERATOR_TYPE}),cc312)
APPL_DEFINES += -DCRYPTO_HW_ACCELERATOR_CC312
endif
endif

#ifeq ($(strip ${CRYPTO_NV_SEED}),ON) #1.7.0 ha no
#APPL_DEFINES += -DCRYPTO_NV_SEED
#endif
ifeq ($(strip ${TFM_MULTI_CORE_TOPOLOGY}),ON)
APPL_DEFINES += -DTFM_MULTI_CORE_TOPOLOGY
endif
ifeq ($(strip ${TFM_SPM_LOG_RAW_ENABLED}),ON)
APPL_DEFINES += -DTFM_SPM_LOG_RAW_ENABLED
endif
ifeq ($(strip ${PLATFORM_DEFAULT_UART_STDOUT}),ON)
APPL_DEFINES += -DPLATFORM_DEFAULT_UART_STDOUT
endif
ifeq ($(strip ${TFM_DUMMY_PROVISIONING}),ON)
APPL_DEFINES += -DTFM_DUMMY_PROVISIONING
endif
ifeq ($(strip ${CONFIG_TFM_ENABLE_CTX_MGMT}),ON) #1.16.1
APPL_DEFINES += -DCONFIG_TFM_ENABLE_CTX_MGMT
endif

#ifeq ($(strip ${FORWARD_PROT_MSG}),ON) # 1.7.0 has no
#APPL_DEFINES += -DFORWARD_PROT_MSG
#endif
ifeq ($(strip ${TFM_NS_MANAGE_NSID}),ON)
APPL_DEFINES += -DTFM_NS_MANAGE_NSID
endif

ifeq ($(strip ${TEST_NS_FLIH_HX}),ON)
APPL_DEFINES += -DTEST_NS_FLIH_HX
endif
ifeq ($(strip ${TFM_PARTITION_HX}),ON)
APPL_DEFINES += -DTFM_PARTITION_HX
endif

#ifeq ($(strip ${TFM_PARTITION_AUDIT_LOG}),ON)
#APPL_DEFINES += -DTFM_PARTITION_AUDIT_LOG
#endif
ifeq ($(strip ${TFM_PARTITION_CRYPTO}),ON)
APPL_DEFINES += -DTFM_PARTITION_CRYPTO
endif
ifeq ($(strip ${TFM_PARTITION_INITIAL_ATTESTATION}),ON)
APPL_DEFINES += -DTFM_PARTITION_INITIAL_ATTESTATION
endif
ifeq ($(strip ${TFM_PARTITION_INTERNAL_TRUSTED_STORAGE}),ON)
APPL_DEFINES += -DTFM_PARTITION_INTERNAL_TRUSTED_STORAGE
endif
ifeq ($(strip ${TFM_PARTITION_PLATFORM}),ON)
APPL_DEFINES += -DTFM_PARTITION_PLATFORM
endif
ifeq ($(strip ${TFM_PARTITION_FIRMWARE_UPDATE}),ON)
APPL_DEFINES += -DTFM_PARTITION_FIRMWARE_UPDATE=$(strip ${TFM_PARTITION_FIRMWARE_UPDATE})
endif
ifeq ($(strip ${TFM_PARTITION_PROTECTED_STORAGE}),ON)
APPL_DEFINES += -DTFM_PARTITION_PROTECTED_STORAGE
endif
#target_compile_definitions(tfm_partition_defs
#    INTERFACE
#        TFM_PARTITION_NS_AGENT_TZ
#)
ifeq ($(strip ${TFM_PARTITION_NS_AGENT_TZ}),ON)
APPL_DEFINES += -DTFM_PARTITION_NS_AGENT_TZ
endif
ifeq ($(strip ${TFM_PARTITION_NS_AGENT_MAILBOX}),ON)
APPL_DEFINES += -DTFM_PARTITION_NS_AGENT_MAILBOX
endif

#if (TEST_NS_CORE)
#    add_subdirectory(tfm_core_test)
#    add_subdirectory(tfm_core_test_2)
#endif()
#ifeq ($(strip ${TEST_NS_CORE}),ON) 1.7.0 has no
#APPL_DEFINES += -DTFM_PARTITION_TEST_CORE
#endif
#if (TFM_PARTITION_IPC_TEST)
#    add_subdirectory(tfm_ipc_client)
#    add_subdirectory(tfm_ipc_service)
#endif()
ifeq ($(strip ${TFM_PARTITION_IPC_TEST}),ON)
APPL_DEFINES += -DTFM_PARTITION_IPC_TEST
APPL_DEFINES += -DTFM_PARTITION_TEST_CORE_IPC
#tfm_app_rot_partition_ipc_client
endif
ifeq ($(strip ${TFM_PARTITION_PROTECTED_STORAGE}),ON)
ifeq ($(strip ${TEST_S_PS}),ON)
APPL_DEFINES += -DTFM_PARTITION_TEST_PS
endif
endif

#if (TEST_FRAMEWORK_S)
#    add_subdirectory(tfm_secure_client_service)
#    add_subdirectory(tfm_secure_client_2)
#endif()
ifeq ($(strip ${TEST_FRAMEWORK_S}),ON)
APPL_DEFINES += -DTFM_PARTITION_TEST_SECURE_SERVICES 
endif
#ifeq ($(strip ${TFM_PSA_API}),ON)
#APPL_DEFINES += -DTFM_PSA_API
#endif
ifeq ($(strip ${CONFIG_TFM_PARTITION_META}),ON) #1.6.1
APPL_DEFINES += -DCONFIG_TFM_PARTITION_META
endif

#$<$<AND:$<BOOL:${TFM_PXN_ENABLE}>,$<STREQUAL:${TFM_SYSTEM_ARCHITECTURE},armv8.1-m.main>>:TFM_PXN_ENABLE>
ifeq ($(strip ${TFM_PXN_ENABLE}),ON)
ifeq (${TFM_SYSTEM_ARCHITECTURE},armv8.1-m.main)
APPL_DEFINES += -DTFM_PXN_ENABLE
endif
endif

ifeq ($(strip ${TFM_EXCEPTION_INFO_DUMP}),ON)
APPL_DEFINES += -DTFM_EXCEPTION_INFO_DUMP
endif
ifeq ($(strip ${CONFIG_TFM_LAZY_STACKING}),ON) #1.6.1
APPL_DEFINES += -DCONFIG_TFM_LAZY_STACKING
endif

ifeq ($(strip ${CONFIG_TFM_ENABLE_FP}),ON) #1.7.0
APPL_DEFINES += -DCONFIG_TFM_ENABLE_FP
endif
ifeq ($(strip ${CONFIG_TFM_ENABLE_MVE}),ON) #1.7.0
APPL_DEFINES += -DCONFIG_TFM_ENABLE_MVE
endif
ifeq ($(strip ${CONFIG_TFM_ENABLE_MVE_FP}),ON) #1.7.0
APPL_DEFINES += -DCONFIG_TFM_ENABLE_MVE_FP
endif

#$<$<STREQUAL:${CONFIG_TFM_FLOAT_ABI},hard>:CONFIG_TFM_FLOAT_ABI=2>
#$<$<STREQUAL:${CONFIG_TFM_FLOAT_ABI},soft>:CONFIG_TFM_FLOAT_ABI=0>
ifeq ($(strip ${CONFIG_TFM_FLOAT_ABI}),hard) #1.7.0
APPL_DEFINES += -DCONFIG_TFM_FLOAT_ABI=2
else ifeq ($(strip ${CONFIG_TFM_FLOAT_ABI}),soft)
APPL_DEFINES += -DCONFIG_TFM_FLOAT_ABI=0
else
$(error CONFIG_TFM_FLOAT_ABI = ${CONFIG_TFM_FLOAT_ABI})
endif

#$<$<BOOL:${CONFIG_TFM_STACK_WATERMARKS}>:CONFIG_TFM_STACK_WATERMARKS>
ifeq ($(strip ${CONFIG_TFM_STACK_WATERMARKS}),ON) #1.7.0
APPL_DEFINES += -DCONFIG_TFM_STACK_WATERMARKS
endif
#$<$<BOOL:${PLATFORM_SVC_HANDLERS}>:PLATFORM_SVC_HANDLERS>
ifeq ($(strip ${PLATFORM_SVC_HANDLERS}),ON) #1.7.0
APPL_DEFINES += -DPLATFORM_SVC_HANDLERS
endif

#$<$<BOOL:${CONFIG_TFM_ENABLE_CP10CP11}>:CONFIG_TFM_ENABLE_CP10CP11>
ifeq ($(strip ${CONFIG_TFM_ENABLE_CP10CP11}),ON) #1.7.0
APPL_DEFINES += -DCONFIG_TFM_ENABLE_CP10CP11
endif

#$<$<BOOL:${OTP_NV_COUNTERS_RAM_EMULATION}>:OTP_NV_COUNTERS_RAM_EMULATION>
ifeq ($(strip ${OTP_NV_COUNTERS_RAM_EMULATION}),ON) #1.7.0
APPL_DEFINES += -DOTP_NV_COUNTERS_RAM_EMULATION
endif

APPL_DEFINES += -DTFM_SPM_LOG_LEVEL=$(strip ${TFM_SPM_LOG_LEVEL})
APPL_DEFINES += -DTFM_PARTITION_LOG_LEVEL=$(strip ${TFM_PARTITION_LOG_LEVEL})
ifeq ($(strip ${TFM_SP_LOG_RAW_ENABLED}),ON)
APPL_DEFINES += -DTFM_SP_LOG_RAW_ENABLED
endif

#$<$<OR:$<VERSION_GREATER:${TFM_ISOLATION_LEVEL},1>,$<STREQUAL:"${TEST_PSA_API}","IPC">>:CONFIG_TFM_ENABLE_MEMORY_PROTECT>
ifeq ($(strip ${TEST_PSA_API}),IPC)
APPL_DEFINES += -DCONFIG_TFM_ENABLE_MEMORY_PROTECT
else ifneq ($(findstring $(strip ${TFM_ISOLATION_LEVEL}),2 3),) # OR logic
APPL_DEFINES += -DCONFIG_TFM_ENABLE_MEMORY_PROTECT
endif
APPL_DEFINES += -DDAUTH_$(strip ${DEBUG_AUTHENTICATION})

#target_compile_definitions(crypto_service_mbedcrypto
#    PUBLIC
#        CRYPTO_HW_ACCELERATOR
#        MBEDTLS_ECDH_LEGACY_CONTEXT
#        $<$<BOOL:${CC312_LEGACY_DRIVER_API_ENABLED}>:CC312_LEGACY_DRIVER_API_ENABLED>
#)
APPL_DEFINES += -DMBEDTLS_ECDH_LEGACY_CONTEXT
ifeq ($(strip ${CC312_LEGACY_DRIVER_API_ENABLED}),ON)
APPL_DEFINES += -DCC312_LEGACY_DRIVER_API_ENABLED
endif

ifeq ($(strip ${PLATFORM_DEFAULT_OTP}),ON)
APPL_DEFINES += -DPLATFORM_DEFAULT_OTP
endif
ifeq ($(strip ${PLATFORM_DEFAULT_OTP_WRITEABLE}),ON)
APPL_DEFINES += -DOTP_WRITEABLE
endif
ifeq ($(strip ${PLATFORM_DEFAULT_NV_COUNTERS}),ON)
APPL_DEFINES += -DPLATFORM_DEFAULT_NV_COUNTERS
endif
ifeq ($(strip ${PLATFORM_DEFAULT_NV_SEED}),ON)
APPL_DEFINES += -DPLATFORM_DEFAULT_NV_SEED
endif
#if (NOT TFM_PARTITION_CRYPTO)
#    return()
#endif()
#target_compile_definitions(crypto_service_mbedcrypto_config
#    INTERFACE
#        MBEDTLS_CONFIG_FILE="${TFM_MBEDCRYPTO_CONFIG_PATH}"
#        MBEDTLS_PSA_CRYPTO_CONFIG_FILE="${TFM_MBEDCRYPTO_PSA_CRYPTO_CONFIG_PATH}"
#        $<$<BOOL:${TFM_MBEDCRYPTO_PLATFORM_EXTRA_CONFIG_PATH}>:MBEDTLS_USER_CONFIG_FILE="${TFM_MBEDCRYPTO_PLATFORM_EXTRA_CONFIG_PATH}">
#        PSA_CRYPTO_SECURE
ifeq ($(strip ${TFM_PARTITION_CRYPTO}),ON)
APPL_DEFINES += -DPSA_CRYPTO_SECURE
endif
ifeq ($(strip ${PS_CREATE_FLASH_LAYOUT}),ON)
APPL_DEFINES += -DPS_CREATE_FLASH_LAYOUT
endif
ifeq ($(strip ${PS_RAM_FS}),ON)
APPL_DEFINES += -DPS_RAM_FS
endif

#target_compile_definitions(tfm_config
#    INTERFACE
#        $<$<STREQUAL:${PS_CRYPTO_AEAD_ALG},PSA_ALG_GCM>:PS_CRYPTO_AEAD_ALG_GCM>
#        $<$<STREQUAL:${PS_CRYPTO_AEAD_ALG},PSA_ALG_CCM>:PS_CRYPTO_AEAD_ALG_CCM>
#        $<$<BOOL:${PS_ENCRYPTION}>:PS_ENCRYPTION>
#)
ifeq ($(strip ${PS_ENCRYPTION}),ON)
APPL_DEFINES += -DPS_ENCRYPTION
endif
ifeq ($(strip ${PS_CRYPTO_AEAD_ALG}),PSA_ALG_GCM)
APPL_DEFINES += -DPS_CRYPTO_AEAD_ALG_GCM
endif
ifeq ($(strip ${PS_CRYPTO_AEAD_ALG}),PSA_ALG_CCM)
APPL_DEFINES += -DPS_CRYPTO_AEAD_ALG_CCM
endif

#target_compile_definitions(tfm_psa_rot_partition_its
#    PUBLIC
#        PS_CRYPTO_AEAD_ALG=${PS_CRYPTO_AEAD_ALG}
#)
APPL_DEFINES += -DPS_CRYPTO_AEAD_ALG=$(strip ${PS_CRYPTO_AEAD_ALG})

#APPL_DEFINES += -DPS_MAX_ASSET_SIZE=$(strip ${PS_MAX_ASSET_SIZE})  #1.7.0 has no
#APPL_DEFINES += -DPS_NUM_ASSETS=$(strip ${PS_NUM_ASSETS})  #1.7.0 has no
ifeq ($(strip ${PS_ROLLBACK_PROTECTION}),ON)
APPL_DEFINES += -DPS_ROLLBACK_PROTECTION
endif
ifeq ($(strip ${PS_VALIDATE_METADATA_FROM_FLASH}),ON)
APPL_DEFINES += -DPS_VALIDATE_METADATA_FROM_FLASH
endif
ifeq ($(strip ${ITS_CREATE_FLASH_LAYOUT}),ON)
APPL_DEFINES += -DITS_CREATE_FLASH_LAYOUT
endif
#APPL_DEFINES += -DITS_RAM_FS=$(strip ${ITS_RAM_FS}) #1.7.0 has no
#APPL_DEFINES += -DITS_MAX_ASSET_SIZE=$(strip ${ITS_MAX_ASSET_SIZE}) #1.7.0 has no
#APPL_DEFINES += -DITS_NUM_ASSETS=$(strip ${ITS_NUM_ASSETS}) #1.7.0 has no
#$<$<OR:$<BOOL:${ITS_VALIDATE_METADATA_FROM_FLASH}>,$<BOOL:${PS_VALIDATE_METADATA_FROM_FLASH}>>:ITS_VALIDATE_METADATA_FROM_FLASH>
ifneq ($(findstring ON,$(strip ${ITS_VALIDATE_METADATA_FROM_FLASH}) $(strip ${PS_VALIDATE_METADATA_FROM_FLASH})),) # OR logic
APPL_DEFINES += -DITS_VALIDATE_METADATA_FROM_FLASH
endif
#ifneq ($(strip ${ITS_BUF_SIZE}),)
#ITS_BUF_SIZE=$(strip ${ITS_BUF_SIZE}) #1.7.0 has no
#endif

#target_compile_definitions(${CC312_LIB_TARGET}
#target_compile_definitions(${CC312_PAL_TARGET}
#target_compile_definitions(${CC312_CDMPU_TARGET}
ifeq ($(strip ${CRYPTO_HW_ACCELERATOR}),ON)
ifeq ($(strip ${CRYPTO_HW_ACCELERATOR_TYPE}),cc312)
APPL_DEFINES += -DDLLI_MAX_BUFF_SIZE=0x10000
APPL_DEFINES += -DUSE_MBEDTLS_CRYPTOCELL
APPL_DEFINES += -DCC_MNG_MIN_BACKUP_SIZE_IN_BYTES=512
#ifneq ($(findstring $(strip ${TFM_CONFIG}),Debug relwithdebinfo),) # OR logic
ifeq ($(strip ${TFM_CONFIG}),Debug)
APPL_DEFINES += -DCC_PAL_MAX_LOG_LEVEL=3
else
APPL_DEFINES += -DCC_PAL_MAX_LOG_LEVEL=-1
endif
APPL_DEFINES += -DCC_IOT
APPL_DEFINES += -DCC_SUPPORT_PKA_64_16
APPL_DEFINES += -DCC_TRNG_MODE=0
endif
endif

ifeq ($(strip ${PLATFORM_DEFAULT_CRYPTO_KEYS}),ON)
APPL_DEFINES += -DPLATFORM_DEFAULT_CRYPTO_KEYS
endif

#target_compile_definitions(${CC312_PSA_DRIVER_API_TARGET}
#    PUBLIC
#        MBEDTLS_PSA_CRYPTO_DRIVERS
#        PSA_CRYPTO_DRIVER_CC3XX
#)
ifeq ($(strip ${CC312_LEGACY_DRIVER_API_ENABLED}),OFF)
APPL_DEFINES += -DMBEDTLS_PSA_CRYPTO_DRIVERS
APPL_DEFINES += -DPSA_CRYPTO_DRIVER_CC3XX
endif

#target_compile_definitions(crypto_service_mbedcrypto_config
#    INTERFACE
#        MBEDTLS_CONFIG_FILE="${TFM_MBEDCRYPTO_CONFIG_PATH}"
#        MBEDTLS_PSA_CRYPTO_CONFIG_FILE="${TFM_MBEDCRYPTO_PSA_CRYPTO_CONFIG_PATH}"
#        $<$<BOOL:${TFM_MBEDCRYPTO_PLATFORM_EXTRA_CONFIG_PATH}>:MBEDTLS_USER_CONFIG_FILE="${TFM_MBEDCRYPTO_PLATFORM_EXTRA_CONFIG_PATH}">
#        PSA_CRYPTO_SECURE
#        # Workaround for https://github.com/ARMmbed/mbedtls/issues/1077
#        $<$<OR:$<STREQUAL:${TFM_SYSTEM_ARCHITECTURE},armv8-m.base>,$<STREQUAL:${TFM_SYSTEM_ARCHITECTURE},armv6-m>>:MULADDC_CANNOT_USE_R7>
#        $<$<BOOL:${PLATFORM_DEFAULT_NV_SEED}>:PLATFORM_DEFAULT_NV_SEED>
#        $<$<BOOL:${PLATFORM_DEFAULT_CRYPTO_KEYS}>:PLATFORM_DEFAULT_CRYPTO_KEYS>
#        MBEDTLS_PSA_CRYPTO_BUILTIN_KEYS
#        MBEDTLS_PSA_CRYPTO_DRIVERS
#        $<$<BOOL:CRYPTO_TFM_BUILTIN_KEYS_DRIVER>:PSA_CRYPTO_DRIVER_TFM_BUILTIN_KEY_LOADER>
#)
APPL_DEFINES += -DMBEDTLS_PSA_CRYPTO_BUILTIN_KEYS
APPL_DEFINES += -DMBEDTLS_PSA_CRYPTO_DRIVERS
ifeq ($(strip ${CRYPTO_TFM_BUILTIN_KEYS_DRIVER}),ON)
APPL_DEFINES += -DPSA_CRYPTO_DRIVER_TFM_BUILTIN_KEY_LOADER
endif

#target_compile_definitions(tfm_psa_rot_partition_crypto
#    PUBLIC
#        MBEDTLS_PSA_CRYPTO_DRIVERS
#        MBEDTLS_PSA_CRYPTO_BUILTIN_KEYS
#        $<$<BOOL:CRYPTO_BUILTIN_KEYS>:PSA_CRYPTO_DRIVER_TFM_BUILTIN_KEY>
#)
ifeq ($(strip ${CRYPTO_BUILTIN_KEYS}),ON) 
APPL_DEFINES += -DPSA_CRYPTO_DRIVER_TFM_BUILTIN_KEY
endif

#target_compile_definitions(tfm_qcbor_ns
#    PUBLIC
#        QCBOR_DISABLE_FLOAT_HW_USE
#        USEFULBUF_DISABLE_ALL_FLOAT
#        QCBOR_DISABLE_PREFERRED_FLOAT
#)
#target_compile_definitions(tfm_qcbor_s
#    PRIVATE
#        QCBOR_DISABLE_FLOAT_HW_USE
#)
#ifeq ($(strip ${BUILD_TFM_NS}),ON)
APPL_DEFINES += -DQCBOR_DISABLE_FLOAT_HW_USE
APPL_DEFINES += -DUSEFULBUF_DISABLE_ALL_FLOAT
APPL_DEFINES += -DQCBOR_DISABLE_PREFERRED_FLOAT
#else
#APPL_DEFINES += -DQCBOR_DISABLE_FLOAT_HW_USE
#endif

ifeq ($(strip ${TEST_FRAMEWORK_NS}),ON)
APPL_DEFINES += -DTEST_FRAMEWORK_NS
endif
ifeq ($(strip ${TEST_NS_ATTESTATION}),ON)
APPL_DEFINES += -DTEST_NS_ATTESTATION
endif
ifeq ($(strip ${TEST_NS_T_COSE}),ON)
APPL_DEFINES += -DTEST_NS_T_COSE
endif
ifeq ($(strip ${TEST_NS_QCBOR}),ON)
APPL_DEFINES += -DTEST_NS_QCBOR
endif
#ifeq ($(strip ${TEST_NS_AUDIT}),ON) 1.7.0 has no
#APPL_DEFINES += -DTEST_NS_AUDIT
#endif
#ifeq ($(strip ${TEST_NS_CORE}),ON) 1.7.0 has no
#APPL_DEFINES += -DTEST_NS_CORE
#endif
ifeq ($(strip ${TEST_NS_CRYPTO}),ON)
APPL_DEFINES += -DTEST_NS_CRYPTO
endif
ifeq ($(strip ${TEST_NS_ITS}),ON)
APPL_DEFINES += -DTEST_NS_ITS
endif
ifeq ($(strip ${TEST_NS_PS}),ON)
APPL_DEFINES += -DTEST_NS_PS
endif
ifeq ($(strip ${TEST_NS_PLATFORM}),ON)
APPL_DEFINES += -DTEST_NS_PLATFORM
endif
ifeq ($(strip ${TEST_NS_FWU}),ON)
APPL_DEFINES += -DTEST_NS_FWU
endif
ifeq ($(strip ${TEST_NS_IPC}),ON)
APPL_DEFINES += -DTEST_NS_IPC
endif
ifeq ($(strip ${TEST_NS_FPU}),ON)
APPL_DEFINES += -DTEST_NS_FPU
endif
ifeq ($(strip ${TEST_NS_SLIH_IRQ}),ON)
APPL_DEFINES += -DTEST_NS_SLIH_IRQ
endif
ifeq ($(strip ${TEST_NS_FLIH_IRQ}),ON)
APPL_DEFINES += -DTEST_NS_FLIH_IRQ
endif
ifeq ($(strip ${TEST_NS_MULTI_CORE}),ON)
APPL_DEFINES += -DTEST_NS_MULTI_CORE
endif

#ifeq ($(strip ${TFM_MULTI_CORE_TOPOLOGY}),ON)
ifeq ($(strip ${TFM_MULTI_CORE_NS_OS}),ON)
APPL_DEFINES += -DTFM_MULTI_CORE_NS_OS
#endif
#$<$<AND:$<BOOL:${TFM_MULTI_CORE_NS_OS_MAILBOX_THREAD}>,$<BOOL:${TFM_MULTI_CORE_NS_OS}>>:TFM_MULTI_CORE_NS_OS_MAILBOX_THREAD>
ifeq ($(strip ${TFM_MULTI_CORE_NS_OS}),ON)
ifeq ($(strip ${TFM_MULTI_CORE_NS_OS_MAILBOX_THREAD}),ON)
APPL_DEFINES += -DTFM_MULTI_CORE_NS_OS_MAILBOX_THREAD
endif
endif
endif

ifeq ($(strip ${TEST_NS_MANAGE_NSID}),ON)
APPL_DEFINES += -DTEST_NS_MANAGE_NSID
endif
ifeq ($(strip ${TEST_NS_SFN_BACKEND}),ON)
APPL_DEFINES += -DTEST_NS_SFN_BACKEND
endif
ifeq ($(strip ${TEST_S_SFN_BACKEND}),ON)
APPL_DEFINES += -DTEST_S_SFN_BACKEND
endif
ifeq ($(strip ${TEST_FRAMEWORK_S}),ON)
APPL_DEFINES += -DTEST_FRAMEWORK_S
endif
ifeq ($(strip ${TEST_S_ATTESTATION}),ON)
APPL_DEFINES += -DTEST_S_ATTESTATION
endif
#ifeq ($(strip ${TEST_S_AUDIT}),ON) #1.7.0 has no
#APPL_DEFINES += -DTEST_S_AUDIT
#endif
ifeq ($(strip ${TEST_S_CRYPTO}),ON)
APPL_DEFINES += -DTEST_S_CRYPTO
endif
ifeq ($(strip ${TEST_S_ITS}),ON)
APPL_DEFINES += -DTEST_S_ITS
endif
ifeq ($(strip ${TEST_S_PS}),ON)
APPL_DEFINES += -DTEST_S_PS
endif
ifeq ($(strip ${TEST_S_PLATFORM}),ON)
APPL_DEFINES += -DTEST_S_PLATFORM
endif
ifeq ($(strip ${TEST_S_FWU}),ON)
APPL_DEFINES += -DTEST_S_FWU
endif
ifeq ($(strip ${TEST_S_IPC}),ON)
APPL_DEFINES += -DTEST_S_IPC
endif
ifeq ($(strip ${TEST_S_FPU}),ON)
APPL_DEFINES += -DTEST_S_FPU
endif

ifeq ($(strip ${TFM_PARTITION_SFN_BACKEND_TEST}),ON)
APPL_DEFINES += -DTFM_PARTITION_SFN_BACKEND_TEST
endif
ifeq ($(strip ${TEST_PARTITION_FPU_TEST}),ON)
APPL_DEFINES += -DTEST_PARTITION_FPU_TEST
endif
ifeq ($(strip ${TEST_S_FPU}),ON)
APPL_DEFINES += -DTEST_PARTITION_FPU_TEST
endif

ifeq ($(strip ${PS_TEST_NV_COUNTERS}),ON)
APPL_DEFINES += -DPS_TEST_NV_COUNTERS
endif

ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_CBC}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_CBC
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_CCM}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_CCM
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_CFB}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_CFB
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_ECB}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_ECB
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_CTR}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_CTR
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_OFB}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_OFB
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_GCM}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_GCM
endif
#$<$<AND:$<BOOL:${TFM_CRYPTO_TEST_ALG_SHA_384}>,$<BOOL:${CC312_LEGACY_DRIVER_API_ENABLED}>>:TFM_CRYPTO_TEST_ALG_SHA_384>
#$<$<AND:$<BOOL:${TFM_CRYPTO_TEST_ALG_SHA_512}>,$<BOOL:${CC312_LEGACY_DRIVER_API_ENABLED}>>:TFM_CRYPTO_TEST_ALG_SHA_512>
ifeq ($(strip ${CC312_LEGACY_DRIVER_API_ENABLED}),ON)
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_SHA_384}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_SHA_384
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_SHA_512}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_SHA_512
endif
endif
#$<$<BOOL:${CC312_LEGACY_DRIVER_API_ENABLED}>:CC312_LEGACY_DRIVER_API_ENABLED>
ifeq ($(strip ${CC312_LEGACY_DRIVER_API_ENABLED}),ON)
APPL_DEFINES += -DCC312_LEGACY_DRIVER_API_ENABLED
endif

ifeq ($(strip ${TFM_CRYPTO_TEST_HKDF}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_HKDF
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ECDH}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ECDH
endif
#$<$<BOOL:${TFM_CRYPTO_TEST_CHACHA20}>:TFM_CRYPTO_TEST_CHACHA20>
#$<$<BOOL:${TFM_CRYPTO_TEST_ALG_CHACHA20_POLY1305}>:TFM_CRYPTO_TEST_ALG_CHACHA20_POLY1305>
#$<$<BOOL:${TFM_CRYPTO_TEST_ALG_RSASSA_PSS_VERIFICATION}>:TFM_CRYPTO_TEST_ALG_RSASSA_PSS_VERIFICATION>
#$<$<BOOL:${TFM_CRYPTO_TEST_SINGLE_PART_FUNCS}>:TFM_CRYPTO_TEST_SINGLE_PART_FUNCS>
ifeq ($(strip ${TFM_CRYPTO_TEST_CHACHA20}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_CHACHA20
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_CHACHA20_POLY1305}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_CHACHA20_POLY1305
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_ALG_RSASSA_PSS_VERIFICATION}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ALG_RSASSA_PSS_VERIFICATION
endif
ifeq ($(strip ${TFM_CRYPTO_TEST_SINGLE_PART_FUNCS}),ON)
APPL_DEFINES += -DTFM_CRYPTO_TEST_SINGLE_PART_FUNCS
endif

#$<$<NOT:$<BOOL:${CRYPTO_ASYM_ENCRYPT_MODULE_DISABLED}>>:TFM_CRYPTO_TEST_ASYM_ENCRYPT>
ifeq ($(strip ${CRYPTO_ASYM_ENCRYPT_MODULE_DISABLED}),OFF)
APPL_DEFINES += -DTFM_CRYPTO_TEST_ASYM_ENCRYPT
endif
ifeq ($(strip ${TFM_FWU_TEST_REQUEST_REBOOT}),ON)
APPL_DEFINES += -DTFM_FWU_TEST_REQUEST_REBOOT
endif
ifeq ($(strip ${TFM_FWU_TEST_WRITE_WITH_NULL}),ON)
APPL_DEFINES += -DTFM_FWU_TEST_WRITE_WITH_NULL
endif
ifeq ($(strip ${TFM_FWU_TEST_QUERY_WITH_NULL}),ON)
APPL_DEFINES += -DTFM_FWU_TEST_QUERY_WITH_NULL
endif
#$<$<AND:$<BOOL:${ATTEST_TEST_GET_PUBLIC_KEY}>,$<NOT:$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>>>:ATTEST_TEST_GET_PUBLIC_KEY>
ifeq ($(strip ${ATTEST_TEST_GET_PUBLIC_KEY}),ON)
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),OFF)
APPL_DEFINES += -DATTEST_TEST_GET_PUBLIC_KEY
endif
endif
ifeq ($(strip ${PLATFORM_SLIH_IRQ_TEST_SUPPORT}),ON)
APPL_DEFINES += -DPLATFORM_SLIH_IRQ_TEST_SUPPORT
endif
ifeq ($(strip ${PLATFORM_FLIH_IRQ_TEST_SUPPORT}),ON)
APPL_DEFINES += -DPLATFORM_FLIH_IRQ_TEST_SUPPORT
endif

#target_compile_definitions(tfm_t_cose_defs
#    INTERFACE
#        T_COSE_COMPILE_TIME_CONFIG
#        T_COSE_USE_PSA_CRYPTO
#        T_COSE_USE_PSA_CRYPTO_FROM_TFM
#        T_COSE_DISABLE_CONTENT_TYPE
#        $<$<OR:$<NOT:$<STREQUAL:${ATTEST_KEY_BITS},384>>,$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>>:T_COSE_DISABLE_ES384>
#        $<$<OR:$<NOT:$<STREQUAL:${ATTEST_KEY_BITS},521>>,$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>>:T_COSE_DISABLE_ES512>
#        $<$<NOT:$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>>:T_COSE_DISABLE_SIGN_VERIFY_TESTS>
#        $<$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>:T_COSE_DISABLE_SIGN1>
#        $<$<NOT:$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>>:T_COSE_DISABLE_MAC0>
#        $<$<NOT:$<BOOL:${ATTEST_INCLUDE_TEST_CODE}>>:T_COSE_DISABLE_SHORT_CIRCUIT_SIGN>
#)
APPL_DEFINES += -DT_COSE_COMPILE_TIME_CONFIG
APPL_DEFINES += -DT_COSE_USE_PSA_CRYPTO
APPL_DEFINES += -DT_COSE_USE_PSA_CRYPTO_FROM_TFM
APPL_DEFINES += -DT_COSE_DISABLE_CONTENT_TYPE
ifneq ($(strip ${ATTEST_KEY_BITS}),384)
APPL_DEFINES += -DT_COSE_DISABLE_ES384
else ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),ON)
APPL_DEFINES += -DT_COSE_DISABLE_ES384
endif
ifneq ($(strip ${ATTEST_KEY_BITS}),521)
APPL_DEFINES += -DT_COSE_DISABLE_ES512
else ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),ON)
APPL_DEFINES += -DT_COSE_DISABLE_ES512
endif
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),OFF)
APPL_DEFINES += -DT_COSE_DISABLE_SIGN_VERIFY_TESTS
endif
#$<$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>:T_COSE_DISABLE_SIGN1>
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),ON)
APPL_DEFINES += -DT_COSE_DISABLE_SIGN1
endif
#$<$<NOT:$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>>:T_COSE_DISABLE_MAC0>
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),OFF)
APPL_DEFINES += -DT_COSE_DISABLE_MAC0
endif
#$<$<NOT:$<BOOL:${ATTEST_INCLUDE_TEST_CODE}>>:T_COSE_DISABLE_SHORT_CIRCUIT_SIGN>
ifeq ($(strip ${ATTEST_INCLUDE_TEST_CODE}),OFF)
APPL_DEFINES += -DT_COSE_DISABLE_SHORT_CIRCUIT_SIGN
endif
#target_compile_definitions(tfm_ns_tests
#    INTERFACE
#        $<$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>:SYMMETRIC_INITIAL_ATTESTATION>
#        $<$<BOOL:${TFM_FUZZER_TOOL_TESTS}>:TFM_FUZZER_TOOL_TESTS>
#)
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),ON)
APPL_DEFINES += -DSYMMETRIC_INITIAL_ATTESTATION
endif
ifeq ($(strip ${TFM_FUZZER_TOOL_TESTS}),ON)
APPL_DEFINES += -DTFM_FUZZER_TOOL_TESTS
endif
#$<$<CONFIG:Debug>:TFM_CORE_DEBUG>
ifeq ($(strip ${TFM_CONFIG}),Debug)
APPL_DEFINES += -DTFM_CORE_DEBUG
endif
#$<$<BOOL:${ATTEST_INCLUDE_TEST_CODE}>:INCLUDE_TEST_CODE>
ifeq ($(strip ${ATTEST_INCLUDE_TEST_CODE}),ON)
APPL_DEFINES += -DINCLUDE_TEST_CODE
endif

#1.7.0 has no
#ifneq ($(findstring ON,$(strip ${TEST_S_AUDIT}) $(strip ${TEST_NS_AUDIT})),) # OR logic
##$<$<BOOL:${TEST_FRAMEWORK_S}>:AUDIT_TEST_S_ENABLE>
#ifeq ($(strip ${TEST_FRAMEWORK_S}),ON)
#APPL_DEFINES += -DAUDIT_TEST_S_ENABLE
#endif
#endif

ifeq ($(strip ${TFM_MULTI_CORE_TEST}),ON)
APPL_DEFINES += -DTFM_MULTI_CORE_TEST
endif
ifeq ($(strip ${ATTEST_INCLUDE_OPTIONAL_CLAIMS}),ON)
APPL_DEFINES += -DINCLUDE_OPTIONAL_CLAIMS
endif
ifeq ($(strip ${ATTEST_INCLUDE_COSE_KEY_ID}),ON)
APPL_DEFINES += -DINCLUDE_COSE_KEY_ID
endif
#target_compile_definitions(tfm_psa_rot_partition_fwu
#    PRIVATE
#        MCUBOOT_${MCUBOOT_UPGRADE_STRATEGY}
#        $<$<BOOL:${MCUBOOT_DIRECT_XIP_REVERT}>:MCUBOOT_DIRECT_XIP_REVERT>
#)
APPL_DEFINES += -DMCUBOOT_$(strip ${MCUBOOT_UPGRADE_STRATEGY})
ifeq ($(strip ${MCUBOOT_UPGRADE_STRATEGY}),DIRECT_XIP)
APPL_DEFINES += -DIMAGE_ROM_FIXED
endif
ifeq ($(strip ${MCUBOOT_DIRECT_XIP_REVERT}),ON)
APPL_DEFINES += -DMCUBOOT_DIRECT_XIP_REVERT
endif
ifeq ($(strip ${DEFAULT_MCUBOOT_FLASH_MAP}),ON)
APPL_DEFINES += -DDEFAULT_MCUBOOT_FLASH_MAP
endif
ifneq ($(findstring $(strip ${TFM_SYSTEM_ARCHITECTURE}),armv8-m.base armv6-m),) # OR logic
APPL_DEFINES += -DMULADDC_CANNOT_USE_R7
endif
#ifeq ($(strip ${CRYPTO_RNG_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_RNG_MODULE_DISABLED
#endif
#ifeq ($(strip ${CRYPTO_KEY_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_KEY_MODULE_DISABLED
#endif
#ifeq ($(strip ${CRYPTO_AEAD_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_AEAD_MODULE_DISABLED
#endif
#ifeq ($(strip ${CRYPTO_MAC_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_MAC_MODULE_DISABLED
#endif
#ifeq ($(strip ${CRYPTO_CIPHER_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_CIPHER_MODULE_DISABLED
#endif
#ifeq ($(strip ${CRYPTO_HASH_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_HASH_MODULE_DISABLED
#endif
#ifeq ($(strip ${CRYPTO_ASYM_SIGN_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_ASYM_SIGN_MODULE_DISABLED
#endif
##$<$<BOOL:${CRYPTO_ASYM_ENCRYPT_MODULE_DISABLED}>:TFM_CRYPTO_ASYM_ENCRYPT_MODULE_DISABLED>
##$(error CRYPTO_ASYM_ENCRYPT_MODULE_DISABLED = ${CRYPTO_ASYM_ENCRYPT_MODULE_DISABLED})
#ifeq ($(strip ${CRYPTO_ASYM_ENCRYPT_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_ASYM_ENCRYPT_MODULE_DISABLED
#endif
#ifeq ($(strip ${CRYPTO_KEY_DERIVATION_MODULE_DISABLED}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_KEY_DERIVATION_MODULE_DISABLED
#endif
#APPL_DEFINES += -DTFM_CRYPTO_CONC_OPER_NUM=$(strip ${CRYPTO_CONC_OPER_NUM})
#ifeq ($(strip ${TFM_PSA_API}),ON)
#APPL_DEFINES += -DTFM_CRYPTO_IOVEC_BUFFER_SIZE=$(strip ${CRYPTO_IOVEC_BUFFER_SIZE}) #1.7.0 has no
#endif

#$<$<NOT:$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>>:ATTEST_KEY_BITS=${ATTEST_KEY_BITS}>
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),OFF)
APPL_DEFINES += -DATTEST_KEY_BITS=$(strip ${ATTEST_KEY_BITS}) #1.7.0
endif

#PLATFORM_NS_NV_COUNTERS=${TFM_NS_NV_COUNTER_AMOUNT}
APPL_DEFINES += -DPLATFORM_NS_NV_COUNTERS=$(strip ${TFM_NS_NV_COUNTER_AMOUNT})

#$<$<OR:$<CONFIG:Debug>,$<CONFIG:relwithdebinfo>>:ENABLE_HEAP>
#ifneq ($(findstring $(strip ${TFM_CONFIG}),Debug relwithdebinfo),) # OR logic
APPL_DEFINES += -DENABLE_HEAP
#YX 20230118 always use ENABLE_HEAP
#endif

#-------------------------------------------------------------------------------------------------------------
ifeq ($(strip ${BUILD_TFM_NS}),ON) 
ifeq ($(findstring $(strip ${TFM_NS_RTOS2_WRAPPER}),BARE_METAL RTOS2_RTX RTOS2_FREERTOS),) # OR logic
$(error tfm_invalid_config. BUILD_TFM_NS = ${BUILD_TFM_NS}, TFM_NS_RTOS2_WRAPPER = ${TFM_NS_RTOS2_WRAPPER})
endif
endif

ifeq ($(strip ${TFM_NS_MANAGE_NSID}),ON) 
ifneq ($(strip ${TFM_NS_RTOS2_WRAPPER}),RTOS2_RTX) 
$(error tfm_invalid_config. TFM_NS_MANAGE_NSID = ${TFM_NS_MANAGE_NSID}, TFM_NS_RTOS2_WRAPPER = ${TFM_NS_RTOS2_WRAPPER})
endif
endif

ifeq ($(strip ${TFM_PARTITION_FIRMWARE_UPDATE}),ON) 
$(error tfm_invalid_config. TFM_PARTITION_FIRMWARE_UPDATE = ${TFM_PARTITION_FIRMWARE_UPDATE})
endif

ifeq ($(strip ${SECURE_UART1}),ON) 
$(error tfm_invalid_config. SECURE_UART1 = ${SECURE_UART1})
endif

ifeq ($(strip ${TEST_NS_FLIH_HX}),ON) 
ifeq ($(strip ${TEST_NS_FLIH_IRQ}),ON) 
$(error tfm_invalid_config. TEST_NS_FLIH_HX = ${TEST_NS_FLIH_HX}, TEST_NS_FLIH_IRQ = ${TEST_NS_FLIH_IRQ})
endif
ifeq ($(strip ${TEST_NS_SLIH_IRQ}),ON) 
$(error tfm_invalid_config. TEST_NS_FLIH_HX = ${TEST_NS_FLIH_HX}, TEST_NS_SLIH_IRQ = ${TEST_NS_SLIH_IRQ})
endif
endif

#ifeq ($(strip ${TFM_PARTITION_HX}),ON) 
#ifeq ($(strip ${TEST_NS_SLIH_IRQ}),ON)
#$(error tfm_invalid_config. TFM_PARTITION_HX = ${TFM_PARTITION_HX}, TEST_NS_SLIH_IRQ = ${TEST_NS_SLIH_IRQ})
#endif
#ifeq ($(strip ${TEST_NS_FLIH_IRQ}),ON)
#$(error tfm_invalid_config. TFM_PARTITION_HX = ${TFM_PARTITION_HX}, TEST_NS_FLIH_IRQ = ${TEST_NS_FLIH_IRQ})
#endif
#endif

ifeq ($(strip ${CRYPTO_HW_ACCELERATOR}),ON) 
ifeq ($(strip ${CRYPTO_NV_SEED}),ON) 
$(error tfm_invalid_config. CRYPTO_NV_SEED = ${CRYPTO_NV_SEED}, CRYPTO_HW_ACCELERATOR = ${CRYPTO_HW_ACCELERATOR})
endif
endif

ifeq ($(strip ${CRYPTO_HW_ACCELERATOR}),OFF) 
ifeq ($(strip ${CRYPTO_NV_SEED}),OFF) 
$(error tfm_invalid_config. CRYPTO_NV_SEED = ${CRYPTO_NV_SEED}, CRYPTO_HW_ACCELERATOR = ${CRYPTO_HW_ACCELERATOR})
endif
endif

ifeq ($(strip ${TEST_NS_MANAGE_NSID}),ON)
ifeq ($(strip ${TFM_NS_MANAGE_NSID}),OFF)
$(error tfm_invalid_config. TEST_NS_MANAGE_NSID = ${TEST_NS_MANAGE_NSID}, TFM_NS_MANAGE_NSID = ${TFM_NS_MANAGE_NSID})
endif
endif

ifeq ($(strip ${CRYPTO_HW_ACCELERATOR}),ON)
ifneq ($(strip ${CRYPTO_HW_ACCELERATOR_TYPE}),cc312)
$(error tfm_invalid_config. CRYPTO_HW_ACCELERATOR = ${CRYPTO_HW_ACCELERATOR}, CRYPTO_HW_ACCELERATOR_TYPE = ${CRYPTO_HW_ACCELERATOR_TYPE})
endif
endif

ifeq ($(strip ${CONFIG_TFM_SPM_BACKEND_IPC}),$(strip ${CONFIG_TFM_SPM_BACKEND_SFN}))
$(error tfm_invalid_config. CONFIG_TFM_SPM_BACKEND_IPC = ${CONFIG_TFM_SPM_BACKEND_IPC}, CONFIG_TFM_SPM_BACKEND_SFN = ${CONFIG_TFM_SPM_BACKEND_SFN})
endif

ifeq ($(strip ${BL2}),ON)
$(error tfm_invalid_config. BL2 = ${BL2})
endif

ifeq ($(strip ${TFM_PARTITION_FIRMWARE_UPDATE}),ON)
$(error tfm_invalid_config. TFM_PARTITION_FIRMWARE_UPDATE = ${TFM_PARTITION_FIRMWARE_UPDATE})
endif

ifeq ($(strip ${CONFIG_TFM_SPM_BACKEND_SFN}),ON)
ifneq ($(strip ${TFM_ISOLATION_LEVEL}),1)
$(error tfm_invalid_config. CONFIG_TFM_SPM_BACKEND_SFN = ${CONFIG_TFM_SPM_BACKEND_SFN}, TFM_ISOLATION_LEVEL = ${TFM_ISOLATION_LEVEL})
endif
endif

ifeq ($(findstring $(strip ${CONFIG_TFM_FLOAT_ABI}),soft hard),) # OR logic
$(error tfm_invalid_config. CONFIG_TFM_FLOAT_ABI = ${CONFIG_TFM_FLOAT_ABI})
endif