# directory declaration
TFM_PSA_ROT_PARTITION_ATTESTATION_INC_DIR = ${TFM_ROOT}
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS =
TFM_PSA_ROT_PARTITION_ATTESTATION_ASMSRCS =
TFM_PSA_ROT_PARTITION_ATTESTATION_CXXSRCS =
TFM_PSA_ROT_PARTITION_ATTESTATION_CCSRCS =

#secure_fw\partitions\initial_attestation\CMakeLists.txt
#target_sources(tfm_psa_rot_partition_attestation PRIVATE
#    tfm_attest.c
#    tfm_attest_req_mngr.c
#    attest_core.c
#    $<$<NOT:$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>>:attest_asymmetric_key.c>
#    $<$<BOOL:${SYMMETRIC_INITIAL_ATTESTATION}>:attest_symmetric_key.c>
#    attest_token_encode.c
#)
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS += ${TFM_ROOT}/secure_fw/partitions/initial_attestation/tfm_attest.c
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS += ${TFM_ROOT}/secure_fw/partitions/initial_attestation/tfm_attest_req_mngr.c
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS += ${TFM_ROOT}/secure_fw/partitions/initial_attestation/attest_core.c
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS += ${TFM_ROOT}/secure_fw/partitions/initial_attestation/attest_boot_data.c
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),OFF)
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS += ${TFM_ROOT}/secure_fw/partitions/initial_attestation/attest_asymmetric_key.c
endif
ifeq ($(strip ${SYMMETRIC_INITIAL_ATTESTATION}),ON)
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS += ${TFM_ROOT}/secure_fw/partitions/initial_attestation/attest_symmetric_key.c
endif
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS += ${TFM_ROOT}/secure_fw/partitions/initial_attestation/attest_token_encode.c
#target_sources(tfm_psa_rot_partition_attestation
#    PRIVATE
#        ${CMAKE_BINARY_DIR}/generated/secure_fw/partitions/initial_attestation/auto_generated/intermedia_tfm_initial_attestation.c
#)
TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS += ${TFM_ROOT}/generated/secure_fw/partitions/initial_attestation/auto_generated/intermedia_tfm_initial_attestation.c
#target_include_directories(tfm_psa_rot_partition_attestation
#    PUBLIC
#        .
#    PRIVATE
#        ${CMAKE_BINARY_DIR}/generated/secure_fw/partitions/initial_attestation
#)
TFM_PSA_ROT_PARTITION_ATTESTATION_INC_DIR += ${TFM_ROOT}/secure_fw/partitions/initial_attestation
TFM_PSA_ROT_PARTITION_ATTESTATION_INC_DIR += ${TFM_ROOT}/generated/secure_fw/partitions/initial_attestation

# get object files
TFM_PSA_ROT_PARTITION_ATTESTATION_COBJS = $(call get_relobjs, $(TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS))
TFM_PSA_ROT_PARTITION_ATTESTATION_ASMOBJS = $(call get_relobjs, $(TFM_PSA_ROT_PARTITION_ATTESTATION_ASMSRCS))
TFM_PSA_ROT_PARTITION_ATTESTATION_CXXOBJS = $(call get_relobjs, $(TFM_PSA_ROT_PARTITION_ATTESTATION_CXXSRCS))
TFM_PSA_ROT_PARTITION_ATTESTATION_CCOBJS = $(call get_relobjs, $(TFM_PSA_ROT_PARTITION_ATTESTATION_CCSRCS))
TFM_PSA_ROT_PARTITION_ATTESTATION_OBJS = $(TFM_PSA_ROT_PARTITION_ATTESTATION_COBJS) $(TFM_PSA_ROT_PARTITION_ATTESTATION_ASMOBJS) $(TFM_PSA_ROT_PARTITION_ATTESTATION_CXXOBJS) $(TFM_PSA_ROT_PARTITION_ATTESTATION_CCOBJS)

# get dependency files
TFM_PSA_ROT_PARTITION_ATTESTATION_DEPS = $(call get_deps, $(TFM_PSA_ROT_PARTITION_ATTESTATION_OBJS))

# genearte library
TFM_PSA_ROT_PARTITION_ATTESTATION_LIB = $(OUT_DIR)/libtfm_psa_rot_partition_attestation.a

# library generation rule
$(TFM_PSA_ROT_PARTITION_ATTESTATION_LIB): $(TFM_PSA_ROT_PARTITION_ATTESTATION_OBJS)
	$(TRACE_ARCHIVE)
#	$(Q)-$(IFEXISTFILE) $(subst /,$(PS),$(TFM_PSA_ROT_PARTITION_ATTESTATION_LIB)) $(ENDIFEXISTFILE) $(RM) $(subst /,$(PS),$(TFM_PSA_ROT_PARTITION_ATTESTATION_LIB))	
	$(Q)$(AR) $(AR_OPT) $@ $(TFM_PSA_ROT_PARTITION_ATTESTATION_OBJS)

TFM_INC_DIR += $(TFM_PSA_ROT_PARTITION_ATTESTATION_INC_DIR)
TFM_CSRCS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_CSRCS)
TFM_ASMSRCS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_CXXSRCS)
TFM_CXXSRCS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_ASMSRCS)
TFM_CCSRCS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_CCSRCS)

TFM_COBJS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_COBJS)
TFM_ASMOBJS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_ASMOBJS)
TFM_CXXOBJS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_CXXOBJS)
TFM_CCOBJS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_CCOBJS)

TFM_LIBS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_LIB)
#TFM_OBJS += $(TFM_PSA_ROT_PARTITION_ATTESTATION_OBJS)

ifneq ($(MAKECMDGOALS),clean)
-include $(TFM_PSA_ROT_PARTITION_ATTESTATION_DEPS)
endif
