#ifndef _RTE_DEVICE_H
#define _RTE_DEVICE_H
//-------- <<< Use Configuration Wizard in Context Menu >>> --------------------
// <h> Trustzone Config
// </h>
// <i> trustzone
#define RTE_TRUSTZONE_SEC_ONLY   0
// <o> trustzone <0=>secure <1=>secure only

// <h> Peripheral Config
// </h>

#define RTE_IP_scu              1
#define RTE_IP_swreg_lsc        1
#define RTE_IP_swreg_aon        1
#define RTE_IP_ppc              1
#define RTE_IP_pmu              1
#define RTE_IP_mpc              1

// <o> scu <1=>Secure
#define RTE_SCU         1
// <o> swreg_lsc <1=>Secure
#define RTE_SWREG_LSC   1
// <o> swreg_aon <1=>Secure
#define RTE_SWREG_AON   1
// <o> ppc <1=>Secure
#define RTE_PPC         1
// <o> mpc <1=>Secure
#define RTE_MPC         1
// <o> pmu <1=>Secure
#define RTE_PMU         1

// <e> uart
// <i> IP_uart
#define RTE_IP_uart             1
// <o> UART0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_UART0       2
// <o> UART1 <0=>None <1=>Secure <2=>Non-secure
#define RTE_UART1       0
// <o> UART2 <0=>None <1=>Secure <2=>Non-secure
#define RTE_UART2       0
// </e> uart

// <e> timer
// <i> IP_timer
#define RTE_IP_timer            1
// <o> TIMER0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER0      2
// <o> TIMER1 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER1      2
// <o> TIMER2 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER2      1
// <o> TIMER3 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER3      1
// <o> TIMER4 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER4      0
// <o> TIMER5 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER5      0
// <o> TIMER6 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER6      2
// <o> TIMER7 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER7      0
// <o> TIMER8 <0=>None <1=>Secure <2=>Non-secure
#define RTE_TIMER8      0
// </e> timer

// <e> gpio
// <i> IP_gpio
#define RTE_IP_gpio             0
// <o> GPIO_G0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_GPIO_G0     0
// <o> GPIO_G1 <0=>None <1=>Secure <2=>Non-secure
#define RTE_GPIO_G1     0
// <o> GPIO_G2 <0=>None <1=>Secure <2=>Non-secure
#define RTE_GPIO_G2     0
// <o> GPIO_G3 <0=>None <1=>Secure <2=>Non-secure
#define RTE_GPIO_G3     0
// <o> SB_GPIO <0=>None <1=>Secure <2=>Non-secure
#define RTE_SB_GPIO     0
// <o> AON_GPIO <0=>None <1=>Secure <2=>Non-secure
#define RTE_AON_GPIO    0
// </e> gpio

// <e> spi
// <i> IP_spi
#define RTE_IP_spi             1
// <o> QSPI_HOST <0=>None <1=>Secure
#define RTE_QSPI_HOST    1
// <o> OSPI_HOST <0=>None <1=>Secure
#define RTE_OSPI_HOST    1
// <o> SSPI_HOST <0=>None <1=>Secure <2=>Non-secure
#define RTE_SSPI_HOST     0
// <o> SSPI_SLAVE <0=>None <1=>Secure <2=>Non-secure
#define RTE_SSPI_SLAVE    0
// </e> spi

// <e> iic
// <i> IP_iic
#define RTE_IP_iic              0
// <o> IIC_SLAVE0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_IIC_SLAVE0      0
// <o> IIC_SLAVE1 <0=>None <1=>Secure <2=>Non-secure
#define RTE_IIC_SLAVE1      0
// <o> IIC_HOST_SENSOR <0=>None <1=>Secure <2=>Non-secure
#define RTE_IIC_HOST_SENSOR 0
// <o> IIC_HOST <0=>None <1=>Secure <2=>Non-secure
#define RTE_IIC_HOST        0
// </e> iic

// <e> i3c_slv
// <i> IP_i3c_slv
#define RTE_IP_i3c_slv              0
// <o> IIIC_SLAVE0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_IIIC_SLAVE0      0
// <o> IIIC_SLAVE0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_IIIC_SLAVE1      0
// </e> i3c_slv

// <e> i2s
// <i> IP_i2s
#define RTE_IP_i2s             0
// <o> I2S_HOST <0=>None <1=>Secure <2=>Non-secure
#define RTE_I2S_HOST       0
// <o> I2S_SLAV <0=>None <1=>Secure <2=>Non-secure
#define RTE_I2S_SLAVE      0
// </e> i2s

// <e> pwm
// <i> IP_pwm
#define RTE_IP_pwm             0
// <o> Secure Status <1=>Secure <2=>Non-secure
#define RTE_PWM        2
// <o> PWM0 <0=>None <1=>Instance
#define RTE_PWM0_INST      0
// <o> PWM2 <0=>None <1=>Instance
#define RTE_PWM1_INST      0
// <o> PWM2 <0=>None <1=>Instance
#define RTE_PWM2_INST      0
// </e> pwm

// <e> rtc
// <i> IP_rtc
#define RTE_IP_rtc             1
// <o> RTC0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_RTC0      0
// <o> RTC1 <0=>None <1=>Secure <2=>Non-secure
#define RTE_RTC1      0
// <o> RTC2 <0=>None <1=>Secure <2=>Non-secure
#define RTE_RTC2      0
// </e> rtc

// <e> watchdog
// <i> IP_watchdog
#define RTE_IP_watchdog             0
// <o> WDT0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_WDT0      0
// <o> WDT1 <0=>None <1=>Secure <2=>Non-secure
#define RTE_WDT1      0
// </e> watchdog

// <e> dma
// <i> IP_dma
#define RTE_IP_dma             1
// <o> DMA0 <0=>None <1=>Secure <2=>Non-secure
#define RTE_DMA0       0
// <o> DMA1 <0=>None <1=>Secure
#define RTE_DMA1       1
// <o> DMA2 <0=>None <1=>Secure <2=>Non-secure
#define RTE_DMA2       0
// <o> DMA3 <0=>None <1=>Secure <2=>Non-secure
#define RTE_DMA3       2
// </e> dma

// <e> vad
// <i> IP_vad
#define RTE_IP_vad             0
// <o> vad <1=>Secure <2=>Non-secure
#define RTE_vad      2
// </e> vad

// <e> sensorctrl
// <i> IP_sensorctrl
#define RTE_IP_sensorctrl             0
// <o> sensorctrl <1=>Secure <2=>Non-secure
#define RTE_sensorctrl      2
// </e> sensorctrl

// <e> hxautoi2c_mst
// <i> IP_hxautoi2c_mst
#define RTE_IP_hxautoi2c_mst             0
// <o> hxautoi2c_mst <1=>Secure <2=>Non-secure
#define RTE_hxautoi2c_mst      2
// </e> hxautoi2c_mst

// <e> csirx
// <i> IP_csirx
#define RTE_IP_csirx             0
// <o> csirx <1=>Secure <2=>Non-secure
#define RTE_csirx      2
// </e> csirx

// <e> csitx
// <i> IP_csitx
#define RTE_IP_csitx             0
// <o> csitx <1=>Secure <2=>Non-secure
#define RTE_csitx      2
// </e> csitx

// <e> dp
// <i> IP_dp
#define RTE_IP_dp             0
// <o> dp <1=>Secure <2=>Non-secure
#define RTE_dp      2
// </e> dp

// <e> 2x2
// <i> IP_2x2
#define RTE_IP_2x2             0
// <o> 2x2 <1=>Secure <2=>Non-secure
#define RTE_2x2      2
// </e> 2x2

// <e> 5x5
// <i> IP_5x5
#define RTE_IP_5x5             0
// <o> 5x5 <1=>Secure <2=>Non-secure
#define RTE_5x5      2
// </e> 5x5

// <e> pdm
// <i> IP_pdm
#define RTE_IP_pdm             0
// <o> pdm <1=>Secure <2=>Non-secure
#define RTE_pdm      2
// </e> pdm

// <e> inp
// <i> IP_inp
#define RTE_IP_inp             0
// <o> inp <1=>Secure <2=>Non-secure
#define RTE_inp      2
// </e> inp

// <e> inp1bitparser
// <i> IP_inp1bitparser
#define RTE_IP_inp1bitparser             0
// <o> inp1bitparser <1=>Secure <2=>Non-secure
#define RTE_inp1bitparser      2
// </e> inp1bitparser

// <e> inpovparser
// <i> IP_inpovparser
#define RTE_IP_inpovparser             0
// <o> inpovparser <1=>Secure <2=>Non-secure
#define RTE_inpovparser      2
// </e> inpovparser

// <e> mb
// <i> IP_mb
#define RTE_IP_mb             0
// <o> mb <1=>Secure <2=>Non-secure
#define RTE_mb      2
// </e> mb

// <e> sdio
// <i> IP_sdio
#define RTE_IP_sdio             0
// <o> sdio <1=>Secure <2=>Non-secure
#define RTE_sdio      2
// </e> sdio

// <e> jpeg
// <i> IP_jpeg
#define RTE_IP_jpeg             0
// <o> jpeg <1=>Secure <2=>Non-secure
#define RTE_jpeg      2
// </e> jpeg

// <e> ts
// <i> IP_ts
#define RTE_IP_ts             0
// <o> ts <1=>Secure <2=>Non-secure
#define RTE_ts      2
// </e> ts

// <e> tpg
// <i> IP_tpg
#define RTE_IP_tpg             0
// <o> tpg <1=>Secure <2=>Non-secure
#define RTE_tpg      2
// </e> tpg

// <e> cdm
// <i> IP_cdm
#define RTE_IP_cdm            0
// <o> cdm <1=>Secure <2=>Non-secure
#define RTE_cdm      2
// </e> cdm

// <e> edm
// <i> IP_edm
#define RTE_IP_edm            0
// <o> edm <1=>Secure <2=>Non-secure
#define RTE_edm      2
// </e> edm

// <e> xdma
// <i> IP_xdma
#define RTE_IP_xdma            0
// <o> xdma <1=>Secure <2=>Non-secure
#define RTE_xdma      2
// </e> xdma

// <e> adcc
// <i> IP_adcc
#define RTE_IP_adcc            0
// <o> adcc <1=>Secure <2=>Non-secure
#define RTE_adcc      2
// </e> adcc

// <e> adcc_hv
// <i> IP_adcc_hv
#define RTE_IP_adcc_hv            0
// <o> adcc_hv <1=>Secure <2=>Non-secure
#define RTE_adcc_hv      2
// </e> adcc_hv

// <e> u55
// <i> IP_u55
#define RTE_IP_u55            0
// <o> u55 <1=>Secure <2=>Non-secure
#define RTE_u55      2
// </e> u55

// <<< end of configuration section >>>

// Convert to WE2 #define
#include "Config_WE2.h"
#include "Config_WE2_S.h"

#endif /* _RTE_DEVICE_H */
