#ifndef _CONFIG_WE2_TFM_H
#define _CONFIG_WE2_TFM_H

#define SYS_TEST_PSA_API_                          0
#define SYS_TEST_PSA_API_ON                        1
#define SYS_TEST_PSA_API_IPC                       2
#define SYS_TEST_PSA_API_CRYPTO                    3
#define SYS_TEST_PSA_API_INITIAL_ATTESTATION       4
#define SYS_TEST_PSA_API_INTERNAL_TRUSTED_STORAGE  5
#define SYS_TEST_PSA_API_PROTECTED_STORAGE         6
#define SYS_TEST_PSA_API_STORAGE                   7

#define SYS_TEST_PSA_API         SYS_TEST_PSA_API_

#if defined(CM55_SMALL)
#error "CM55_SMALL are defined"
#endif

#if defined(RTE_TFM_DOMAIN_S) && defined(RTE_TFM_DOMAIN_NS)
#error "RTE_DOMAIN_S and RTE_DOMAIN_NS are defined"
#endif

#if defined(RTE_TFM_LVL)
#if (RTE_TFM_LVL == 3)
#define SYS_TFM_ISOLATION_LEVEL 3
#elif (RTE_TFM_LVL == 2)
#define SYS_TFM_ISOLATION_LEVEL 2
#elif (RTE_TFM_LVL == 1)
#define SYS_TFM_ISOLATION_LEVEL 1
#else
#error "RTE_TFM_LVL must be 1, 2 or 3"
#endif
#endif

#if defined(RTE_TFM_NS_OS_WRAPPER)
#if (RTE_TFM_NS_OS_WRAPPER == 3)
#define TFM_NS_RTOS2_WRAPPER_BARE_METAL 1
#elif (RTE_TFM_NS_OS_WRAPPER == 2)
#define TFM_NS_RTOS2_WRAPPER_RTOS2_FREERTOS 1
#define freertos_10_5_1 1
#if !defined(ENABLE_OS)
#define ENABLE_OS 1
#endif
#elif (RTE_TFM_NS_OS_WRAPPER == 1)
#define TFM_NS_RTOS2_WRAPPER_RTOS2_RTX 1
#if !defined(ENABLE_OS)
#define ENABLE_OS 1
#endif
#else
#error "RTE_TFM_NS_OS_WRAPPER must be 1, 2 or 3"
#endif
#endif

#if defined(RTE_TFM_DOMAIN_NS)
#define BUILD_TFM_NS 1
#define DOMAIN_NS 1
#endif

#if defined(RTE_TFM_DOMAIN_S)
#define USE_SP_LOG 1
#define ENABLE_OS 1
#define CONFIG_TFM_SPM_BACKEND_IPC 1
#define CONFIG_TFM_SPM_BACKEND_SFN 0
#endif

#if defined(SYS_TFM_ISOLATION_LEVEL)
#if (SYS_TFM_ISOLATION_LEVEL == 3)
#define CONFIG_TFM_PSA_API_SUPERVISOR_CALL 1
#define CONFIG_TFM_PSA_API_CROSS_CALL 0
#define CONFIG_TFM_PSA_API_SFN_CALL 0
#elif (SYS_TFM_ISOLATION_LEVEL == 2)
#define CONFIG_TFM_PSA_API_SUPERVISOR_CALL 1
#define CONFIG_TFM_PSA_API_CROSS_CALL 0
#define CONFIG_TFM_PSA_API_SFN_CALL 0
#elif (SYS_TFM_ISOLATION_LEVEL == 1)
#define CONFIG_TFM_PSA_API_SUPERVISOR_CALL 0
#define CONFIG_TFM_PSA_API_CROSS_CALL 1
#define CONFIG_TFM_PSA_API_SFN_CALL 0
#endif
#endif

#define TFM_LVL   SYS_TFM_ISOLATION_LEVEL
#define TFM_PARTITION_HX_IRQS_DMA1_QSPI 1
//#define HX_LIB_SPIM_DMA_POLL_STATUS_NO_IRQ 1
//#define HX_LIB_SPI_EEPROM_BUFFER_POOL 1
#define HX_TFM   1
#define ATTEST_KEY_BITS 256
#define BL1_HEADER_SIZE 0x000
#define BL1_TRAILER_SIZE 0x000
#define BL2_HEADER_SIZE 0x000
#define BL2_TRAILER_SIZE 0x000
#define CC312_LEGACY_DRIVER_API_ENABLED 1
#define CC_IOT 1
#define CC_MNG_MIN_BACKUP_SIZE_IN_BYTES 512
#define CC_PAL_MAX_LOG_LEVEL 3
#define CC_SUPPORT_PKA_64_16 1
#define CC_TRNG_MODE 0
#define CONFIG_TFM_BUILDING_SPE 1
#define CONFIG_TFM_CONNECTION_BASED_SERVICE_API 1
#define CONFIG_TFM_ENABLE_CP10CP11 1
#define CONFIG_TFM_ENABLE_FP 1
//#define CONFIG_TFM_ENABLE_MEMORY_PROTECT 1
#if ((SYS_TEST_PSA_API == SYS_TEST_PSA_API_IPC) || (SYS_TFM_ISOLATION_LEVEL != 1))
#define CONFIG_TFM_ENABLE_MEMORY_PROTECT 1
#endif
#define CONFIG_TFM_ENABLE_MVE 1
#define CONFIG_TFM_ENABLE_MVE_FP 1
#define CONFIG_TFM_FLIH_API 1
#define CONFIG_TFM_FLOAT_ABI 2
#define CONFIG_TFM_HALT_ON_CORE_PANIC 1
#define CONFIG_TFM_LAZY_STACKING 1
#define CONFIG_TFM_MMIO_REGION_ENABLE 1
#define CONFIG_TFM_PARTITION_META 1
#define CONFIG_TFM_SLIH_API 0
#define CONFIG_TFM_USE_TRUSTZONE 1
#define CRYPTO_HW_ACCELERATOR 1
#define CRYPTO_HW_ACCELERATOR_CC312 1
#define DAUTH_CHIP_DEFAULT 1
#define DLLI_MAX_BUFF_SIZE 0x10000
#define ENABLE_HEAP 1
#define IMPLEMENT_FLASH_DRV 1
#define MBEDTLS_CONFIG_FILE "tfm_mbedcrypto_config_profile_large.h"
#define MBEDTLS_ECDH_LEGACY_CONTEXT 1
#define MBEDTLS_PSA_CRYPTO_BUILTIN_KEYS 1
#define MBEDTLS_PSA_CRYPTO_CONFIG_FILE "crypto_config_profile_large.h"
#define MBEDTLS_PSA_CRYPTO_DRIVERS 1
#define MCUBOOT_ 1
#define OTP_WRITEABLE 1
#define PLATFORM_DEFAULT_BL1 1
#define PLATFORM_DEFAULT_CRYPTO_KEYS 1
#define PLATFORM_DEFAULT_NV_COUNTERS 1
#define PLATFORM_DEFAULT_NV_SEED 1
#define PLATFORM_DEFAULT_OTP 1
#define PLATFORM_DEFAULT_UART_STDOUT 1
#define PLATFORM_FLIH_IRQ_TEST_SUPPORT 1
#define PLATFORM_NS_NV_COUNTERS 0
#define PLATFORM_SLIH_IRQ_TEST_SUPPORT 1
#define PROJECT_CONFIG_HEADER_FILE "config_profile_large.h"
#define PSA_API_TEST_ 1
#define PSA_CRYPTO_DRIVER_TFM_BUILTIN_KEY_LOADER 1
#define PSA_CRYPTO_SECURE 1
#define PSA_FRAMEWORK_HAS_MM_IOVEC 0
#define PSA_FRAMEWORK_ISOLATION_LEVEL SYS_TFM_ISOLATION_LEVEL
#define PS_CRYPTO_AEAD_ALG PSA_ALG_CCM
#define PS_CRYPTO_AEAD_ALG_CCM 1
#define PS_ENCRYPTION 1
#define QCBOR_DISABLE_FLOAT_HW_USE 1
#define QCBOR_DISABLE_PREFERRED_FLOAT 1
#define TFM_CORE_DEBUG 1
#define TFM_DUMMY_PROVISIONING 1
#define TFM_EXCEPTION_INFO_DUMP 1
#define TFM_FIH_PROFILE_OFF 1
#define TFM_PARTITION_CRYPTO 1
#define TFM_PARTITION_HX 1
#define TFM_PARTITION_INITIAL_ATTESTATION 1
#define TFM_PARTITION_INTERNAL_TRUSTED_STORAGE 1
#define TFM_PARTITION_LOG_LEVEL TFM_PARTITION_LOG_LEVEL_DEBUG
#define TFM_PARTITION_NS_AGENT_TZ 1
#define TFM_PARTITION_PLATFORM 1
#define TFM_PARTITION_PROTECTED_STORAGE 1
#define TFM_SPM_LOG_LEVEL TFM_SPM_LOG_LEVEL_DEBUG
#define TFM_SPM_LOG_RAW_ENABLED 1
#define TFM_SP_LOG_RAW_ENABLED 1
#define T_COSE_COMPILE_TIME_CONFIG 1
#define T_COSE_DISABLE_CONTENT_TYPE 1
#define T_COSE_DISABLE_ES384 1
#define T_COSE_DISABLE_ES512 1
#define T_COSE_DISABLE_MAC0 1
#define T_COSE_DISABLE_SHORT_CIRCUIT_SIGN 1
#define T_COSE_DISABLE_SIGN_VERIFY_TESTS 1
#define T_COSE_USE_PSA_CRYPTO 1
#define T_COSE_USE_PSA_CRYPTO_FROM_TFM 1
#define USEFULBUF_DISABLE_ALL_FLOAT 1
#define USE_MBEDTLS_CRYPTOCELL 1


#if defined(RTE_TFM_S_NS_TEST)
#define PS_TEST_NV_COUNTERS 1
#define TEST_FRAMEWORK_S 1
#define TEST_S_ATTESTATION 1
#define TEST_S_CRYPTO 1
#define TEST_S_IPC 1
#define TEST_S_ITS 1
#define TEST_S_PLATFORM 1
#define TEST_S_PS 1
#define TEST_FRAMEWORK_NS 1
#define TEST_NS_ATTESTATION 1
#define TEST_NS_CRYPTO 1
#define TEST_NS_FLIH_IRQ 1
#define TEST_NS_IPC 1
#define TEST_NS_ITS 1
#define TEST_NS_PLATFORM 1
#define TEST_NS_PS 1
#define TEST_NS_QCBOR 1
#define TEST_NS_T_COSE 1
#define TFM_CRYPTO_TEST_ALG_CBC 1
#define TFM_CRYPTO_TEST_ALG_CCM 1
#define TFM_CRYPTO_TEST_ALG_GCM 1
#define TFM_CRYPTO_TEST_ALG_SHA_512 1
#define TFM_CRYPTO_TEST_ECDH 1
#define TFM_CRYPTO_TEST_HKDF 1
#define TFM_CRYPTO_TEST_SINGLE_PART_FUNCS 1
//#define TFM_IPC_ISOLATION_3_RETRIEVE_APP_MEM 1
#if (RTE_TFM_LVL == 3)
#define TFM_IPC_ISOLATION_3_RETRIEVE_APP_MEM 1
#endif
#define TFM_PARTITION_IPC_TEST 1
#define TFM_PARTITION_TEST_CORE_IPC 1
#define TFM_PARTITION_TEST_PS 1
#define TFM_PARTITION_TEST_SECURE_SERVICES 1

#endif

////////////////////////////////////////////////////////////

#endif /* _CONFIG_WE2_TFM_H */
